<?xml version="1.0" encoding="UTF-8"?>
<model ref="r:9b4a89e1-ec38-42c4-b1bd-96ab47ffcb3f(jetbrains.mps.vcs.diff.changes)">
  <persistence version="9" />
  <languages>
    <use id="774bf8a0-62e5-41e1-af63-f4812e60e48b" name="jetbrains.mps.baseLanguage.checkedDots" version="0" />
    <use id="fd392034-7849-419d-9071-12563d152375" name="jetbrains.mps.baseLanguage.closures" version="0" />
    <use id="83888646-71ce-4f1c-9c53-c54016f6ad4f" name="jetbrains.mps.baseLanguage.collections" version="0" />
    <use id="7866978e-a0f0-4cc7-81bc-4d213d9375e1" name="jetbrains.mps.lang.smodel" version="8" />
    <use id="f3061a53-9226-4cc5-a443-f952ceaf5816" name="jetbrains.mps.baseLanguage" version="5" />
  </languages>
  <imports>
    <import index="wyt6" ref="6354ebe7-c22a-4a0f-ac54-50b52ab9b065/java:java.lang(JDK/)" />
    <import index="33ny" ref="6354ebe7-c22a-4a0f-ac54-50b52ab9b065/java:java.util(JDK/)" />
    <import index="bfxj" ref="r:5744ed46-c83f-47cd-94ce-f24d1f92d6a1(jetbrains.mps.vcs.diff)" />
    <import index="w1kc" ref="6ed54515-acc8-4d1e-a16c-9fd6cfe951ea/java:jetbrains.mps.smodel(MPS.Core/)" />
    <import index="18ew" ref="6ed54515-acc8-4d1e-a16c-9fd6cfe951ea/java:jetbrains.mps.util(MPS.Core/)" />
    <import index="mhbf" ref="8865b7a8-5271-43d3-884c-6fd1d9cfdd34/java:org.jetbrains.mps.openapi.model(MPS.OpenAPI/)" />
    <import index="mhfm" ref="3f233e7f-b8a6-46d2-a57f-795d56775243/java:org.jetbrains.annotations(Annotations/)" />
    <import index="lui2" ref="8865b7a8-5271-43d3-884c-6fd1d9cfdd34/java:org.jetbrains.mps.openapi.module(MPS.OpenAPI/)" />
    <import index="4szu" ref="6ed54515-acc8-4d1e-a16c-9fd6cfe951ea/java:jetbrains.mps.smodel.references(MPS.Core/)" />
    <import index="g3l6" ref="6ed54515-acc8-4d1e-a16c-9fd6cfe951ea/java:jetbrains.mps.extapi.model(MPS.Core/)" />
    <import index="6p" ref="r:134c8eea-8ea6-4b50-ba87-7cf1b28ce5ba(jetbrains.mps.vcs.mergehints.structure)" />
    <import index="c17a" ref="8865b7a8-5271-43d3-884c-6fd1d9cfdd34/java:org.jetbrains.mps.openapi.language(MPS.OpenAPI/)" />
    <import index="tpce" ref="r:00000000-0000-4000-0000-011c89590292(jetbrains.mps.lang.structure.structure)" implicit="true" />
  </imports>
  <registry>
    <language id="f3061a53-9226-4cc5-a443-f952ceaf5816" name="jetbrains.mps.baseLanguage">
      <concept id="1080223426719" name="jetbrains.mps.baseLanguage.structure.OrExpression" flags="nn" index="22lmx$" />
      <concept id="1082485599095" name="jetbrains.mps.baseLanguage.structure.BlockStatement" flags="nn" index="9aQIb">
        <child id="1082485599096" name="statements" index="9aQI4" />
      </concept>
      <concept id="1215693861676" name="jetbrains.mps.baseLanguage.structure.BaseAssignmentExpression" flags="nn" index="d038R">
        <child id="1068498886297" name="rValue" index="37vLTx" />
        <child id="1068498886295" name="lValue" index="37vLTJ" />
      </concept>
      <concept id="4836112446988635817" name="jetbrains.mps.baseLanguage.structure.UndefinedType" flags="in" index="2jxLKc" />
      <concept id="1202948039474" name="jetbrains.mps.baseLanguage.structure.InstanceMethodCallOperation" flags="nn" index="liA8E" />
      <concept id="1465982738277781862" name="jetbrains.mps.baseLanguage.structure.PlaceholderMember" flags="ng" index="2tJIrI" />
      <concept id="1239714755177" name="jetbrains.mps.baseLanguage.structure.AbstractUnaryNumberOperation" flags="nn" index="2$Kvd9">
        <child id="1239714902950" name="expression" index="2$L3a6" />
      </concept>
      <concept id="1188207840427" name="jetbrains.mps.baseLanguage.structure.AnnotationInstance" flags="nn" index="2AHcQZ">
        <reference id="1188208074048" name="annotation" index="2AI5Lk" />
      </concept>
      <concept id="1188208481402" name="jetbrains.mps.baseLanguage.structure.HasAnnotation" flags="ng" index="2AJDlI">
        <child id="1188208488637" name="annotation" index="2AJF6D" />
      </concept>
      <concept id="1153952380246" name="jetbrains.mps.baseLanguage.structure.TryStatement" flags="nn" index="2GUZhq">
        <child id="1153952416686" name="body" index="2GV8ay" />
        <child id="1153952429843" name="finallyBody" index="2GVbov" />
      </concept>
      <concept id="1224848483129" name="jetbrains.mps.baseLanguage.structure.IBLDeprecatable" flags="ng" index="IEa8$">
        <property id="1224848525476" name="isDeprecated" index="IEkAT" />
      </concept>
      <concept id="1154032098014" name="jetbrains.mps.baseLanguage.structure.AbstractLoopStatement" flags="nn" index="2LF5Ji">
        <child id="1154032183016" name="body" index="2LFqv$" />
      </concept>
      <concept id="1177666668936" name="jetbrains.mps.baseLanguage.structure.DoWhileStatement" flags="nn" index="MpOyq">
        <child id="1177666688034" name="condition" index="MpTkK" />
      </concept>
      <concept id="1197027756228" name="jetbrains.mps.baseLanguage.structure.DotExpression" flags="nn" index="2OqwBi">
        <child id="1197027771414" name="operand" index="2Oq$k0" />
        <child id="1197027833540" name="operation" index="2OqNvi" />
      </concept>
      <concept id="1197029447546" name="jetbrains.mps.baseLanguage.structure.FieldReferenceOperation" flags="nn" index="2OwXpG">
        <reference id="1197029500499" name="fieldDeclaration" index="2Oxat5" />
      </concept>
      <concept id="1083245097125" name="jetbrains.mps.baseLanguage.structure.EnumClass" flags="ig" index="Qs71p">
        <child id="1083245396908" name="enumConstant" index="Qtgdg" />
      </concept>
      <concept id="1083245299891" name="jetbrains.mps.baseLanguage.structure.EnumConstantDeclaration" flags="ig" index="QsSxf" />
      <concept id="1083260308424" name="jetbrains.mps.baseLanguage.structure.EnumConstantReference" flags="nn" index="Rm8GO">
        <reference id="1083260308426" name="enumConstantDeclaration" index="Rm8GQ" />
        <reference id="1144432896254" name="enumClass" index="1Px2BO" />
      </concept>
      <concept id="1145552977093" name="jetbrains.mps.baseLanguage.structure.GenericNewExpression" flags="nn" index="2ShNRf">
        <child id="1145553007750" name="creator" index="2ShVmc" />
      </concept>
      <concept id="1070475354124" name="jetbrains.mps.baseLanguage.structure.ThisExpression" flags="nn" index="Xjq3P" />
      <concept id="1070475587102" name="jetbrains.mps.baseLanguage.structure.SuperConstructorInvocation" flags="nn" index="XkiVB" />
      <concept id="1070475926800" name="jetbrains.mps.baseLanguage.structure.StringLiteral" flags="nn" index="Xl_RD">
        <property id="1070475926801" name="value" index="Xl_RC" />
      </concept>
      <concept id="1081236700938" name="jetbrains.mps.baseLanguage.structure.StaticMethodDeclaration" flags="ig" index="2YIFZL" />
      <concept id="1081236700937" name="jetbrains.mps.baseLanguage.structure.StaticMethodCall" flags="nn" index="2YIFZM">
        <reference id="1144433194310" name="classConcept" index="1Pybhc" />
      </concept>
      <concept id="1081256982272" name="jetbrains.mps.baseLanguage.structure.InstanceOfExpression" flags="nn" index="2ZW3vV">
        <child id="1081256993305" name="classType" index="2ZW6by" />
        <child id="1081256993304" name="leftExpression" index="2ZW6bz" />
      </concept>
      <concept id="1070533707846" name="jetbrains.mps.baseLanguage.structure.StaticFieldReference" flags="nn" index="10M0yZ">
        <reference id="1144433057691" name="classifier" index="1PxDUh" />
      </concept>
      <concept id="1070534058343" name="jetbrains.mps.baseLanguage.structure.NullLiteral" flags="nn" index="10Nm6u" />
      <concept id="1070534370425" name="jetbrains.mps.baseLanguage.structure.IntegerType" flags="in" index="10Oyi0" />
      <concept id="1070534644030" name="jetbrains.mps.baseLanguage.structure.BooleanType" flags="in" index="10P_77" />
      <concept id="1070534934090" name="jetbrains.mps.baseLanguage.structure.CastExpression" flags="nn" index="10QFUN">
        <child id="1070534934091" name="type" index="10QFUM" />
        <child id="1070534934092" name="expression" index="10QFUP" />
      </concept>
      <concept id="1068390468200" name="jetbrains.mps.baseLanguage.structure.FieldDeclaration" flags="ig" index="312cEg">
        <property id="8606350594693632173" name="isTransient" index="eg7rD" />
        <property id="1240249534625" name="isVolatile" index="34CwA1" />
      </concept>
      <concept id="1068390468198" name="jetbrains.mps.baseLanguage.structure.ClassConcept" flags="ig" index="312cEu">
        <property id="1075300953594" name="abstractClass" index="1sVAO0" />
        <child id="1165602531693" name="superclass" index="1zkMxy" />
      </concept>
      <concept id="1068431474542" name="jetbrains.mps.baseLanguage.structure.VariableDeclaration" flags="ng" index="33uBYm">
        <property id="1176718929932" name="isFinal" index="3TUv4t" />
        <child id="1068431790190" name="initializer" index="33vP2m" />
      </concept>
      <concept id="1068498886296" name="jetbrains.mps.baseLanguage.structure.VariableReference" flags="nn" index="37vLTw">
        <reference id="1068581517664" name="variableDeclaration" index="3cqZAo" />
      </concept>
      <concept id="1068498886292" name="jetbrains.mps.baseLanguage.structure.ParameterDeclaration" flags="ir" index="37vLTG" />
      <concept id="1068498886294" name="jetbrains.mps.baseLanguage.structure.AssignmentExpression" flags="nn" index="37vLTI" />
      <concept id="1225271177708" name="jetbrains.mps.baseLanguage.structure.StringType" flags="in" index="17QB3L" />
      <concept id="1225271221393" name="jetbrains.mps.baseLanguage.structure.NPENotEqualsExpression" flags="nn" index="17QLQc" />
      <concept id="1225271283259" name="jetbrains.mps.baseLanguage.structure.NPEEqualsExpression" flags="nn" index="17R0WA" />
      <concept id="4972933694980447171" name="jetbrains.mps.baseLanguage.structure.BaseVariableDeclaration" flags="ng" index="19Szcq">
        <child id="5680397130376446158" name="type" index="1tU5fm" />
      </concept>
      <concept id="1068580123132" name="jetbrains.mps.baseLanguage.structure.BaseMethodDeclaration" flags="ng" index="3clF44">
        <property id="4276006055363816570" name="isSynchronized" index="od$2w" />
        <property id="1181808852946" name="isFinal" index="DiZV1" />
        <child id="1068580123133" name="returnType" index="3clF45" />
        <child id="1068580123134" name="parameter" index="3clF46" />
        <child id="1068580123135" name="body" index="3clF47" />
      </concept>
      <concept id="1068580123165" name="jetbrains.mps.baseLanguage.structure.InstanceMethodDeclaration" flags="ig" index="3clFb_">
        <property id="1178608670077" name="isAbstract" index="1EzhhJ" />
      </concept>
      <concept id="1068580123152" name="jetbrains.mps.baseLanguage.structure.EqualsExpression" flags="nn" index="3clFbC" />
      <concept id="1068580123155" name="jetbrains.mps.baseLanguage.structure.ExpressionStatement" flags="nn" index="3clFbF">
        <child id="1068580123156" name="expression" index="3clFbG" />
      </concept>
      <concept id="1068580123157" name="jetbrains.mps.baseLanguage.structure.Statement" flags="nn" index="3clFbH" />
      <concept id="1068580123159" name="jetbrains.mps.baseLanguage.structure.IfStatement" flags="nn" index="3clFbJ">
        <property id="4467513934994662257" name="forceMultiLine" index="TyiWK" />
        <property id="4467513934994662256" name="forceOneLine" index="TyiWL" />
        <child id="1082485599094" name="ifFalseStatement" index="9aQIa" />
        <child id="1068580123160" name="condition" index="3clFbw" />
        <child id="1068580123161" name="ifTrue" index="3clFbx" />
        <child id="1206060520071" name="elsifClauses" index="3eNLev" />
      </concept>
      <concept id="1068580123136" name="jetbrains.mps.baseLanguage.structure.StatementList" flags="sn" stub="5293379017992965193" index="3clFbS">
        <child id="1068581517665" name="statement" index="3cqZAp" />
      </concept>
      <concept id="1068580123137" name="jetbrains.mps.baseLanguage.structure.BooleanConstant" flags="nn" index="3clFbT">
        <property id="1068580123138" name="value" index="3clFbU" />
      </concept>
      <concept id="1068580123140" name="jetbrains.mps.baseLanguage.structure.ConstructorDeclaration" flags="ig" index="3clFbW" />
      <concept id="1068580320020" name="jetbrains.mps.baseLanguage.structure.IntegerConstant" flags="nn" index="3cmrfG">
        <property id="1068580320021" name="value" index="3cmrfH" />
      </concept>
      <concept id="1068581242875" name="jetbrains.mps.baseLanguage.structure.PlusExpression" flags="nn" index="3cpWs3" />
      <concept id="1068581242878" name="jetbrains.mps.baseLanguage.structure.ReturnStatement" flags="nn" index="3cpWs6">
        <child id="1068581517676" name="expression" index="3cqZAk" />
      </concept>
      <concept id="1068581242864" name="jetbrains.mps.baseLanguage.structure.LocalVariableDeclarationStatement" flags="nn" index="3cpWs8">
        <child id="1068581242865" name="localVariableDeclaration" index="3cpWs9" />
      </concept>
      <concept id="1068581242869" name="jetbrains.mps.baseLanguage.structure.MinusExpression" flags="nn" index="3cpWsd" />
      <concept id="1068581242863" name="jetbrains.mps.baseLanguage.structure.LocalVariableDeclaration" flags="nr" index="3cpWsn" />
      <concept id="1068581517677" name="jetbrains.mps.baseLanguage.structure.VoidType" flags="in" index="3cqZAl" />
      <concept id="1206060495898" name="jetbrains.mps.baseLanguage.structure.ElsifClause" flags="ng" index="3eNFk2">
        <child id="1206060619838" name="condition" index="3eO9$A" />
        <child id="1206060644605" name="statementList" index="3eOfB_" />
      </concept>
      <concept id="1079359253375" name="jetbrains.mps.baseLanguage.structure.ParenthesizedExpression" flags="nn" index="1eOMI4">
        <child id="1079359253376" name="expression" index="1eOMHV" />
      </concept>
      <concept id="1081506773034" name="jetbrains.mps.baseLanguage.structure.LessThanExpression" flags="nn" index="3eOVzh" />
      <concept id="1081516740877" name="jetbrains.mps.baseLanguage.structure.NotExpression" flags="nn" index="3fqX7Q">
        <child id="1081516765348" name="expression" index="3fr31v" />
      </concept>
      <concept id="1160998861373" name="jetbrains.mps.baseLanguage.structure.AssertStatement" flags="nn" index="1gVbGN">
        <child id="1160998896846" name="condition" index="1gVkn0" />
      </concept>
      <concept id="1204053956946" name="jetbrains.mps.baseLanguage.structure.IMethodCall" flags="ng" index="1ndlxa">
        <reference id="1068499141037" name="baseMethodDeclaration" index="37wK5l" />
        <child id="1068499141038" name="actualArgument" index="37wK5m" />
      </concept>
      <concept id="1073063089578" name="jetbrains.mps.baseLanguage.structure.SuperMethodCall" flags="nn" index="3nyPlj" />
      <concept id="1212685548494" name="jetbrains.mps.baseLanguage.structure.ClassCreator" flags="nn" index="1pGfFk" />
      <concept id="1107461130800" name="jetbrains.mps.baseLanguage.structure.Classifier" flags="ng" index="3pOWGL">
        <property id="521412098689998745" name="nonStatic" index="2bfB8j" />
        <child id="5375687026011219971" name="member" index="jymVt" unordered="true" />
      </concept>
      <concept id="1171903916106" name="jetbrains.mps.baseLanguage.structure.UpperBoundType" flags="in" index="3qUE_q">
        <child id="1171903916107" name="bound" index="3qUE_r" />
      </concept>
      <concept id="7812454656619025416" name="jetbrains.mps.baseLanguage.structure.MethodDeclaration" flags="ng" index="1rXfSm">
        <property id="8355037393041754995" name="isNative" index="2aFKle" />
      </concept>
      <concept id="7812454656619025412" name="jetbrains.mps.baseLanguage.structure.LocalMethodCall" flags="nn" index="1rXfSq" />
      <concept id="1107535904670" name="jetbrains.mps.baseLanguage.structure.ClassifierType" flags="in" index="3uibUv">
        <reference id="1107535924139" name="classifier" index="3uigEE" />
        <child id="1109201940907" name="parameter" index="11_B2D" />
      </concept>
      <concept id="1081773326031" name="jetbrains.mps.baseLanguage.structure.BinaryOperation" flags="nn" index="3uHJSO">
        <child id="1081773367579" name="rightExpression" index="3uHU7w" />
        <child id="1081773367580" name="leftExpression" index="3uHU7B" />
      </concept>
      <concept id="1214918800624" name="jetbrains.mps.baseLanguage.structure.PostfixIncrementExpression" flags="nn" index="3uNrnE" />
      <concept id="1073239437375" name="jetbrains.mps.baseLanguage.structure.NotEqualsExpression" flags="nn" index="3y3z36" />
      <concept id="1178549954367" name="jetbrains.mps.baseLanguage.structure.IVisible" flags="ng" index="1B3ioH">
        <child id="1178549979242" name="visibility" index="1B3o_S" />
      </concept>
      <concept id="1144230876926" name="jetbrains.mps.baseLanguage.structure.AbstractForStatement" flags="nn" index="1DupvO">
        <child id="1144230900587" name="variable" index="1Duv9x" />
      </concept>
      <concept id="1144231330558" name="jetbrains.mps.baseLanguage.structure.ForStatement" flags="nn" index="1Dw8fO">
        <child id="1144231399730" name="condition" index="1Dwp0S" />
        <child id="1144231408325" name="iteration" index="1Dwrff" />
      </concept>
      <concept id="1163668896201" name="jetbrains.mps.baseLanguage.structure.TernaryOperatorExpression" flags="nn" index="3K4zz7">
        <child id="1163668914799" name="condition" index="3K4Cdx" />
        <child id="1163668922816" name="ifTrue" index="3K4E3e" />
        <child id="1163668934364" name="ifFalse" index="3K4GZi" />
      </concept>
      <concept id="1082113931046" name="jetbrains.mps.baseLanguage.structure.ContinueStatement" flags="nn" index="3N13vt" />
      <concept id="6329021646629104957" name="jetbrains.mps.baseLanguage.structure.TextCommentPart" flags="nn" index="3SKdUq">
        <property id="6329021646629104958" name="text" index="3SKdUp" />
      </concept>
      <concept id="6329021646629104954" name="jetbrains.mps.baseLanguage.structure.SingleLineComment" flags="nn" index="3SKdUt">
        <child id="6329021646629175155" name="commentPart" index="3SKWNk" />
      </concept>
      <concept id="1146644602865" name="jetbrains.mps.baseLanguage.structure.PublicVisibility" flags="nn" index="3Tm1VV" />
      <concept id="1146644623116" name="jetbrains.mps.baseLanguage.structure.PrivateVisibility" flags="nn" index="3Tm6S6" />
      <concept id="1146644641414" name="jetbrains.mps.baseLanguage.structure.ProtectedVisibility" flags="nn" index="3Tmbuc" />
      <concept id="1080120340718" name="jetbrains.mps.baseLanguage.structure.AndExpression" flags="nn" index="1Wc70l" />
    </language>
    <language id="774bf8a0-62e5-41e1-af63-f4812e60e48b" name="jetbrains.mps.baseLanguage.checkedDots">
      <concept id="4079382982702596667" name="jetbrains.mps.baseLanguage.checkedDots.structure.CheckedDotExpression" flags="nn" index="2EnYce" />
    </language>
    <language id="fd392034-7849-419d-9071-12563d152375" name="jetbrains.mps.baseLanguage.closures">
      <concept id="1235746970280" name="jetbrains.mps.baseLanguage.closures.structure.CompactInvokeFunctionExpression" flags="nn" index="2Sg_IR">
        <child id="1235746996653" name="function" index="2SgG2M" />
        <child id="1235747002942" name="parameter" index="2SgHGx" />
      </concept>
      <concept id="1199542442495" name="jetbrains.mps.baseLanguage.closures.structure.FunctionType" flags="in" index="1ajhzC">
        <child id="1199542457201" name="resultType" index="1ajl9A" />
        <child id="1199542501692" name="parameterType" index="1ajw0F" />
      </concept>
      <concept id="1199569711397" name="jetbrains.mps.baseLanguage.closures.structure.ClosureLiteral" flags="nn" index="1bVj0M">
        <child id="1199569906740" name="parameter" index="1bW2Oz" />
        <child id="1199569916463" name="body" index="1bW5cS" />
      </concept>
    </language>
    <language id="7866978e-a0f0-4cc7-81bc-4d213d9375e1" name="jetbrains.mps.lang.smodel">
      <concept id="1177026924588" name="jetbrains.mps.lang.smodel.structure.RefConcept_Reference" flags="nn" index="chp4Y">
        <reference id="1177026940964" name="conceptDeclaration" index="cht4Q" />
      </concept>
      <concept id="1138411891628" name="jetbrains.mps.lang.smodel.structure.SNodeOperation" flags="nn" index="eCIE_">
        <child id="1144104376918" name="parameter" index="1xVPHs" />
      </concept>
      <concept id="2396822768958367367" name="jetbrains.mps.lang.smodel.structure.AbstractTypeCastExpression" flags="nn" index="$5XWr">
        <child id="6733348108486823193" name="leftExpression" index="1m5AlR" />
        <child id="3906496115198199033" name="conceptArgument" index="3oSUPX" />
      </concept>
      <concept id="1143226024141" name="jetbrains.mps.lang.smodel.structure.SModelType" flags="in" index="H_c77" />
      <concept id="1143234257716" name="jetbrains.mps.lang.smodel.structure.Node_GetModelOperation" flags="nn" index="I4A8Y" />
      <concept id="1145404486709" name="jetbrains.mps.lang.smodel.structure.SemanticDowncastExpression" flags="nn" index="2JrnkZ">
        <child id="1145404616321" name="leftExpression" index="2JrQYb" />
      </concept>
      <concept id="1171305280644" name="jetbrains.mps.lang.smodel.structure.Node_GetDescendantsOperation" flags="nn" index="2Rf3mk" />
      <concept id="1171310072040" name="jetbrains.mps.lang.smodel.structure.Node_GetContainingRootOperation" flags="nn" index="2Rxl7S" />
      <concept id="1139613262185" name="jetbrains.mps.lang.smodel.structure.Node_GetParentOperation" flags="nn" index="1mfA1w" />
      <concept id="1171999116870" name="jetbrains.mps.lang.smodel.structure.Node_IsNullOperation" flags="nn" index="3w_OXm" />
      <concept id="1172008320231" name="jetbrains.mps.lang.smodel.structure.Node_IsNotNullOperation" flags="nn" index="3x8VRR" />
      <concept id="1144100932627" name="jetbrains.mps.lang.smodel.structure.OperationParm_Inclusion" flags="ng" index="1xIGOp" />
      <concept id="1206482823744" name="jetbrains.mps.lang.smodel.structure.Model_AddRootOperation" flags="nn" index="3BYIHo">
        <child id="1206482823746" name="nodeArgument" index="3BYIHq" />
      </concept>
      <concept id="6407023681583036853" name="jetbrains.mps.lang.smodel.structure.NodeAttributeQualifier" flags="ng" index="3CFYIy">
        <reference id="6407023681583036854" name="attributeConcept" index="3CFYIx" />
      </concept>
      <concept id="6407023681583031218" name="jetbrains.mps.lang.smodel.structure.AttributeAccess" flags="nn" index="3CFZ6_">
        <child id="6407023681583036852" name="qualifier" index="3CFYIz" />
      </concept>
      <concept id="1172323065820" name="jetbrains.mps.lang.smodel.structure.Node_GetConceptOperation" flags="nn" index="3NT_Vc" />
      <concept id="1140131837776" name="jetbrains.mps.lang.smodel.structure.Node_ReplaceWithAnotherOperation" flags="nn" index="1P9Npp">
        <child id="1140131861877" name="replacementNode" index="1P9ThW" />
      </concept>
      <concept id="1140137987495" name="jetbrains.mps.lang.smodel.structure.SNodeTypeCastExpression" flags="nn" index="1PxgMI">
        <property id="1238684351431" name="asCast" index="1BlNFB" />
      </concept>
      <concept id="1138055754698" name="jetbrains.mps.lang.smodel.structure.SNodeType" flags="in" index="3Tqbb2">
        <reference id="1138405853777" name="concept" index="ehGHo" />
      </concept>
      <concept id="1172420572800" name="jetbrains.mps.lang.smodel.structure.ConceptNodeType" flags="in" index="3THzug" />
      <concept id="1228341669568" name="jetbrains.mps.lang.smodel.structure.Node_DetachOperation" flags="nn" index="3YRAZt" />
    </language>
    <language id="ceab5195-25ea-4f22-9b92-103b95ca8c0c" name="jetbrains.mps.lang.core">
      <concept id="1133920641626" name="jetbrains.mps.lang.core.structure.BaseConcept" flags="ng" index="2VYdi">
        <property id="1193676396447" name="virtualPackage" index="3GE5qa" />
      </concept>
      <concept id="1169194658468" name="jetbrains.mps.lang.core.structure.INamedConcept" flags="ng" index="TrEIO">
        <property id="1169194664001" name="name" index="TrG5h" />
      </concept>
    </language>
    <language id="83888646-71ce-4f1c-9c53-c54016f6ad4f" name="jetbrains.mps.baseLanguage.collections">
      <concept id="1204796164442" name="jetbrains.mps.baseLanguage.collections.structure.InternalSequenceOperation" flags="nn" index="23sCx2">
        <child id="1204796294226" name="closure" index="23t8la" />
      </concept>
      <concept id="540871147943773365" name="jetbrains.mps.baseLanguage.collections.structure.SingleArgumentSequenceOperation" flags="nn" index="25WWJ4">
        <child id="540871147943773366" name="argument" index="25WWJ7" />
      </concept>
      <concept id="1172667724288" name="jetbrains.mps.baseLanguage.collections.structure.PageOperation" flags="nn" index="8snch">
        <child id="1172667737868" name="fromElement" index="8sqot" />
        <child id="1172667748353" name="toElement" index="8st4g" />
      </concept>
      <concept id="1204980550705" name="jetbrains.mps.baseLanguage.collections.structure.VisitAllOperation" flags="nn" index="2es0OD" />
      <concept id="1151688443754" name="jetbrains.mps.baseLanguage.collections.structure.ListType" flags="in" index="_YKpA">
        <child id="1151688676805" name="elementType" index="_ZDj9" />
      </concept>
      <concept id="1151689724996" name="jetbrains.mps.baseLanguage.collections.structure.SequenceType" flags="in" index="A3Dl8">
        <child id="1151689745422" name="elementType" index="A3Ik2" />
      </concept>
      <concept id="1153943597977" name="jetbrains.mps.baseLanguage.collections.structure.ForEachStatement" flags="nn" index="2Gpval">
        <child id="1153944400369" name="variable" index="2Gsz3X" />
        <child id="1153944424730" name="inputSequence" index="2GsD0m" />
      </concept>
      <concept id="1153944193378" name="jetbrains.mps.baseLanguage.collections.structure.ForEachVariable" flags="nr" index="2GrKxI" />
      <concept id="1153944233411" name="jetbrains.mps.baseLanguage.collections.structure.ForEachVariableReference" flags="nn" index="2GrUjf">
        <reference id="1153944258490" name="variable" index="2Gs0qQ" />
      </concept>
      <concept id="1235566554328" name="jetbrains.mps.baseLanguage.collections.structure.AnyOperation" flags="nn" index="2HwmR7" />
      <concept id="1235566831861" name="jetbrains.mps.baseLanguage.collections.structure.AllOperation" flags="nn" index="2HxqBE" />
      <concept id="1237721394592" name="jetbrains.mps.baseLanguage.collections.structure.AbstractContainerCreator" flags="nn" index="HWqM0">
        <child id="1237721435807" name="elementType" index="HW$YZ" />
      </concept>
      <concept id="1201306600024" name="jetbrains.mps.baseLanguage.collections.structure.ContainsKeyOperation" flags="nn" index="2Nt0df">
        <child id="1201654602639" name="key" index="38cxEo" />
      </concept>
      <concept id="1203518072036" name="jetbrains.mps.baseLanguage.collections.structure.SmartClosureParameterDeclaration" flags="ig" index="Rh6nW" />
      <concept id="1237909114519" name="jetbrains.mps.baseLanguage.collections.structure.GetValuesOperation" flags="nn" index="T8wYR" />
      <concept id="1160600644654" name="jetbrains.mps.baseLanguage.collections.structure.ListCreatorWithInit" flags="nn" index="Tc6Ow" />
      <concept id="1160612413312" name="jetbrains.mps.baseLanguage.collections.structure.AddElementOperation" flags="nn" index="TSZUe" />
      <concept id="1162935959151" name="jetbrains.mps.baseLanguage.collections.structure.GetSizeOperation" flags="nn" index="34oBXx" />
      <concept id="1201872418428" name="jetbrains.mps.baseLanguage.collections.structure.GetKeysOperation" flags="nn" index="3lbrtF" />
      <concept id="1197683403723" name="jetbrains.mps.baseLanguage.collections.structure.MapType" flags="in" index="3rvAFt">
        <child id="1197683466920" name="keyType" index="3rvQeY" />
        <child id="1197683475734" name="valueType" index="3rvSg0" />
      </concept>
      <concept id="1197686869805" name="jetbrains.mps.baseLanguage.collections.structure.HashMapCreator" flags="nn" index="3rGOSV">
        <child id="1562299158921034623" name="initSize" index="3lNPQL" />
        <child id="1197687026896" name="keyType" index="3rHrn6" />
        <child id="1197687035757" name="valueType" index="3rHtpV" />
      </concept>
      <concept id="1165525191778" name="jetbrains.mps.baseLanguage.collections.structure.GetFirstOperation" flags="nn" index="1uHKPH" />
      <concept id="1240687580870" name="jetbrains.mps.baseLanguage.collections.structure.JoinOperation" flags="nn" index="3uJxvA">
        <child id="1240687658305" name="delimiter" index="3uJOhx" />
      </concept>
      <concept id="1202128969694" name="jetbrains.mps.baseLanguage.collections.structure.SelectOperation" flags="nn" index="3$u5V9" />
      <concept id="1240824834947" name="jetbrains.mps.baseLanguage.collections.structure.ValueAccessOperation" flags="nn" index="3AV6Ez" />
      <concept id="1240825616499" name="jetbrains.mps.baseLanguage.collections.structure.KeyAccessOperation" flags="nn" index="3AY5_j" />
      <concept id="1197932370469" name="jetbrains.mps.baseLanguage.collections.structure.MapElement" flags="nn" index="3EllGN">
        <child id="1197932505799" name="map" index="3ElQJh" />
        <child id="1197932525128" name="key" index="3ElVtu" />
      </concept>
      <concept id="1176501494711" name="jetbrains.mps.baseLanguage.collections.structure.IsNotEmptyOperation" flags="nn" index="3GX2aA" />
    </language>
  </registry>
  <node concept="312cEu" id="7Dh0CRFZxgO">
    <property role="TrG5h" value="ModelChange" />
    <property role="1sVAO0" value="true" />
    <node concept="3Tm1VV" id="7Dh0CRFZxgP" role="1B3o_S" />
    <node concept="312cEg" id="5x0q8wkvS3H" role="jymVt">
      <property role="TrG5h" value="myChangeSet" />
      <node concept="3uibUv" id="3kRMfhMvhrq" role="1tU5fm">
        <ref role="3uigEE" to="bfxj:3kRMfhMv03j" resolve="ChangeSet" />
      </node>
      <node concept="3Tm6S6" id="5x0q8wkvS3I" role="1B3o_S" />
    </node>
    <node concept="312cEg" id="2WueYNNT$H8" role="jymVt">
      <property role="TrG5h" value="myOpposite" />
      <node concept="3Tm6S6" id="2WueYNNT$H9" role="1B3o_S" />
      <node concept="3uibUv" id="2WueYNNT$Hb" role="1tU5fm">
        <ref role="3uigEE" node="7Dh0CRFZxgO" resolve="ModelChange" />
      </node>
      <node concept="10Nm6u" id="2WueYNNT$Hd" role="33vP2m" />
    </node>
    <node concept="3clFbW" id="5x0q8wkvS3L" role="jymVt">
      <node concept="3cqZAl" id="5x0q8wkvS3M" role="3clF45" />
      <node concept="3Tmbuc" id="5x0q8wkvS43" role="1B3o_S" />
      <node concept="3clFbS" id="5x0q8wkvS3P" role="3clF47">
        <node concept="3clFbF" id="5x0q8wkvS3S" role="3cqZAp">
          <node concept="37vLTI" id="5x0q8wkvS3U" role="3clFbG">
            <node concept="37vLTw" id="2BHiRxeuQuG" role="37vLTJ">
              <ref role="3cqZAo" node="5x0q8wkvS3H" resolve="myChangeSet" />
            </node>
            <node concept="37vLTw" id="2BHiRxgha32" role="37vLTx">
              <ref role="3cqZAo" node="5x0q8wkvS3Q" resolve="changeSet" />
            </node>
          </node>
        </node>
      </node>
      <node concept="37vLTG" id="5x0q8wkvS3Q" role="3clF46">
        <property role="TrG5h" value="changeSet" />
        <node concept="3uibUv" id="3kRMfhMvhro" role="1tU5fm">
          <ref role="3uigEE" to="bfxj:3kRMfhMv03j" resolve="ChangeSet" />
        </node>
        <node concept="2AHcQZ" id="2W$ok$XXEZb" role="2AJF6D">
          <ref role="2AI5Lk" to="mhfm:~NotNull" resolve="NotNull" />
        </node>
      </node>
    </node>
    <node concept="3clFb_" id="5x0q8wkvS4u" role="jymVt">
      <property role="TrG5h" value="getChangeSet" />
      <property role="DiZV1" value="true" />
      <node concept="3uibUv" id="3kRMfhMvhrr" role="3clF45">
        <ref role="3uigEE" to="bfxj:3kRMfhMv03j" resolve="ChangeSet" />
      </node>
      <node concept="2AHcQZ" id="2W$ok$XXEZa" role="2AJF6D">
        <ref role="2AI5Lk" to="mhfm:~NotNull" resolve="NotNull" />
      </node>
      <node concept="3Tm1VV" id="5x0q8wkvS4w" role="1B3o_S" />
      <node concept="3clFbS" id="5x0q8wkvS4x" role="3clF47">
        <node concept="3clFbF" id="5x0q8wkvS4y" role="3cqZAp">
          <node concept="37vLTw" id="2BHiRxeumWM" role="3clFbG">
            <ref role="3cqZAo" node="5x0q8wkvS3H" resolve="myChangeSet" />
          </node>
        </node>
      </node>
    </node>
    <node concept="3clFb_" id="3RcDWS$m24_" role="jymVt">
      <property role="TrG5h" value="getRootId" />
      <node concept="3uibUv" id="3RcDWS$m24D" role="3clF45">
        <ref role="3uigEE" to="mhbf:~SNodeId" resolve="SNodeId" />
      </node>
      <node concept="3Tm1VV" id="3RcDWS$m24B" role="1B3o_S" />
      <node concept="3clFbS" id="3RcDWS$m24C" role="3clF47">
        <node concept="3clFbF" id="3RcDWS$m24F" role="3cqZAp">
          <node concept="10Nm6u" id="3RcDWS$m24G" role="3clFbG" />
        </node>
      </node>
      <node concept="2AHcQZ" id="3RcDWS$m24E" role="2AJF6D">
        <ref role="2AI5Lk" to="mhfm:~Nullable" resolve="Nullable" />
      </node>
    </node>
    <node concept="3clFb_" id="2W$ok$XX_PQ" role="jymVt">
      <property role="1EzhhJ" value="true" />
      <property role="TrG5h" value="apply" />
      <node concept="3cqZAl" id="2W$ok$XX_PR" role="3clF45" />
      <node concept="3Tm1VV" id="2W$ok$XX_PS" role="1B3o_S" />
      <node concept="3clFbS" id="2W$ok$XX_PT" role="3clF47" />
      <node concept="37vLTG" id="2W$ok$XXAjT" role="3clF46">
        <property role="TrG5h" value="model" />
        <node concept="H_c77" id="2W$ok$XXAjU" role="1tU5fm" />
        <node concept="2AHcQZ" id="2W$ok$XXEZd" role="2AJF6D">
          <ref role="2AI5Lk" to="mhfm:~NotNull" resolve="NotNull" />
        </node>
      </node>
      <node concept="37vLTG" id="4YYMSngGbjq" role="3clF46">
        <property role="TrG5h" value="nodeCopier" />
        <node concept="3uibUv" id="4YPlf0PK8wT" role="1tU5fm">
          <ref role="3uigEE" node="69abr3GmYnQ" resolve="NodeCopier" />
        </node>
        <node concept="2AHcQZ" id="4YYMSngGbjx" role="2AJF6D">
          <ref role="2AI5Lk" to="mhfm:~NotNull" resolve="NotNull" />
        </node>
      </node>
    </node>
    <node concept="3clFb_" id="2WueYNNT$jz" role="jymVt">
      <property role="1EzhhJ" value="false" />
      <property role="TrG5h" value="getOppositeChange" />
      <node concept="3uibUv" id="2WueYNNT$jC" role="3clF45">
        <ref role="3uigEE" node="7Dh0CRFZxgO" resolve="ModelChange" />
      </node>
      <node concept="3Tm1VV" id="2WueYNNT$j_" role="1B3o_S" />
      <node concept="3clFbS" id="2WueYNNT$jA" role="3clF47">
        <node concept="3clFbJ" id="2WueYNNT$Hk" role="3cqZAp">
          <node concept="3clFbS" id="2WueYNNT$Hl" role="3clFbx">
            <node concept="3clFbF" id="2WueYNNT$Ht" role="3cqZAp">
              <node concept="37vLTI" id="2WueYNNT$Hv" role="3clFbG">
                <node concept="1rXfSq" id="4hiugqyyYek" role="37vLTx">
                  <ref role="37wK5l" node="2WueYNNT$He" resolve="createOppositeChange" />
                </node>
                <node concept="37vLTw" id="2BHiRxeuyU5" role="37vLTJ">
                  <ref role="3cqZAo" node="2WueYNNT$H8" resolve="myOpposite" />
                </node>
              </node>
            </node>
            <node concept="3clFbF" id="2WueYNNT$H$" role="3cqZAp">
              <node concept="37vLTI" id="2WueYNNT$HF" role="3clFbG">
                <node concept="Xjq3P" id="2WueYNNT$HI" role="37vLTx" />
                <node concept="2OqwBi" id="2WueYNNT$HA" role="37vLTJ">
                  <node concept="37vLTw" id="2BHiRxeuQvm" role="2Oq$k0">
                    <ref role="3cqZAo" node="2WueYNNT$H8" resolve="myOpposite" />
                  </node>
                  <node concept="2OwXpG" id="2WueYNNT$HE" role="2OqNvi">
                    <ref role="2Oxat5" node="2WueYNNT$H8" resolve="myOpposite" />
                  </node>
                </node>
              </node>
            </node>
          </node>
          <node concept="3clFbC" id="2WueYNNT$Hp" role="3clFbw">
            <node concept="10Nm6u" id="2WueYNNT$Hs" role="3uHU7w" />
            <node concept="37vLTw" id="2BHiRxeumWd" role="3uHU7B">
              <ref role="3cqZAo" node="2WueYNNT$H8" resolve="myOpposite" />
            </node>
          </node>
        </node>
        <node concept="3cpWs6" id="2WueYNNT$HM" role="3cqZAp">
          <node concept="37vLTw" id="2BHiRxeungZ" role="3cqZAk">
            <ref role="3cqZAo" node="2WueYNNT$H8" resolve="myOpposite" />
          </node>
        </node>
      </node>
    </node>
    <node concept="3clFb_" id="2WueYNNT$He" role="jymVt">
      <property role="1EzhhJ" value="true" />
      <property role="TrG5h" value="createOppositeChange" />
      <node concept="3uibUv" id="2WueYNNT$Hj" role="3clF45">
        <ref role="3uigEE" node="7Dh0CRFZxgO" resolve="ModelChange" />
      </node>
      <node concept="3Tmbuc" id="2WueYNNT$Hi" role="1B3o_S" />
      <node concept="3clFbS" id="2WueYNNT$Hh" role="3clF47" />
      <node concept="2AHcQZ" id="5Gi8bfMdALC" role="2AJF6D">
        <ref role="2AI5Lk" to="mhfm:~NotNull" resolve="NotNull" />
      </node>
    </node>
    <node concept="3clFb_" id="7inhnIFBpIN" role="jymVt">
      <property role="1EzhhJ" value="true" />
      <property role="TrG5h" value="getType" />
      <node concept="3uibUv" id="7inhnIFBpIS" role="3clF45">
        <ref role="3uigEE" node="7inhnIFBpHM" resolve="ChangeType" />
      </node>
      <node concept="3Tm1VV" id="7inhnIFBpIP" role="1B3o_S" />
      <node concept="3clFbS" id="7inhnIFBpIQ" role="3clF47" />
      <node concept="2AHcQZ" id="5Gi8bfMdALB" role="2AJF6D">
        <ref role="2AI5Lk" to="mhfm:~NotNull" resolve="NotNull" />
      </node>
    </node>
    <node concept="3clFb_" id="3kU7_0wM0Wc" role="jymVt">
      <property role="TrG5h" value="isNonConflicting" />
      <node concept="10P_77" id="3kU7_0wM1CD" role="3clF45" />
      <node concept="3Tm1VV" id="3kU7_0wM0We" role="1B3o_S" />
      <node concept="3clFbS" id="3kU7_0wM0Wf" role="3clF47">
        <node concept="3SKdUt" id="3kU7_0wM2Hj" role="3cqZAp">
          <node concept="3SKdUq" id="3kU7_0wM2Jv" role="3SKWNk">
            <property role="3SKdUp" value="true - change can never conflict with other change and should be ignored if connected change exists (e.g. resolveInfo change)" />
          </node>
        </node>
        <node concept="3clFbF" id="7n1vgxs$Jt6" role="3cqZAp">
          <node concept="3y3z36" id="7n1vgxs$Kgg" role="3clFbG">
            <node concept="10Nm6u" id="7n1vgxs$Khd" role="3uHU7w" />
            <node concept="1rXfSq" id="7n1vgxs$Jt4" role="3uHU7B">
              <ref role="37wK5l" node="7n1vgxs$HuB" resolve="getMergeHint" />
            </node>
          </node>
        </node>
      </node>
    </node>
    <node concept="3clFb_" id="7n1vgxs$HuB" role="jymVt">
      <property role="1EzhhJ" value="false" />
      <property role="TrG5h" value="getMergeHint" />
      <property role="od$2w" value="false" />
      <property role="DiZV1" value="false" />
      <property role="2aFKle" value="false" />
      <node concept="3clFbS" id="7n1vgxs$HuE" role="3clF47">
        <node concept="3clFbF" id="7n1vgxs$IAU" role="3cqZAp">
          <node concept="10Nm6u" id="7n1vgxs$IAT" role="3clFbG" />
        </node>
      </node>
      <node concept="3Tm1VV" id="7n1vgxs$H8b" role="1B3o_S" />
      <node concept="3uibUv" id="7n1vgxs$ITn" role="3clF45">
        <ref role="3uigEE" to="mhbf:~SNodeReference" resolve="SNodeReference" />
      </node>
      <node concept="2AHcQZ" id="7n1vgxs$JaS" role="2AJF6D">
        <ref role="2AI5Lk" to="mhfm:~Nullable" resolve="Nullable" />
      </node>
    </node>
    <node concept="3clFb_" id="5Gi8bfMdBoE" role="jymVt">
      <property role="IEkAT" value="false" />
      <property role="1EzhhJ" value="true" />
      <property role="TrG5h" value="toString" />
      <property role="DiZV1" value="false" />
      <node concept="3Tm1VV" id="5Gi8bfMdBoF" role="1B3o_S" />
      <node concept="17QB3L" id="5Gi8bfMdBoL" role="3clF45" />
      <node concept="3clFbS" id="5Gi8bfMdBoH" role="3clF47" />
      <node concept="2AHcQZ" id="5Gi8bfMdBoI" role="2AJF6D">
        <ref role="2AI5Lk" to="wyt6:~Override" resolve="Override" />
      </node>
    </node>
    <node concept="3clFb_" id="51cMXQKR7zc" role="jymVt">
      <property role="1EzhhJ" value="true" />
      <property role="TrG5h" value="getDescription" />
      <node concept="17QB3L" id="51cMXQKR7zg" role="3clF45" />
      <node concept="3Tm1VV" id="51cMXQKR7ze" role="1B3o_S" />
      <node concept="3clFbS" id="51cMXQKR7zf" role="3clF47" />
    </node>
    <node concept="2YIFZL" id="hBYHs5iiMO" role="jymVt">
      <property role="TrG5h" value="rollbackChanges" />
      <property role="DiZV1" value="false" />
      <node concept="3cqZAl" id="hBYHs5iiMP" role="3clF45" />
      <node concept="37vLTG" id="hBYHs5iiMQ" role="3clF46">
        <property role="TrG5h" value="changes" />
        <node concept="A3Dl8" id="hBYHs5iiMR" role="1tU5fm">
          <node concept="3uibUv" id="hBYHs5iiMS" role="A3Ik2">
            <ref role="3uigEE" node="7Dh0CRFZxgO" resolve="ModelChange" />
          </node>
        </node>
      </node>
      <node concept="3clFbS" id="hBYHs5iiMX" role="3clF47">
        <node concept="1gVbGN" id="hBYHs5iiN1" role="3cqZAp">
          <node concept="2OqwBi" id="hBYHs5iiN2" role="1gVkn0">
            <node concept="37vLTw" id="2BHiRxglWuQ" role="2Oq$k0">
              <ref role="3cqZAo" node="hBYHs5iiMQ" resolve="changes" />
            </node>
            <node concept="3GX2aA" id="hBYHs5iiN4" role="2OqNvi" />
          </node>
        </node>
        <node concept="3cpWs8" id="hBYHs5iiN5" role="3cqZAp">
          <node concept="3cpWsn" id="hBYHs5iiN6" role="3cpWs9">
            <property role="TrG5h" value="model" />
            <node concept="2OqwBi" id="hBYHs5iiN8" role="33vP2m">
              <node concept="2OqwBi" id="hBYHs5iiN9" role="2Oq$k0">
                <node concept="2OqwBi" id="hBYHs5iiNa" role="2Oq$k0">
                  <node concept="37vLTw" id="2BHiRxgm6eZ" role="2Oq$k0">
                    <ref role="3cqZAo" node="hBYHs5iiMQ" resolve="changes" />
                  </node>
                  <node concept="1uHKPH" id="hBYHs5iiNc" role="2OqNvi" />
                </node>
                <node concept="liA8E" id="hBYHs5iiNd" role="2OqNvi">
                  <ref role="37wK5l" node="5x0q8wkvS4u" resolve="getChangeSet" />
                </node>
              </node>
              <node concept="liA8E" id="hBYHs5iiNe" role="2OqNvi">
                <ref role="37wK5l" to="bfxj:3kRMfhMv9u8" resolve="getNewModel" />
              </node>
            </node>
            <node concept="H_c77" id="4PzMkXRcyhp" role="1tU5fm" />
          </node>
        </node>
        <node concept="3cpWs8" id="hBYHs5iiNf" role="3cqZAp">
          <node concept="3cpWsn" id="hBYHs5iiNg" role="3cpWs9">
            <property role="TrG5h" value="nc" />
            <node concept="3uibUv" id="hBYHs5iiNh" role="1tU5fm">
              <ref role="3uigEE" node="69abr3GmYnQ" resolve="NodeCopier" />
            </node>
            <node concept="2ShNRf" id="hBYHs5iiNi" role="33vP2m">
              <node concept="1pGfFk" id="hBYHs5iiNj" role="2ShVmc">
                <ref role="37wK5l" node="69abr3GmYsP" resolve="NodeCopier" />
                <node concept="37vLTw" id="3GM_nagT_eg" role="37wK5m">
                  <ref role="3cqZAo" node="hBYHs5iiN6" resolve="model" />
                </node>
              </node>
            </node>
          </node>
        </node>
        <node concept="3cpWs8" id="hBYHs5iiNl" role="3cqZAp">
          <node concept="3cpWsn" id="hBYHs5iiNm" role="3cpWs9">
            <property role="TrG5h" value="oppositeChanges" />
            <node concept="A3Dl8" id="hBYHs5iiNn" role="1tU5fm">
              <node concept="3uibUv" id="hBYHs5iiNo" role="A3Ik2">
                <ref role="3uigEE" node="7Dh0CRFZxgO" resolve="ModelChange" />
              </node>
            </node>
            <node concept="2OqwBi" id="hBYHs5iiNp" role="33vP2m">
              <node concept="37vLTw" id="2BHiRxgkWGQ" role="2Oq$k0">
                <ref role="3cqZAo" node="hBYHs5iiMQ" resolve="changes" />
              </node>
              <node concept="3$u5V9" id="hBYHs5iiNr" role="2OqNvi">
                <node concept="1bVj0M" id="hBYHs5iiNs" role="23t8la">
                  <node concept="3clFbS" id="hBYHs5iiNt" role="1bW5cS">
                    <node concept="3clFbF" id="hBYHs5iiNu" role="3cqZAp">
                      <node concept="2OqwBi" id="hBYHs5iiNv" role="3clFbG">
                        <node concept="37vLTw" id="2BHiRxgm$a4" role="2Oq$k0">
                          <ref role="3cqZAo" node="hBYHs5iiNy" resolve="ch" />
                        </node>
                        <node concept="liA8E" id="hBYHs5iiNx" role="2OqNvi">
                          <ref role="37wK5l" node="2WueYNNT$jz" resolve="getOppositeChange" />
                        </node>
                      </node>
                    </node>
                  </node>
                  <node concept="Rh6nW" id="hBYHs5iiNy" role="1bW2Oz">
                    <property role="TrG5h" value="ch" />
                    <node concept="2jxLKc" id="hBYHs5iiNz" role="1tU5fm" />
                  </node>
                </node>
              </node>
            </node>
          </node>
        </node>
        <node concept="2Gpval" id="hBYHs5iiN$" role="3cqZAp">
          <node concept="2GrKxI" id="hBYHs5iiN_" role="2Gsz3X">
            <property role="TrG5h" value="ch" />
          </node>
          <node concept="37vLTw" id="3GM_nagT_9y" role="2GsD0m">
            <ref role="3cqZAo" node="hBYHs5iiNm" resolve="oppositeChanges" />
          </node>
          <node concept="3clFbS" id="hBYHs5iiNB" role="2LFqv$">
            <node concept="3clFbJ" id="hBYHs5iiNC" role="3cqZAp">
              <node concept="2ZW3vV" id="hBYHs5iiND" role="3clFbw">
                <node concept="3uibUv" id="hBYHs5iiNE" role="2ZW6by">
                  <ref role="3uigEE" node="4k3fuHGsESX" resolve="NodeGroupChange" />
                </node>
                <node concept="2GrUjf" id="hBYHs5iiNF" role="2ZW6bz">
                  <ref role="2Gs0qQ" node="hBYHs5iiN_" resolve="ch" />
                </node>
              </node>
              <node concept="3clFbS" id="hBYHs5iiNG" role="3clFbx">
                <node concept="3clFbF" id="hBYHs5iiNH" role="3cqZAp">
                  <node concept="2OqwBi" id="hBYHs5iiNI" role="3clFbG">
                    <node concept="1eOMI4" id="hBYHs5iiNJ" role="2Oq$k0">
                      <node concept="10QFUN" id="hBYHs5iiNK" role="1eOMHV">
                        <node concept="3uibUv" id="hBYHs5iiNL" role="10QFUM">
                          <ref role="3uigEE" node="4k3fuHGsESX" resolve="NodeGroupChange" />
                        </node>
                        <node concept="2GrUjf" id="hBYHs5iiNM" role="10QFUP">
                          <ref role="2Gs0qQ" node="hBYHs5iiN_" resolve="ch" />
                        </node>
                      </node>
                    </node>
                    <node concept="liA8E" id="hBYHs5iiNN" role="2OqNvi">
                      <ref role="37wK5l" node="PhFjFi7uzM" resolve="prepare" />
                    </node>
                  </node>
                </node>
              </node>
            </node>
          </node>
        </node>
        <node concept="3clFbF" id="hBYHs5iiNO" role="3cqZAp">
          <node concept="2OqwBi" id="hBYHs5iiNP" role="3clFbG">
            <node concept="37vLTw" id="3GM_nagT$ip" role="2Oq$k0">
              <ref role="3cqZAo" node="hBYHs5iiNm" resolve="oppositeChanges" />
            </node>
            <node concept="2es0OD" id="hBYHs5iiNR" role="2OqNvi">
              <node concept="1bVj0M" id="hBYHs5iiNS" role="23t8la">
                <node concept="3clFbS" id="hBYHs5iiNT" role="1bW5cS">
                  <node concept="3clFbF" id="hBYHs5iiNU" role="3cqZAp">
                    <node concept="2OqwBi" id="hBYHs5iiNV" role="3clFbG">
                      <node concept="37vLTw" id="2BHiRxghiUR" role="2Oq$k0">
                        <ref role="3cqZAo" node="hBYHs5iiO0" resolve="ch" />
                      </node>
                      <node concept="liA8E" id="hBYHs5iiNX" role="2OqNvi">
                        <ref role="37wK5l" node="2W$ok$XX_PQ" resolve="apply" />
                        <node concept="37vLTw" id="3GM_nagTrEn" role="37wK5m">
                          <ref role="3cqZAo" node="hBYHs5iiN6" resolve="model" />
                        </node>
                        <node concept="37vLTw" id="3GM_nagTAtc" role="37wK5m">
                          <ref role="3cqZAo" node="hBYHs5iiNg" resolve="nc" />
                        </node>
                      </node>
                    </node>
                  </node>
                </node>
                <node concept="Rh6nW" id="hBYHs5iiO0" role="1bW2Oz">
                  <property role="TrG5h" value="ch" />
                  <node concept="2jxLKc" id="hBYHs5iiO1" role="1tU5fm" />
                </node>
              </node>
            </node>
          </node>
        </node>
        <node concept="3clFbF" id="hBYHs5iiO2" role="3cqZAp">
          <node concept="2OqwBi" id="hBYHs5iiO3" role="3clFbG">
            <node concept="37vLTw" id="3GM_nagTBj2" role="2Oq$k0">
              <ref role="3cqZAo" node="hBYHs5iiNg" resolve="nc" />
            </node>
            <node concept="liA8E" id="hBYHs5iiO5" role="2OqNvi">
              <ref role="37wK5l" node="69abr3GmYp9" resolve="restoreIds" />
              <node concept="3clFbT" id="hBYHs5iiO6" role="37wK5m">
                <property role="3clFbU" value="true" />
              </node>
            </node>
          </node>
        </node>
      </node>
      <node concept="3Tm1VV" id="hBYHs5iiOf" role="1B3o_S" />
    </node>
  </node>
  <node concept="312cEu" id="5x0q8wkvS3B">
    <property role="TrG5h" value="AddRootChange" />
    <property role="3GE5qa" value="structure" />
    <node concept="3Tm1VV" id="5x0q8wkvS3C" role="1B3o_S" />
    <node concept="3uibUv" id="5x0q8wkvS4$" role="1zkMxy">
      <ref role="3uigEE" node="7Dh0CRFZxgO" resolve="ModelChange" />
    </node>
    <node concept="312cEg" id="5x0q8wkvS4P" role="jymVt">
      <property role="TrG5h" value="myNodeId" />
      <node concept="3Tm6S6" id="5x0q8wkvS4Q" role="1B3o_S" />
      <node concept="3uibUv" id="5x0q8wkvS4S" role="1tU5fm">
        <ref role="3uigEE" to="mhbf:~SNodeId" resolve="SNodeId" />
      </node>
    </node>
    <node concept="3clFbW" id="5x0q8wkvS4_" role="jymVt">
      <node concept="3cqZAl" id="5x0q8wkvS4A" role="3clF45" />
      <node concept="3Tm1VV" id="5x0q8wkvS4B" role="1B3o_S" />
      <node concept="3clFbS" id="5x0q8wkvS4D" role="3clF47">
        <node concept="XkiVB" id="5x0q8wkvS4E" role="3cqZAp">
          <ref role="37wK5l" node="5x0q8wkvS3L" resolve="ModelChange" />
          <node concept="37vLTw" id="2BHiRxgmOdD" role="37wK5m">
            <ref role="3cqZAo" node="5x0q8wkvS4F" resolve="changeSet" />
          </node>
        </node>
        <node concept="3clFbF" id="5x0q8wkvS4U" role="3cqZAp">
          <node concept="37vLTI" id="5x0q8wkvS4W" role="3clFbG">
            <node concept="37vLTw" id="2BHiRxgm7w8" role="37vLTx">
              <ref role="3cqZAo" node="5x0q8wkvS4J" resolve="nodeId" />
            </node>
            <node concept="37vLTw" id="2BHiRxeu_Fn" role="37vLTJ">
              <ref role="3cqZAo" node="5x0q8wkvS4P" resolve="myNodeId" />
            </node>
          </node>
        </node>
      </node>
      <node concept="37vLTG" id="5x0q8wkvS4F" role="3clF46">
        <property role="TrG5h" value="changeSet" />
        <node concept="3uibUv" id="3kRMfhMvhrm" role="1tU5fm">
          <ref role="3uigEE" to="bfxj:3kRMfhMv03j" resolve="ChangeSet" />
        </node>
        <node concept="2AHcQZ" id="2W$ok$XXEZl" role="2AJF6D">
          <ref role="2AI5Lk" to="mhfm:~NotNull" resolve="NotNull" />
        </node>
      </node>
      <node concept="37vLTG" id="5x0q8wkvS4J" role="3clF46">
        <property role="TrG5h" value="nodeId" />
        <node concept="2AHcQZ" id="2W$ok$XXEZm" role="2AJF6D">
          <ref role="2AI5Lk" to="mhfm:~NotNull" resolve="NotNull" />
        </node>
        <node concept="3uibUv" id="5x0q8wkvS4L" role="1tU5fm">
          <ref role="3uigEE" to="mhbf:~SNodeId" resolve="SNodeId" />
        </node>
      </node>
    </node>
    <node concept="3clFb_" id="3RcDWS$m24H" role="jymVt">
      <property role="TrG5h" value="getRootId" />
      <node concept="3uibUv" id="3RcDWS$m24I" role="3clF45">
        <ref role="3uigEE" to="mhbf:~SNodeId" resolve="SNodeId" />
      </node>
      <node concept="3Tm1VV" id="3RcDWS$m24J" role="1B3o_S" />
      <node concept="2AHcQZ" id="3RcDWS$m24K" role="2AJF6D">
        <ref role="2AI5Lk" to="mhfm:~NotNull" resolve="NotNull" />
      </node>
      <node concept="3clFbS" id="3RcDWS$m24L" role="3clF47">
        <node concept="3clFbF" id="5Gi8bfMdBnX" role="3cqZAp">
          <node concept="37vLTw" id="2BHiRxeuQuO" role="3clFbG">
            <ref role="3cqZAo" node="5x0q8wkvS4P" resolve="myNodeId" />
          </node>
        </node>
      </node>
      <node concept="2AHcQZ" id="3RcDWS$m24M" role="2AJF6D">
        <ref role="2AI5Lk" to="wyt6:~Override" resolve="Override" />
      </node>
    </node>
    <node concept="3clFb_" id="2W$ok$XXEZe" role="jymVt">
      <property role="TrG5h" value="apply" />
      <node concept="3cqZAl" id="2W$ok$XXEZf" role="3clF45" />
      <node concept="3Tm1VV" id="2W$ok$XXEZg" role="1B3o_S" />
      <node concept="37vLTG" id="2W$ok$XXEZh" role="3clF46">
        <property role="TrG5h" value="model" />
        <node concept="H_c77" id="2W$ok$XXEZi" role="1tU5fm" />
        <node concept="2AHcQZ" id="2W$ok$XXEZj" role="2AJF6D">
          <ref role="2AI5Lk" to="mhfm:~NotNull" resolve="NotNull" />
        </node>
      </node>
      <node concept="37vLTG" id="4YYMSngGbjZ" role="3clF46">
        <property role="TrG5h" value="nodeCopier" />
        <node concept="3uibUv" id="4YPlf0PK8wP" role="1tU5fm">
          <ref role="3uigEE" node="69abr3GmYnQ" resolve="NodeCopier" />
        </node>
        <node concept="2AHcQZ" id="4YYMSngGbk1" role="2AJF6D">
          <ref role="2AI5Lk" to="mhfm:~NotNull" resolve="NotNull" />
        </node>
      </node>
      <node concept="3clFbS" id="2W$ok$XXEZk" role="3clF47">
        <node concept="3cpWs8" id="2W$ok$XXFkB" role="3cqZAp">
          <node concept="3cpWsn" id="2W$ok$XXFkC" role="3cpWs9">
            <property role="TrG5h" value="newNode" />
            <node concept="2OqwBi" id="2n9zn0CqMCZ" role="33vP2m">
              <node concept="liA8E" id="2n9zn0CqMD0" role="2OqNvi">
                <ref role="37wK5l" to="mhbf:~SModel.getNode(org.jetbrains.mps.openapi.model.SNodeId):org.jetbrains.mps.openapi.model.SNode" resolve="getNode" />
                <node concept="37vLTw" id="2BHiRxeuWRg" role="37wK5m">
                  <ref role="3cqZAo" node="5x0q8wkvS4P" resolve="myNodeId" />
                </node>
              </node>
              <node concept="2JrnkZ" id="2n9zn0CqMD2" role="2Oq$k0">
                <node concept="2OqwBi" id="2n9zn0CqMD3" role="2JrQYb">
                  <node concept="1rXfSq" id="4hiugqyz8Xf" role="2Oq$k0">
                    <ref role="37wK5l" node="5x0q8wkvS4u" resolve="getChangeSet" />
                  </node>
                  <node concept="liA8E" id="2n9zn0CqMD5" role="2OqNvi">
                    <ref role="37wK5l" to="bfxj:3kRMfhMv9u8" resolve="getNewModel" />
                  </node>
                </node>
              </node>
            </node>
            <node concept="3uibUv" id="2W$ok$XXFkD" role="1tU5fm">
              <ref role="3uigEE" to="mhbf:~SNode" resolve="SNode" />
            </node>
          </node>
        </node>
        <node concept="3clFbF" id="2W$ok$XXFkN" role="3cqZAp">
          <node concept="2OqwBi" id="2W$ok$XXFkP" role="3clFbG">
            <node concept="37vLTw" id="2BHiRxglVt3" role="2Oq$k0">
              <ref role="3cqZAo" node="2W$ok$XXEZh" resolve="model" />
            </node>
            <node concept="3BYIHo" id="2W$ok$XXFkT" role="2OqNvi">
              <node concept="2OqwBi" id="4YYMSngGbk4" role="3BYIHq">
                <node concept="37vLTw" id="2BHiRxglGas" role="2Oq$k0">
                  <ref role="3cqZAo" node="4YYMSngGbjZ" resolve="nodeCopier" />
                </node>
                <node concept="liA8E" id="4YYMSngGbk8" role="2OqNvi">
                  <ref role="37wK5l" node="69abr3GmYoe" resolve="copyNode" />
                  <node concept="37vLTw" id="3GM_nagTyZi" role="37wK5m">
                    <ref role="3cqZAo" node="2W$ok$XXFkC" resolve="newNode" />
                  </node>
                </node>
              </node>
            </node>
          </node>
        </node>
      </node>
      <node concept="2AHcQZ" id="3tYsUK_RXHq" role="2AJF6D">
        <ref role="2AI5Lk" to="wyt6:~Override" resolve="Override" />
      </node>
    </node>
    <node concept="3clFb_" id="2WueYNNTBd$" role="jymVt">
      <property role="1EzhhJ" value="false" />
      <property role="TrG5h" value="createOppositeChange" />
      <node concept="3uibUv" id="2WueYNNTBd_" role="3clF45">
        <ref role="3uigEE" node="7Dh0CRFZxgO" resolve="ModelChange" />
      </node>
      <node concept="3Tmbuc" id="2WueYNNTBdA" role="1B3o_S" />
      <node concept="3clFbS" id="2WueYNNTBdB" role="3clF47">
        <node concept="3clFbF" id="2WueYNNTBdF" role="3cqZAp">
          <node concept="2ShNRf" id="2WueYNNTBdG" role="3clFbG">
            <node concept="1pGfFk" id="2WueYNNTBdI" role="2ShVmc">
              <ref role="37wK5l" node="5x0q8wkvVi7" resolve="DeleteRootChange" />
              <node concept="2OqwBi" id="2WueYNNTBdK" role="37wK5m">
                <node concept="1rXfSq" id="4hiugqyz8GF" role="2Oq$k0">
                  <ref role="37wK5l" node="5x0q8wkvS4u" resolve="getChangeSet" />
                </node>
                <node concept="liA8E" id="2WueYNNTBdO" role="2OqNvi">
                  <ref role="37wK5l" to="bfxj:3kRMfhMv9uc" resolve="getOppositeChangeSet" />
                </node>
              </node>
              <node concept="37vLTw" id="2BHiRxeuskB" role="37wK5m">
                <ref role="3cqZAo" node="5x0q8wkvS4P" resolve="myNodeId" />
              </node>
            </node>
          </node>
        </node>
      </node>
      <node concept="2AHcQZ" id="5Gi8bfMdALD" role="2AJF6D">
        <ref role="2AI5Lk" to="mhfm:~NotNull" resolve="NotNull" />
      </node>
      <node concept="2AHcQZ" id="3tYsUK_RXHp" role="2AJF6D">
        <ref role="2AI5Lk" to="wyt6:~Override" resolve="Override" />
      </node>
    </node>
    <node concept="3clFb_" id="7inhnIFBpIZ" role="jymVt">
      <property role="TrG5h" value="getType" />
      <node concept="3uibUv" id="7inhnIFBpJ0" role="3clF45">
        <ref role="3uigEE" node="7inhnIFBpHM" resolve="ChangeType" />
      </node>
      <node concept="3Tm1VV" id="7inhnIFBpJ1" role="1B3o_S" />
      <node concept="3clFbS" id="7inhnIFBpJ2" role="3clF47">
        <node concept="3clFbF" id="7inhnIFBpJ6" role="3cqZAp">
          <node concept="Rm8GO" id="7inhnIFBpJ8" role="3clFbG">
            <ref role="Rm8GQ" node="7inhnIFBpHO" resolve="ADD" />
            <ref role="1Px2BO" node="7inhnIFBpHM" resolve="ChangeType" />
          </node>
        </node>
      </node>
      <node concept="2AHcQZ" id="5Gi8bfMdBnM" role="2AJF6D">
        <ref role="2AI5Lk" to="mhfm:~NotNull" resolve="NotNull" />
      </node>
      <node concept="2AHcQZ" id="3tYsUK_RXHo" role="2AJF6D">
        <ref role="2AI5Lk" to="wyt6:~Override" resolve="Override" />
      </node>
    </node>
    <node concept="3clFb_" id="5x0q8wkvVip" role="jymVt">
      <property role="TrG5h" value="toString" />
      <node concept="17QB3L" id="5x0q8wkvViq" role="3clF45" />
      <node concept="3Tm1VV" id="5x0q8wkvVir" role="1B3o_S" />
      <node concept="3clFbS" id="5x0q8wkvVis" role="3clF47">
        <node concept="3clFbF" id="5x0q8wkvVit" role="3cqZAp">
          <node concept="3cpWs3" id="5x0q8wkvVkO" role="3clFbG">
            <node concept="Xl_RD" id="5x0q8wkvVkN" role="3uHU7B">
              <property role="Xl_RC" value="Add root " />
            </node>
            <node concept="37vLTw" id="2BHiRxeuzeD" role="3uHU7w">
              <ref role="3cqZAo" node="5x0q8wkvS4P" resolve="myNodeId" />
            </node>
          </node>
        </node>
      </node>
      <node concept="2AHcQZ" id="5x0q8wkvVi_" role="2AJF6D">
        <ref role="2AI5Lk" to="wyt6:~Override" resolve="Override" />
      </node>
    </node>
    <node concept="3clFb_" id="51cMXQKRj4e" role="jymVt">
      <property role="1EzhhJ" value="false" />
      <property role="TrG5h" value="getDescription" />
      <node concept="17QB3L" id="51cMXQKRj4f" role="3clF45" />
      <node concept="3Tm1VV" id="51cMXQKRj4g" role="1B3o_S" />
      <node concept="3clFbS" id="51cMXQKRj4h" role="3clF47">
        <node concept="3clFbF" id="51cMXQKRj4i" role="3cqZAp">
          <node concept="3cpWs3" id="51cMXQKRj4j" role="3clFbG">
            <node concept="Xl_RD" id="51cMXQKRj4k" role="3uHU7B">
              <property role="Xl_RC" value="Added root #" />
            </node>
            <node concept="37vLTw" id="2BHiRxeuknO" role="3uHU7w">
              <ref role="3cqZAo" node="5x0q8wkvS4P" resolve="myNodeId" />
            </node>
          </node>
        </node>
      </node>
      <node concept="2AHcQZ" id="3tYsUK_RXHn" role="2AJF6D">
        <ref role="2AI5Lk" to="wyt6:~Override" resolve="Override" />
      </node>
    </node>
  </node>
  <node concept="312cEu" id="5x0q8wkvVi1">
    <property role="TrG5h" value="DeleteRootChange" />
    <property role="3GE5qa" value="structure" />
    <node concept="3Tm1VV" id="5x0q8wkvVi5" role="1B3o_S" />
    <node concept="3uibUv" id="5x0q8wkvVi6" role="1zkMxy">
      <ref role="3uigEE" node="7Dh0CRFZxgO" resolve="ModelChange" />
    </node>
    <node concept="312cEg" id="5x0q8wkvVi2" role="jymVt">
      <property role="TrG5h" value="myNodeId" />
      <node concept="3Tm6S6" id="5x0q8wkvVi3" role="1B3o_S" />
      <node concept="3uibUv" id="5x0q8wkvVi4" role="1tU5fm">
        <ref role="3uigEE" to="mhbf:~SNodeId" resolve="SNodeId" />
      </node>
    </node>
    <node concept="3clFbW" id="5x0q8wkvVi7" role="jymVt">
      <node concept="3cqZAl" id="5x0q8wkvVi8" role="3clF45" />
      <node concept="3Tm1VV" id="5x0q8wkvVi9" role="1B3o_S" />
      <node concept="3clFbS" id="5x0q8wkvVia" role="3clF47">
        <node concept="XkiVB" id="5x0q8wkvVib" role="3cqZAp">
          <ref role="37wK5l" node="5x0q8wkvS3L" resolve="ModelChange" />
          <node concept="37vLTw" id="2BHiRxgm7l7" role="37wK5m">
            <ref role="3cqZAo" node="5x0q8wkvVih" resolve="changeSet" />
          </node>
        </node>
        <node concept="3clFbF" id="5x0q8wkvVid" role="3cqZAp">
          <node concept="37vLTI" id="5x0q8wkvVie" role="3clFbG">
            <node concept="37vLTw" id="2BHiRxghfYS" role="37vLTx">
              <ref role="3cqZAo" node="5x0q8wkvVij" resolve="nodeId" />
            </node>
            <node concept="37vLTw" id="2BHiRxeusvb" role="37vLTJ">
              <ref role="3cqZAo" node="5x0q8wkvVi2" resolve="myNodeId" />
            </node>
          </node>
        </node>
      </node>
      <node concept="37vLTG" id="5x0q8wkvVih" role="3clF46">
        <property role="TrG5h" value="changeSet" />
        <node concept="3uibUv" id="3kRMfhMvhrs" role="1tU5fm">
          <ref role="3uigEE" to="bfxj:3kRMfhMv03j" resolve="ChangeSet" />
        </node>
      </node>
      <node concept="37vLTG" id="5x0q8wkvVij" role="3clF46">
        <property role="TrG5h" value="nodeId" />
        <node concept="3uibUv" id="5x0q8wkvVik" role="1tU5fm">
          <ref role="3uigEE" to="mhbf:~SNodeId" resolve="SNodeId" />
        </node>
      </node>
    </node>
    <node concept="3clFb_" id="3RcDWS$m24U" role="jymVt">
      <property role="TrG5h" value="getRootId" />
      <node concept="3uibUv" id="3RcDWS$m24V" role="3clF45">
        <ref role="3uigEE" to="mhbf:~SNodeId" resolve="SNodeId" />
      </node>
      <node concept="3Tm1VV" id="3RcDWS$m24W" role="1B3o_S" />
      <node concept="2AHcQZ" id="3RcDWS$m24X" role="2AJF6D">
        <ref role="2AI5Lk" to="mhfm:~NotNull" resolve="NotNull" />
      </node>
      <node concept="3clFbS" id="3RcDWS$m24Y" role="3clF47">
        <node concept="3cpWs6" id="3RcDWS$m253" role="3cqZAp">
          <node concept="37vLTw" id="2BHiRxeujnd" role="3cqZAk">
            <ref role="3cqZAo" node="5x0q8wkvVi2" resolve="myNodeId" />
          </node>
        </node>
      </node>
      <node concept="2AHcQZ" id="3RcDWS$m24Z" role="2AJF6D">
        <ref role="2AI5Lk" to="wyt6:~Override" resolve="Override" />
      </node>
    </node>
    <node concept="3clFb_" id="2W$ok$XXFkZ" role="jymVt">
      <property role="TrG5h" value="apply" />
      <node concept="3cqZAl" id="2W$ok$XXFl0" role="3clF45" />
      <node concept="3Tm1VV" id="2W$ok$XXFl1" role="1B3o_S" />
      <node concept="37vLTG" id="2W$ok$XXFl2" role="3clF46">
        <property role="TrG5h" value="model" />
        <node concept="H_c77" id="2W$ok$XXFl3" role="1tU5fm" />
        <node concept="2AHcQZ" id="2W$ok$XXFl4" role="2AJF6D">
          <ref role="2AI5Lk" to="mhfm:~NotNull" resolve="NotNull" />
        </node>
      </node>
      <node concept="37vLTG" id="4YYMSngGbkc" role="3clF46">
        <property role="TrG5h" value="nodeCopier" />
        <node concept="3uibUv" id="4YPlf0PK8wR" role="1tU5fm">
          <ref role="3uigEE" node="69abr3GmYnQ" resolve="NodeCopier" />
        </node>
        <node concept="2AHcQZ" id="4YYMSngGbke" role="2AJF6D">
          <ref role="2AI5Lk" to="mhfm:~NotNull" resolve="NotNull" />
        </node>
      </node>
      <node concept="3clFbS" id="2W$ok$XXFl5" role="3clF47">
        <node concept="1gVbGN" id="2W$ok$XXF_P" role="3cqZAp">
          <node concept="3y3z36" id="2W$ok$XXF_W" role="1gVkn0">
            <node concept="2OqwBi" id="2n9zn0CqM_W" role="3uHU7B">
              <node concept="liA8E" id="2n9zn0CqM_X" role="2OqNvi">
                <ref role="37wK5l" to="mhbf:~SModel.getNode(org.jetbrains.mps.openapi.model.SNodeId):org.jetbrains.mps.openapi.model.SNode" resolve="getNode" />
                <node concept="37vLTw" id="2BHiRxeumQm" role="37wK5m">
                  <ref role="3cqZAo" node="5x0q8wkvVi2" resolve="myNodeId" />
                </node>
              </node>
              <node concept="2JrnkZ" id="2n9zn0CqM_Z" role="2Oq$k0">
                <node concept="37vLTw" id="2BHiRxglIbs" role="2JrQYb">
                  <ref role="3cqZAo" node="2W$ok$XXFl2" resolve="model" />
                </node>
              </node>
            </node>
            <node concept="10Nm6u" id="2W$ok$XXF_Z" role="3uHU7w" />
          </node>
        </node>
        <node concept="3clFbF" id="2W$ok$XXFl6" role="3cqZAp">
          <node concept="2OqwBi" id="2W$ok$XXFlk" role="3clFbG">
            <node concept="2OqwBi" id="2n9zn0CqM_3" role="2Oq$k0">
              <node concept="liA8E" id="2n9zn0CqM_4" role="2OqNvi">
                <ref role="37wK5l" to="mhbf:~SModel.getNode(org.jetbrains.mps.openapi.model.SNodeId):org.jetbrains.mps.openapi.model.SNode" resolve="getNode" />
                <node concept="37vLTw" id="2BHiRxeunej" role="37wK5m">
                  <ref role="3cqZAo" node="5x0q8wkvVi2" resolve="myNodeId" />
                </node>
              </node>
              <node concept="2JrnkZ" id="2n9zn0CqM_6" role="2Oq$k0">
                <node concept="37vLTw" id="2BHiRxglphA" role="2JrQYb">
                  <ref role="3cqZAo" node="2W$ok$XXFl2" resolve="model" />
                </node>
              </node>
            </node>
            <node concept="liA8E" id="2W$ok$XXFlo" role="2OqNvi">
              <ref role="37wK5l" to="mhbf:~SNode.delete():void" resolve="delete" />
            </node>
          </node>
        </node>
      </node>
      <node concept="2AHcQZ" id="3tYsUK_S7$D" role="2AJF6D">
        <ref role="2AI5Lk" to="wyt6:~Override" resolve="Override" />
      </node>
    </node>
    <node concept="3clFb_" id="2WueYNNTBdR" role="jymVt">
      <property role="1EzhhJ" value="false" />
      <property role="TrG5h" value="createOppositeChange" />
      <node concept="3uibUv" id="2WueYNNTBdS" role="3clF45">
        <ref role="3uigEE" node="7Dh0CRFZxgO" resolve="ModelChange" />
      </node>
      <node concept="3Tmbuc" id="2WueYNNTBdT" role="1B3o_S" />
      <node concept="3clFbS" id="2WueYNNTBdU" role="3clF47">
        <node concept="3clFbF" id="2WueYNNTBdX" role="3cqZAp">
          <node concept="2ShNRf" id="2WueYNNTBdY" role="3clFbG">
            <node concept="1pGfFk" id="2WueYNNTBdZ" role="2ShVmc">
              <ref role="37wK5l" node="5x0q8wkvS4_" resolve="AddRootChange" />
              <node concept="2OqwBi" id="2WueYNNTBe0" role="37wK5m">
                <node concept="1rXfSq" id="4hiugqyyRQg" role="2Oq$k0">
                  <ref role="37wK5l" node="5x0q8wkvS4u" resolve="getChangeSet" />
                </node>
                <node concept="liA8E" id="2WueYNNTBe2" role="2OqNvi">
                  <ref role="37wK5l" to="bfxj:3kRMfhMv9uc" resolve="getOppositeChangeSet" />
                </node>
              </node>
              <node concept="37vLTw" id="2BHiRxeuvJf" role="37wK5m">
                <ref role="3cqZAo" node="5x0q8wkvVi2" resolve="myNodeId" />
              </node>
            </node>
          </node>
        </node>
      </node>
      <node concept="2AHcQZ" id="5Gi8bfMdALE" role="2AJF6D">
        <ref role="2AI5Lk" to="mhfm:~NotNull" resolve="NotNull" />
      </node>
      <node concept="2AHcQZ" id="3tYsUK_S7$F" role="2AJF6D">
        <ref role="2AI5Lk" to="wyt6:~Override" resolve="Override" />
      </node>
    </node>
    <node concept="3clFb_" id="7inhnIFBpJ9" role="jymVt">
      <property role="TrG5h" value="getType" />
      <node concept="3uibUv" id="7inhnIFBpJa" role="3clF45">
        <ref role="3uigEE" node="7inhnIFBpHM" resolve="ChangeType" />
      </node>
      <node concept="3Tm1VV" id="7inhnIFBpJb" role="1B3o_S" />
      <node concept="3clFbS" id="7inhnIFBpJc" role="3clF47">
        <node concept="3clFbF" id="7inhnIFBpJg" role="3cqZAp">
          <node concept="Rm8GO" id="7inhnIFBpJi" role="3clFbG">
            <ref role="Rm8GQ" node="7inhnIFBpHU" resolve="DELETE" />
            <ref role="1Px2BO" node="7inhnIFBpHM" resolve="ChangeType" />
          </node>
        </node>
      </node>
      <node concept="2AHcQZ" id="5Gi8bfMdBnN" role="2AJF6D">
        <ref role="2AI5Lk" to="mhfm:~NotNull" resolve="NotNull" />
      </node>
      <node concept="2AHcQZ" id="3tYsUK_S7$C" role="2AJF6D">
        <ref role="2AI5Lk" to="wyt6:~Override" resolve="Override" />
      </node>
    </node>
    <node concept="3clFb_" id="5x0q8wkvVkW" role="jymVt">
      <property role="TrG5h" value="toString" />
      <node concept="17QB3L" id="5x0q8wkvVkX" role="3clF45" />
      <node concept="3Tm1VV" id="5x0q8wkvVkY" role="1B3o_S" />
      <node concept="3clFbS" id="5x0q8wkvVkZ" role="3clF47">
        <node concept="3clFbF" id="5x0q8wkvVl0" role="3cqZAp">
          <node concept="3cpWs3" id="5x0q8wkvVl3" role="3clFbG">
            <node concept="Xl_RD" id="5x0q8wkvVl4" role="3uHU7B">
              <property role="Xl_RC" value="Delete root " />
            </node>
            <node concept="37vLTw" id="2BHiRxeuFHP" role="3uHU7w">
              <ref role="3cqZAo" node="5x0q8wkvVi2" resolve="myNodeId" />
            </node>
          </node>
        </node>
      </node>
      <node concept="2AHcQZ" id="5x0q8wkvVl6" role="2AJF6D">
        <ref role="2AI5Lk" to="wyt6:~Override" resolve="Override" />
      </node>
    </node>
    <node concept="3clFb_" id="51cMXQKRj4p" role="jymVt">
      <property role="1EzhhJ" value="false" />
      <property role="TrG5h" value="getDescription" />
      <node concept="17QB3L" id="51cMXQKRj4q" role="3clF45" />
      <node concept="3Tm1VV" id="51cMXQKRj4r" role="1B3o_S" />
      <node concept="3clFbS" id="51cMXQKRj4s" role="3clF47">
        <node concept="3clFbF" id="51cMXQKRj4t" role="3cqZAp">
          <node concept="3cpWs3" id="51cMXQKRj4u" role="3clFbG">
            <node concept="Xl_RD" id="51cMXQKRj4v" role="3uHU7B">
              <property role="Xl_RC" value="Deleted root #" />
            </node>
            <node concept="37vLTw" id="2BHiRxeun5$" role="3uHU7w">
              <ref role="3cqZAo" node="5x0q8wkvVi2" resolve="myNodeId" />
            </node>
          </node>
        </node>
      </node>
      <node concept="2AHcQZ" id="3tYsUK_S7$E" role="2AJF6D">
        <ref role="2AI5Lk" to="wyt6:~Override" resolve="Override" />
      </node>
    </node>
  </node>
  <node concept="312cEu" id="4k3fuHGsESX">
    <property role="TrG5h" value="NodeGroupChange" />
    <property role="3GE5qa" value="structure" />
    <property role="1sVAO0" value="false" />
    <node concept="3Tm1VV" id="4k3fuHGsESY" role="1B3o_S" />
    <node concept="3uibUv" id="4k3fuHGsET3" role="1zkMxy">
      <ref role="3uigEE" node="7Dh0CRFZxgO" resolve="ModelChange" />
    </node>
    <node concept="312cEg" id="4k3fuHGsETf" role="jymVt">
      <property role="TrG5h" value="myParentNodeId" />
      <property role="3TUv4t" value="true" />
      <node concept="3Tm6S6" id="4k3fuHGsETg" role="1B3o_S" />
      <node concept="3uibUv" id="4k3fuHGsETi" role="1tU5fm">
        <ref role="3uigEE" to="mhbf:~SNodeId" resolve="SNodeId" />
      </node>
    </node>
    <node concept="312cEg" id="4k3fuHGsETj" role="jymVt">
      <property role="TrG5h" value="myRole" />
      <property role="3TUv4t" value="true" />
      <node concept="3Tm6S6" id="4k3fuHGsETk" role="1B3o_S" />
      <node concept="3uibUv" id="58$Pzbkaiiv" role="1tU5fm">
        <ref role="3uigEE" to="c17a:~SContainmentLink" resolve="SContainmentLink" />
      </node>
    </node>
    <node concept="312cEg" id="PhFjFi6YEh" role="jymVt">
      <property role="TrG5h" value="myBegin" />
      <property role="3TUv4t" value="true" />
      <node concept="3Tm6S6" id="PhFjFi6YEi" role="1B3o_S" />
      <node concept="10Oyi0" id="PhFjFi6YEj" role="1tU5fm" />
    </node>
    <node concept="312cEg" id="PhFjFi6YEk" role="jymVt">
      <property role="TrG5h" value="myEnd" />
      <property role="3TUv4t" value="true" />
      <node concept="3Tm6S6" id="PhFjFi6YEl" role="1B3o_S" />
      <node concept="10Oyi0" id="PhFjFi6YEm" role="1tU5fm" />
    </node>
    <node concept="312cEg" id="PhFjFi6YEn" role="jymVt">
      <property role="TrG5h" value="myResultBegin" />
      <property role="3TUv4t" value="true" />
      <node concept="3Tm6S6" id="PhFjFi6YEo" role="1B3o_S" />
      <node concept="10Oyi0" id="PhFjFi6YEp" role="1tU5fm" />
    </node>
    <node concept="312cEg" id="PhFjFi6YEq" role="jymVt">
      <property role="TrG5h" value="myResultEnd" />
      <property role="3TUv4t" value="true" />
      <node concept="3Tm6S6" id="PhFjFi6YEr" role="1B3o_S" />
      <node concept="10Oyi0" id="PhFjFi6YEs" role="1tU5fm" />
    </node>
    <node concept="312cEg" id="PhFjFi7uzF" role="jymVt">
      <property role="TrG5h" value="myPreparedIdsToDelete" />
      <node concept="3Tm6S6" id="PhFjFi7uzG" role="1B3o_S" />
      <node concept="_YKpA" id="PhFjFi7uzI" role="1tU5fm">
        <node concept="3uibUv" id="PhFjFi7uzJ" role="_ZDj9">
          <ref role="3uigEE" to="mhbf:~SNodeId" resolve="SNodeId" />
        </node>
      </node>
      <node concept="10Nm6u" id="PhFjFi7uzL" role="33vP2m" />
    </node>
    <node concept="312cEg" id="PhFjFi7uJW" role="jymVt">
      <property role="TrG5h" value="myPreparedAnchorId" />
      <node concept="3Tm6S6" id="PhFjFi7uJX" role="1B3o_S" />
      <node concept="3uibUv" id="PhFjFi7uJZ" role="1tU5fm">
        <ref role="3uigEE" to="mhbf:~SNodeId" resolve="SNodeId" />
      </node>
      <node concept="10Nm6u" id="PhFjFi7uK1" role="33vP2m" />
    </node>
    <node concept="3clFbW" id="4k3fuHGtdr9" role="jymVt">
      <node concept="3cqZAl" id="4k3fuHGtdra" role="3clF45" />
      <node concept="3Tm1VV" id="4k3fuHGtdrb" role="1B3o_S" />
      <node concept="3clFbS" id="4k3fuHGtdrd" role="3clF47">
        <node concept="XkiVB" id="4k3fuHGtdre" role="3cqZAp">
          <ref role="37wK5l" node="5x0q8wkvS3L" resolve="ModelChange" />
          <node concept="37vLTw" id="2BHiRxgl7Ri" role="37wK5m">
            <ref role="3cqZAo" node="4k3fuHGtdrf" resolve="changeSet" />
          </node>
        </node>
        <node concept="3clFbF" id="4k3fuHGtdrl" role="3cqZAp">
          <node concept="37vLTI" id="4k3fuHGtdrn" role="3clFbG">
            <node concept="37vLTw" id="2BHiRxeuFwW" role="37vLTJ">
              <ref role="3cqZAo" node="4k3fuHGsETf" resolve="myParentNodeId" />
            </node>
            <node concept="37vLTw" id="2BHiRxgkZZl" role="37vLTx">
              <ref role="3cqZAo" node="4k3fuHGtdrj" resolve="parentNodeId" />
            </node>
          </node>
        </node>
        <node concept="3clFbF" id="4k3fuHGtdru" role="3cqZAp">
          <node concept="37vLTI" id="4k3fuHGtdrw" role="3clFbG">
            <node concept="37vLTw" id="2BHiRxeun8x" role="37vLTJ">
              <ref role="3cqZAo" node="4k3fuHGsETj" resolve="myRole" />
            </node>
            <node concept="37vLTw" id="2BHiRxgl6x9" role="37vLTx">
              <ref role="3cqZAo" node="4k3fuHGtdrs" resolve="role" />
            </node>
          </node>
        </node>
        <node concept="3clFbF" id="PhFjFi6YFo" role="3cqZAp">
          <node concept="37vLTI" id="PhFjFi6YFp" role="3clFbG">
            <node concept="37vLTw" id="2BHiRxeuUuR" role="37vLTJ">
              <ref role="3cqZAo" node="PhFjFi6YEh" resolve="myBegin" />
            </node>
            <node concept="37vLTw" id="2BHiRxgm8dn" role="37vLTx">
              <ref role="3cqZAo" node="PhFjFi6YFf" resolve="begin" />
            </node>
          </node>
        </node>
        <node concept="3clFbF" id="PhFjFi6YFs" role="3cqZAp">
          <node concept="37vLTI" id="PhFjFi6YFt" role="3clFbG">
            <node concept="37vLTw" id="2BHiRxeuw_c" role="37vLTJ">
              <ref role="3cqZAo" node="PhFjFi6YEk" resolve="myEnd" />
            </node>
            <node concept="37vLTw" id="2BHiRxgm6nI" role="37vLTx">
              <ref role="3cqZAo" node="PhFjFi6YFh" resolve="end" />
            </node>
          </node>
        </node>
        <node concept="3clFbF" id="PhFjFi6YFw" role="3cqZAp">
          <node concept="37vLTI" id="PhFjFi6YFx" role="3clFbG">
            <node concept="37vLTw" id="2BHiRxeuFk5" role="37vLTJ">
              <ref role="3cqZAo" node="PhFjFi6YEn" resolve="myResultBegin" />
            </node>
            <node concept="37vLTw" id="2BHiRxghgBs" role="37vLTx">
              <ref role="3cqZAo" node="PhFjFi6YFj" resolve="resultBegin" />
            </node>
          </node>
        </node>
        <node concept="3clFbF" id="PhFjFi6YF$" role="3cqZAp">
          <node concept="37vLTI" id="PhFjFi6YF_" role="3clFbG">
            <node concept="37vLTw" id="2BHiRxeukpJ" role="37vLTJ">
              <ref role="3cqZAo" node="PhFjFi6YEq" resolve="myResultEnd" />
            </node>
            <node concept="37vLTw" id="2BHiRxgmtz4" role="37vLTx">
              <ref role="3cqZAo" node="PhFjFi6YFl" resolve="resultEnd" />
            </node>
          </node>
        </node>
      </node>
      <node concept="37vLTG" id="4k3fuHGtdrf" role="3clF46">
        <property role="TrG5h" value="changeSet" />
        <node concept="3uibUv" id="3kRMfhMvhrG" role="1tU5fm">
          <ref role="3uigEE" to="bfxj:3kRMfhMv03j" resolve="ChangeSet" />
        </node>
        <node concept="2AHcQZ" id="2W$ok$XXFDM" role="2AJF6D">
          <ref role="2AI5Lk" to="mhfm:~NotNull" resolve="NotNull" />
        </node>
      </node>
      <node concept="37vLTG" id="4k3fuHGtdrj" role="3clF46">
        <property role="TrG5h" value="parentNodeId" />
        <node concept="2AHcQZ" id="2W$ok$XXFDP" role="2AJF6D">
          <ref role="2AI5Lk" to="mhfm:~NotNull" resolve="NotNull" />
        </node>
        <node concept="3uibUv" id="4k3fuHGtdrk" role="1tU5fm">
          <ref role="3uigEE" to="mhbf:~SNodeId" resolve="SNodeId" />
        </node>
      </node>
      <node concept="37vLTG" id="4k3fuHGtdrs" role="3clF46">
        <property role="TrG5h" value="role" />
        <node concept="2AHcQZ" id="2W$ok$XXFDQ" role="2AJF6D">
          <ref role="2AI5Lk" to="mhfm:~NotNull" resolve="NotNull" />
        </node>
        <node concept="3uibUv" id="58$Pzbkah8B" role="1tU5fm">
          <ref role="3uigEE" to="c17a:~SContainmentLink" resolve="SContainmentLink" />
        </node>
      </node>
      <node concept="37vLTG" id="PhFjFi6YFf" role="3clF46">
        <property role="TrG5h" value="begin" />
        <node concept="10Oyi0" id="PhFjFi6YFg" role="1tU5fm" />
      </node>
      <node concept="37vLTG" id="PhFjFi6YFh" role="3clF46">
        <property role="TrG5h" value="end" />
        <node concept="10Oyi0" id="PhFjFi6YFi" role="1tU5fm" />
      </node>
      <node concept="37vLTG" id="PhFjFi6YFj" role="3clF46">
        <property role="TrG5h" value="resultBegin" />
        <node concept="10Oyi0" id="PhFjFi6YFk" role="1tU5fm" />
      </node>
      <node concept="37vLTG" id="PhFjFi6YFl" role="3clF46">
        <property role="TrG5h" value="resultEnd" />
        <node concept="10Oyi0" id="PhFjFi6YFm" role="1tU5fm" />
      </node>
    </node>
    <node concept="3clFb_" id="4k3fuHGtdr_" role="jymVt">
      <property role="TrG5h" value="getParentNodeId" />
      <node concept="2AHcQZ" id="2W$ok$XXFDR" role="2AJF6D">
        <ref role="2AI5Lk" to="mhfm:~NotNull" resolve="NotNull" />
      </node>
      <node concept="3uibUv" id="4k3fuHGtdrA" role="3clF45">
        <ref role="3uigEE" to="mhbf:~SNodeId" resolve="SNodeId" />
      </node>
      <node concept="3Tm1VV" id="4k3fuHGtdrB" role="1B3o_S" />
      <node concept="3clFbS" id="4k3fuHGtdrC" role="3clF47">
        <node concept="3clFbF" id="4k3fuHGtdrD" role="3cqZAp">
          <node concept="37vLTw" id="2BHiRxeuM$Z" role="3clFbG">
            <ref role="3cqZAo" node="4k3fuHGsETf" resolve="myParentNodeId" />
          </node>
        </node>
      </node>
    </node>
    <node concept="3clFb_" id="3ZTTsGEs2Jc" role="jymVt">
      <property role="TrG5h" value="getParentNodeId" />
      <node concept="2AHcQZ" id="3ZTTsGEs2Jd" role="2AJF6D">
        <ref role="2AI5Lk" to="mhfm:~NotNull" resolve="NotNull" />
      </node>
      <node concept="3uibUv" id="3ZTTsGEs2Je" role="3clF45">
        <ref role="3uigEE" to="mhbf:~SNodeId" resolve="SNodeId" />
      </node>
      <node concept="3Tm1VV" id="3ZTTsGEs2Jf" role="1B3o_S" />
      <node concept="3clFbS" id="3ZTTsGEs2Jg" role="3clF47">
        <node concept="3clFbF" id="3ZTTsGEs2Jh" role="3cqZAp">
          <node concept="37vLTw" id="3ZTTsGEs2Ji" role="3clFbG">
            <ref role="3cqZAo" node="4k3fuHGsETf" resolve="myParentNodeId" />
          </node>
        </node>
      </node>
      <node concept="37vLTG" id="3ZTTsGEs5hx" role="3clF46">
        <property role="TrG5h" value="isNewModel" />
        <node concept="10P_77" id="3ZTTsGEs5hw" role="1tU5fm" />
      </node>
    </node>
    <node concept="3clFb_" id="4k3fuHGtdrF" role="jymVt">
      <property role="TrG5h" value="getRole" />
      <node concept="2AHcQZ" id="2W$ok$XXFDS" role="2AJF6D">
        <ref role="2AI5Lk" to="mhfm:~NotNull" resolve="NotNull" />
      </node>
      <node concept="17QB3L" id="4k3fuHGtdrG" role="3clF45" />
      <node concept="3Tm1VV" id="4k3fuHGtdrH" role="1B3o_S" />
      <node concept="3clFbS" id="4k3fuHGtdrI" role="3clF47">
        <node concept="3clFbF" id="4k3fuHGtdrJ" role="3cqZAp">
          <node concept="2OqwBi" id="58$PzbkaLuE" role="3clFbG">
            <node concept="37vLTw" id="2BHiRxeuR5j" role="2Oq$k0">
              <ref role="3cqZAo" node="4k3fuHGsETj" resolve="myRole" />
            </node>
            <node concept="liA8E" id="58$PzbkaLL1" role="2OqNvi">
              <ref role="37wK5l" to="c17a:~SContainmentLink.getRoleName():java.lang.String" resolve="getRoleName" />
            </node>
          </node>
        </node>
      </node>
    </node>
    <node concept="3clFb_" id="42UviMIl22Z" role="jymVt">
      <property role="1EzhhJ" value="false" />
      <property role="TrG5h" value="getRoleLink" />
      <property role="od$2w" value="false" />
      <property role="DiZV1" value="false" />
      <property role="2aFKle" value="false" />
      <node concept="3clFbS" id="42UviMIl232" role="3clF47">
        <node concept="3clFbF" id="42UviMIl3mq" role="3cqZAp">
          <node concept="37vLTw" id="42UviMIl3mp" role="3clFbG">
            <ref role="3cqZAo" node="4k3fuHGsETj" resolve="myRole" />
          </node>
        </node>
      </node>
      <node concept="3Tm1VV" id="42UviMIl0Ma" role="1B3o_S" />
      <node concept="3uibUv" id="42UviMIl20g" role="3clF45">
        <ref role="3uigEE" to="c17a:~SContainmentLink" resolve="SContainmentLink" />
      </node>
      <node concept="2AHcQZ" id="42UviMIl3pJ" role="2AJF6D">
        <ref role="2AI5Lk" to="mhfm:~NotNull" resolve="NotNull" />
      </node>
    </node>
    <node concept="3clFb_" id="58$PzbkbSxg" role="jymVt">
      <property role="TrG5h" value="isAbout" />
      <node concept="10P_77" id="58$PzbkbWFN" role="3clF45" />
      <node concept="3Tm1VV" id="58$PzbkbSxj" role="1B3o_S" />
      <node concept="3clFbS" id="58$PzbkbSxk" role="3clF47">
        <node concept="3cpWs6" id="58$Pzbkcjvz" role="3cqZAp">
          <node concept="2OqwBi" id="58$PzbkcmUh" role="3cqZAk">
            <node concept="37vLTw" id="58$Pzbkcjw2" role="2Oq$k0">
              <ref role="3cqZAo" node="4k3fuHGsETj" resolve="myRole" />
            </node>
            <node concept="liA8E" id="58$PzbkcqX_" role="2OqNvi">
              <ref role="37wK5l" to="wyt6:~Object.equals(java.lang.Object):boolean" resolve="equals" />
              <node concept="37vLTw" id="58$PzbkcuTm" role="37wK5m">
                <ref role="3cqZAo" node="58$PzbkcfAq" resolve="link" />
              </node>
            </node>
          </node>
        </node>
      </node>
      <node concept="37vLTG" id="58$PzbkcfAq" role="3clF46">
        <property role="TrG5h" value="link" />
        <node concept="3uibUv" id="58$PzbkcfAp" role="1tU5fm">
          <ref role="3uigEE" to="c17a:~SContainmentLink" resolve="SContainmentLink" />
        </node>
      </node>
    </node>
    <node concept="3clFb_" id="PhFjFi6YEP" role="jymVt">
      <property role="TrG5h" value="getBegin" />
      <node concept="10Oyi0" id="PhFjFi6YEQ" role="3clF45" />
      <node concept="3Tm1VV" id="PhFjFi6YER" role="1B3o_S" />
      <node concept="3clFbS" id="PhFjFi6YES" role="3clF47">
        <node concept="3clFbF" id="PhFjFi6YET" role="3cqZAp">
          <node concept="37vLTw" id="2BHiRxeuoR9" role="3clFbG">
            <ref role="3cqZAo" node="PhFjFi6YEh" resolve="myBegin" />
          </node>
        </node>
      </node>
    </node>
    <node concept="3clFb_" id="PhFjFi6YEV" role="jymVt">
      <property role="TrG5h" value="getEnd" />
      <node concept="10Oyi0" id="PhFjFi6YEW" role="3clF45" />
      <node concept="3Tm1VV" id="PhFjFi6YEX" role="1B3o_S" />
      <node concept="3clFbS" id="PhFjFi6YEY" role="3clF47">
        <node concept="3clFbF" id="PhFjFi6YEZ" role="3cqZAp">
          <node concept="37vLTw" id="2BHiRxeuvKj" role="3clFbG">
            <ref role="3cqZAo" node="PhFjFi6YEk" resolve="myEnd" />
          </node>
        </node>
      </node>
    </node>
    <node concept="3clFb_" id="PhFjFi6YF1" role="jymVt">
      <property role="TrG5h" value="getResultEnd" />
      <node concept="10Oyi0" id="PhFjFi6YF2" role="3clF45" />
      <node concept="3Tm1VV" id="PhFjFi6YF3" role="1B3o_S" />
      <node concept="3clFbS" id="PhFjFi6YF4" role="3clF47">
        <node concept="3clFbF" id="PhFjFi6YF5" role="3cqZAp">
          <node concept="37vLTw" id="2BHiRxeuoVl" role="3clFbG">
            <ref role="3cqZAo" node="PhFjFi6YEq" resolve="myResultEnd" />
          </node>
        </node>
      </node>
    </node>
    <node concept="3clFb_" id="PhFjFi6YF7" role="jymVt">
      <property role="TrG5h" value="getResultBegin" />
      <node concept="10Oyi0" id="PhFjFi6YF8" role="3clF45" />
      <node concept="3Tm1VV" id="PhFjFi6YF9" role="1B3o_S" />
      <node concept="3clFbS" id="PhFjFi6YFa" role="3clF47">
        <node concept="3clFbF" id="PhFjFi6YFb" role="3cqZAp">
          <node concept="37vLTw" id="2BHiRxeuynk" role="3clFbG">
            <ref role="3cqZAo" node="PhFjFi6YEn" resolve="myResultBegin" />
          </node>
        </node>
      </node>
    </node>
    <node concept="312cEg" id="7n1vgxsAuLd" role="jymVt">
      <property role="34CwA1" value="false" />
      <property role="eg7rD" value="false" />
      <property role="TrG5h" value="myMergeHint" />
      <property role="3TUv4t" value="false" />
      <node concept="3Tm6S6" id="7n1vgxsAuLe" role="1B3o_S" />
      <node concept="3uibUv" id="7n1vgxsAuLf" role="1tU5fm">
        <ref role="3uigEE" to="mhbf:~SNodeReference" resolve="SNodeReference" />
      </node>
      <node concept="10Nm6u" id="7n1vgxsAuLg" role="33vP2m" />
    </node>
    <node concept="312cEg" id="3BZin2ciAfw" role="jymVt">
      <property role="34CwA1" value="false" />
      <property role="eg7rD" value="false" />
      <property role="TrG5h" value="myMergeHintLoaded" />
      <property role="3TUv4t" value="false" />
      <node concept="3Tm6S6" id="3BZin2ciAfx" role="1B3o_S" />
      <node concept="10P_77" id="6ziFOS4R1Uy" role="1tU5fm" />
      <node concept="3clFbT" id="7n1vgxsAyKw" role="33vP2m">
        <property role="3clFbU" value="false" />
      </node>
    </node>
    <node concept="3clFb_" id="7n1vgxsABm4" role="jymVt">
      <property role="1EzhhJ" value="false" />
      <property role="TrG5h" value="getMergeHint" />
      <property role="od$2w" value="false" />
      <property role="DiZV1" value="false" />
      <property role="2aFKle" value="false" />
      <node concept="3Tm1VV" id="7n1vgxsABm5" role="1B3o_S" />
      <node concept="3uibUv" id="7n1vgxsABm6" role="3clF45">
        <ref role="3uigEE" to="mhbf:~SNodeReference" resolve="SNodeReference" />
      </node>
      <node concept="2AHcQZ" id="7n1vgxsABm7" role="2AJF6D">
        <ref role="2AI5Lk" to="mhfm:~Nullable" resolve="Nullable" />
      </node>
      <node concept="3clFbS" id="7n1vgxsABm8" role="3clF47">
        <node concept="3SKdUt" id="7n1vgxsABm9" role="3cqZAp">
          <node concept="3SKdUq" id="7n1vgxsABma" role="3SKWNk">
            <property role="3SKdUp" value="get &quot;nonconflicting&quot; attribute in metamodel " />
          </node>
        </node>
        <node concept="3clFbJ" id="7n1vgxsABmb" role="3cqZAp">
          <node concept="3fqX7Q" id="7n1vgxsABmc" role="3clFbw">
            <node concept="37vLTw" id="7n1vgxsABmd" role="3fr31v">
              <ref role="3cqZAo" node="3BZin2ciAfw" resolve="myMergeHintLoaded" />
            </node>
          </node>
          <node concept="3clFbS" id="7n1vgxsABme" role="3clFbx">
            <node concept="3clFbF" id="7n1vgxsABmf" role="3cqZAp">
              <node concept="37vLTI" id="7n1vgxsABmg" role="3clFbG">
                <node concept="37vLTw" id="7n1vgxsABmh" role="37vLTJ">
                  <ref role="3cqZAo" node="3BZin2ciAfw" resolve="myMergeHintLoaded" />
                </node>
                <node concept="3clFbT" id="7n1vgxsABmi" role="37vLTx">
                  <property role="3clFbU" value="true" />
                </node>
              </node>
            </node>
            <node concept="3cpWs8" id="7n1vgxsABmj" role="3cqZAp">
              <node concept="3cpWsn" id="7n1vgxsABmk" role="3cpWs9">
                <property role="TrG5h" value="n" />
                <node concept="3Tqbb2" id="7n1vgxsABml" role="1tU5fm" />
                <node concept="1rXfSq" id="3ZTTsGEsskI" role="33vP2m">
                  <ref role="37wK5l" node="3ZTTsGEscp3" resolve="getParent" />
                  <node concept="3clFbT" id="3ZTTsGEsspE" role="37wK5m">
                    <property role="3clFbU" value="false" />
                  </node>
                </node>
              </node>
            </node>
            <node concept="3cpWs8" id="7n1vgxsABmt" role="3cqZAp">
              <node concept="3cpWsn" id="7n1vgxsABmu" role="3cpWs9">
                <property role="TrG5h" value="c" />
                <node concept="3THzug" id="7n1vgxsABmv" role="1tU5fm" />
                <node concept="2OqwBi" id="7n1vgxsABmw" role="33vP2m">
                  <node concept="37vLTw" id="7n1vgxsABmx" role="2Oq$k0">
                    <ref role="3cqZAo" node="7n1vgxsABmk" resolve="n" />
                  </node>
                  <node concept="3NT_Vc" id="7n1vgxsABmy" role="2OqNvi" />
                </node>
              </node>
            </node>
            <node concept="3cpWs8" id="7n1vgxsABmz" role="3cqZAp">
              <node concept="3cpWsn" id="7n1vgxsABm$" role="3cpWs9">
                <property role="TrG5h" value="linkDecl" />
                <node concept="3Tqbb2" id="7n1vgxsABm_" role="1tU5fm">
                  <ref role="ehGHo" to="tpce:f_TJgxE" resolve="LinkDeclaration" />
                </node>
                <node concept="1PxgMI" id="7n1vgxsABmA" role="33vP2m">
                  <property role="1BlNFB" value="true" />
                  <node concept="2OqwBi" id="58$PzbkaLXw" role="1m5AlR">
                    <node concept="37vLTw" id="58$PzbkaLOv" role="2Oq$k0">
                      <ref role="3cqZAo" node="4k3fuHGsETj" resolve="myRole" />
                    </node>
                    <node concept="liA8E" id="58$PzbkaMi$" role="2OqNvi">
                      <ref role="37wK5l" to="c17a:~SContainmentLink.getDeclarationNode():org.jetbrains.mps.openapi.model.SNode" resolve="getDeclarationNode" />
                    </node>
                  </node>
                  <node concept="chp4Y" id="714IaVdGZax" role="3oSUPX">
                    <ref role="cht4Q" to="tpce:f_TJgxE" resolve="LinkDeclaration" />
                  </node>
                </node>
              </node>
            </node>
            <node concept="3cpWs8" id="7n1vgxsABmE" role="3cqZAp">
              <node concept="3cpWsn" id="7n1vgxsABmF" role="3cpWs9">
                <property role="TrG5h" value="hint" />
                <node concept="3Tqbb2" id="7n1vgxsABmG" role="1tU5fm">
                  <ref role="ehGHo" to="6p:6lZ2aXXUNcq" resolve="MergeHint" />
                </node>
                <node concept="2OqwBi" id="7n1vgxsABmH" role="33vP2m">
                  <node concept="37vLTw" id="7n1vgxsABmI" role="2Oq$k0">
                    <ref role="3cqZAo" node="7n1vgxsABm$" resolve="linkDecl" />
                  </node>
                  <node concept="3CFZ6_" id="7n1vgxsABmJ" role="2OqNvi">
                    <node concept="3CFYIy" id="7n1vgxsABmK" role="3CFYIz">
                      <ref role="3CFYIx" to="6p:6lZ2aXXUNcq" resolve="MergeHint" />
                    </node>
                  </node>
                </node>
              </node>
            </node>
            <node concept="3clFbJ" id="7n1vgxsABmL" role="3cqZAp">
              <property role="TyiWK" value="false" />
              <property role="TyiWL" value="true" />
              <node concept="2OqwBi" id="7n1vgxsABmM" role="3clFbw">
                <node concept="37vLTw" id="7n1vgxsABmN" role="2Oq$k0">
                  <ref role="3cqZAo" node="7n1vgxsABmF" resolve="hint" />
                </node>
                <node concept="3w_OXm" id="7n1vgxsABmO" role="2OqNvi" />
              </node>
              <node concept="3clFbS" id="7n1vgxsABmP" role="3clFbx">
                <node concept="3clFbF" id="7n1vgxsABmQ" role="3cqZAp">
                  <node concept="37vLTI" id="7n1vgxsABmR" role="3clFbG">
                    <node concept="2OqwBi" id="7n1vgxsABmS" role="37vLTx">
                      <node concept="37vLTw" id="7n1vgxsABmT" role="2Oq$k0">
                        <ref role="3cqZAo" node="7n1vgxsABmu" resolve="c" />
                      </node>
                      <node concept="3CFZ6_" id="7n1vgxsABmU" role="2OqNvi">
                        <node concept="3CFYIy" id="7n1vgxsABmV" role="3CFYIz">
                          <ref role="3CFYIx" to="6p:6lZ2aXXUNcq" resolve="MergeHint" />
                        </node>
                      </node>
                    </node>
                    <node concept="37vLTw" id="7n1vgxsABmW" role="37vLTJ">
                      <ref role="3cqZAo" node="7n1vgxsABmF" resolve="hint" />
                    </node>
                  </node>
                </node>
              </node>
            </node>
            <node concept="3clFbJ" id="7n1vgxsABmX" role="3cqZAp">
              <node concept="2OqwBi" id="7n1vgxsABmY" role="3clFbw">
                <node concept="37vLTw" id="7n1vgxsABmZ" role="2Oq$k0">
                  <ref role="3cqZAo" node="7n1vgxsABmF" resolve="hint" />
                </node>
                <node concept="3x8VRR" id="7n1vgxsABn0" role="2OqNvi" />
              </node>
              <node concept="3clFbS" id="7n1vgxsABn1" role="3clFbx">
                <node concept="3clFbF" id="7n1vgxsABn2" role="3cqZAp">
                  <node concept="37vLTI" id="7n1vgxsABn3" role="3clFbG">
                    <node concept="2ShNRf" id="7n1vgxsABn4" role="37vLTx">
                      <node concept="1pGfFk" id="7n1vgxsABn5" role="2ShVmc">
                        <ref role="37wK5l" to="w1kc:~SNodePointer.&lt;init&gt;(org.jetbrains.mps.openapi.model.SNode)" resolve="SNodePointer" />
                        <node concept="37vLTw" id="7n1vgxsABn6" role="37wK5m">
                          <ref role="3cqZAo" node="7n1vgxsABmF" resolve="hint" />
                        </node>
                      </node>
                    </node>
                    <node concept="37vLTw" id="7n1vgxsABn7" role="37vLTJ">
                      <ref role="3cqZAo" node="7n1vgxsAuLd" resolve="myMergeHint" />
                    </node>
                  </node>
                </node>
              </node>
            </node>
          </node>
        </node>
        <node concept="3clFbF" id="7n1vgxsABn8" role="3cqZAp">
          <node concept="37vLTw" id="7n1vgxsABn9" role="3clFbG">
            <ref role="3cqZAo" node="7n1vgxsAuLd" resolve="myMergeHint" />
          </node>
        </node>
      </node>
      <node concept="2AHcQZ" id="7n1vgxsABna" role="2AJF6D">
        <ref role="2AI5Lk" to="wyt6:~Override" resolve="Override" />
      </node>
    </node>
    <node concept="3clFb_" id="3ZTTsGEscp3" role="jymVt">
      <property role="1EzhhJ" value="false" />
      <property role="TrG5h" value="getParent" />
      <property role="od$2w" value="false" />
      <property role="DiZV1" value="false" />
      <property role="2aFKle" value="false" />
      <node concept="3clFbS" id="3ZTTsGEscp6" role="3clF47">
        <node concept="3clFbF" id="3ZTTsGEseNE" role="3cqZAp">
          <node concept="2OqwBi" id="3ZTTsGEsflc" role="3clFbG">
            <node concept="2JrnkZ" id="3ZTTsGEsfgc" role="2Oq$k0">
              <node concept="1eOMI4" id="3ZTTsGEsfaF" role="2JrQYb">
                <node concept="3K4zz7" id="3ZTTsGEseQ3" role="1eOMHV">
                  <node concept="2OqwBi" id="3ZTTsGEsf42" role="3K4GZi">
                    <node concept="1rXfSq" id="3ZTTsGEseZS" role="2Oq$k0">
                      <ref role="37wK5l" node="5x0q8wkvS4u" resolve="getChangeSet" />
                    </node>
                    <node concept="liA8E" id="3ZTTsGEsf8G" role="2OqNvi">
                      <ref role="37wK5l" to="bfxj:3kRMfhMv9u3" resolve="getOldModel" />
                    </node>
                  </node>
                  <node concept="2OqwBi" id="3ZTTsGEseUk" role="3K4E3e">
                    <node concept="1rXfSq" id="3ZTTsGEseQT" role="2Oq$k0">
                      <ref role="37wK5l" node="5x0q8wkvS4u" resolve="getChangeSet" />
                    </node>
                    <node concept="liA8E" id="3ZTTsGEseYG" role="2OqNvi">
                      <ref role="37wK5l" to="bfxj:3kRMfhMv9u8" resolve="getNewModel" />
                    </node>
                  </node>
                  <node concept="37vLTw" id="3ZTTsGEseND" role="3K4Cdx">
                    <ref role="3cqZAo" node="3ZTTsGEsdHq" resolve="isNewModel" />
                  </node>
                </node>
              </node>
            </node>
            <node concept="liA8E" id="3ZTTsGEsfon" role="2OqNvi">
              <ref role="37wK5l" to="mhbf:~SModel.getNode(org.jetbrains.mps.openapi.model.SNodeId):org.jetbrains.mps.openapi.model.SNode" resolve="getNode" />
              <node concept="1rXfSq" id="3ZTTsGEsfti" role="37wK5m">
                <ref role="37wK5l" node="3ZTTsGEs2Jc" resolve="getParentNodeId" />
                <node concept="37vLTw" id="3ZTTsGEsfym" role="37wK5m">
                  <ref role="3cqZAo" node="3ZTTsGEsdHq" resolve="isNewModel" />
                </node>
              </node>
            </node>
          </node>
        </node>
      </node>
      <node concept="3Tm6S6" id="3ZTTsGEsb72" role="1B3o_S" />
      <node concept="3Tqbb2" id="3ZTTsGEscmo" role="3clF45" />
      <node concept="37vLTG" id="3ZTTsGEsdHq" role="3clF46">
        <property role="TrG5h" value="isNewModel" />
        <node concept="10P_77" id="3ZTTsGEsdHp" role="1tU5fm" />
      </node>
    </node>
    <node concept="3clFb_" id="PhFjFi7uzM" role="jymVt">
      <property role="TrG5h" value="prepare" />
      <node concept="3cqZAl" id="PhFjFi7uzQ" role="3clF45" />
      <node concept="3clFbS" id="PhFjFi7uzO" role="3clF47">
        <node concept="3clFbJ" id="PhFjFi7uKR" role="3cqZAp">
          <node concept="3clFbC" id="PhFjFi7uKS" role="3clFbw">
            <node concept="37vLTw" id="2BHiRxeumXf" role="3uHU7B">
              <ref role="3cqZAo" node="PhFjFi7uzF" resolve="myPreparedIdsToDelete" />
            </node>
            <node concept="10Nm6u" id="PhFjFi7uKU" role="3uHU7w" />
          </node>
          <node concept="3clFbS" id="PhFjFi7uKV" role="3clFbx">
            <node concept="3cpWs8" id="PhFjFi7uKW" role="3cqZAp">
              <node concept="3cpWsn" id="PhFjFi7uKX" role="3cpWs9">
                <property role="TrG5h" value="parent" />
                <node concept="3uibUv" id="PhFjFi7uKY" role="1tU5fm">
                  <ref role="3uigEE" to="mhbf:~SNode" resolve="SNode" />
                </node>
                <node concept="1rXfSq" id="3ZTTsGEspz7" role="33vP2m">
                  <ref role="37wK5l" node="3ZTTsGEscp3" resolve="getParent" />
                  <node concept="3clFbT" id="3ZTTsGEspM1" role="37wK5m">
                    <property role="3clFbU" value="false" />
                  </node>
                </node>
              </node>
            </node>
            <node concept="1gVbGN" id="PhFjFi7uL6" role="3cqZAp">
              <node concept="3y3z36" id="PhFjFi7uL7" role="1gVkn0">
                <node concept="10Nm6u" id="PhFjFi7uL8" role="3uHU7w" />
                <node concept="37vLTw" id="3GM_nagTxAh" role="3uHU7B">
                  <ref role="3cqZAo" node="PhFjFi7uKX" resolve="parent" />
                </node>
              </node>
            </node>
            <node concept="3clFbH" id="PhFjFi7uLa" role="3cqZAp" />
            <node concept="3cpWs8" id="PhFjFi7uLb" role="3cqZAp">
              <node concept="3cpWsn" id="PhFjFi7uLc" role="3cpWs9">
                <property role="TrG5h" value="children" />
                <node concept="2YIFZM" id="5RC8IUNnpAF" role="33vP2m">
                  <ref role="37wK5l" to="18ew:~IterableUtil.asList(java.lang.Iterable):java.util.List" resolve="asList" />
                  <ref role="1Pybhc" to="18ew:~IterableUtil" resolve="IterableUtil" />
                  <node concept="2OqwBi" id="PhFjFi7uLf" role="37wK5m">
                    <node concept="37vLTw" id="3GM_nagT$bX" role="2Oq$k0">
                      <ref role="3cqZAo" node="PhFjFi7uKX" resolve="parent" />
                    </node>
                    <node concept="liA8E" id="PhFjFi7uLh" role="2OqNvi">
                      <ref role="37wK5l" to="mhbf:~SNode.getChildren(org.jetbrains.mps.openapi.language.SContainmentLink):java.lang.Iterable" resolve="getChildren" />
                      <node concept="37vLTw" id="2BHiRxeudAl" role="37wK5m">
                        <ref role="3cqZAo" node="4k3fuHGsETj" resolve="myRole" />
                      </node>
                    </node>
                  </node>
                </node>
                <node concept="3uibUv" id="PhFjFi7uLd" role="1tU5fm">
                  <ref role="3uigEE" to="33ny:~List" resolve="List" />
                  <node concept="3qUE_q" id="5RC8IUNnpKZ" role="11_B2D">
                    <node concept="3uibUv" id="5RC8IUNnpLc" role="3qUE_r">
                      <ref role="3uigEE" to="mhbf:~SNode" resolve="SNode" />
                    </node>
                  </node>
                </node>
              </node>
            </node>
            <node concept="3clFbF" id="PhFjFi7uLj" role="3cqZAp">
              <node concept="37vLTI" id="PhFjFi7uLk" role="3clFbG">
                <node concept="2ShNRf" id="PhFjFi7uLl" role="37vLTx">
                  <node concept="Tc6Ow" id="PhFjFi7uLm" role="2ShVmc">
                    <node concept="3uibUv" id="PhFjFi7uLn" role="HW$YZ">
                      <ref role="3uigEE" to="mhbf:~SNodeId" resolve="SNodeId" />
                    </node>
                  </node>
                </node>
                <node concept="37vLTw" id="2BHiRxeuktr" role="37vLTJ">
                  <ref role="3cqZAo" node="PhFjFi7uzF" resolve="myPreparedIdsToDelete" />
                </node>
              </node>
            </node>
            <node concept="1Dw8fO" id="PhFjFi7uLp" role="3cqZAp">
              <node concept="3clFbS" id="PhFjFi7uLq" role="2LFqv$">
                <node concept="3clFbF" id="PhFjFi7uLr" role="3cqZAp">
                  <node concept="2OqwBi" id="PhFjFi7uLs" role="3clFbG">
                    <node concept="37vLTw" id="2BHiRxeuNWz" role="2Oq$k0">
                      <ref role="3cqZAo" node="PhFjFi7uzF" resolve="myPreparedIdsToDelete" />
                    </node>
                    <node concept="TSZUe" id="PhFjFi7uLu" role="2OqNvi">
                      <node concept="2OqwBi" id="PhFjFi7uLv" role="25WWJ7">
                        <node concept="liA8E" id="24cAaiUz$iD" role="2OqNvi">
                          <ref role="37wK5l" to="mhbf:~SNode.getNodeId():org.jetbrains.mps.openapi.model.SNodeId" resolve="getNodeId" />
                        </node>
                        <node concept="2OqwBi" id="PhFjFi7uLw" role="2Oq$k0">
                          <node concept="37vLTw" id="3GM_nagTxV9" role="2Oq$k0">
                            <ref role="3cqZAo" node="PhFjFi7uLc" resolve="children" />
                          </node>
                          <node concept="liA8E" id="PhFjFi7uLy" role="2OqNvi">
                            <ref role="37wK5l" to="33ny:~List.get(int):java.lang.Object" resolve="get" />
                            <node concept="37vLTw" id="3GM_nagTtve" role="37wK5m">
                              <ref role="3cqZAo" node="PhFjFi7uL_" resolve="i" />
                            </node>
                          </node>
                        </node>
                      </node>
                    </node>
                  </node>
                </node>
              </node>
              <node concept="3cpWsn" id="PhFjFi7uL_" role="1Duv9x">
                <property role="TrG5h" value="i" />
                <node concept="10Oyi0" id="PhFjFi7uLA" role="1tU5fm" />
                <node concept="37vLTw" id="2BHiRxeunll" role="33vP2m">
                  <ref role="3cqZAo" node="PhFjFi6YEh" resolve="myBegin" />
                </node>
              </node>
              <node concept="3eOVzh" id="PhFjFi7uLC" role="1Dwp0S">
                <node concept="37vLTw" id="2BHiRxeurre" role="3uHU7w">
                  <ref role="3cqZAo" node="PhFjFi6YEk" resolve="myEnd" />
                </node>
                <node concept="37vLTw" id="3GM_nagTvC0" role="3uHU7B">
                  <ref role="3cqZAo" node="PhFjFi7uL_" resolve="i" />
                </node>
              </node>
              <node concept="3uNrnE" id="PhFjFi7uLF" role="1Dwrff">
                <node concept="37vLTw" id="3GM_nagTASX" role="2$L3a6">
                  <ref role="3cqZAo" node="PhFjFi7uL_" resolve="i" />
                </node>
              </node>
            </node>
            <node concept="3clFbF" id="PhFjFi7uLH" role="3cqZAp">
              <node concept="37vLTI" id="PhFjFi7uLI" role="3clFbG">
                <node concept="3K4zz7" id="PhFjFi7uLJ" role="37vLTx">
                  <node concept="10Nm6u" id="PhFjFi7uLK" role="3K4E3e" />
                  <node concept="3clFbC" id="PhFjFi7uLL" role="3K4Cdx">
                    <node concept="3cmrfG" id="PhFjFi7uLM" role="3uHU7w">
                      <property role="3cmrfH" value="0" />
                    </node>
                    <node concept="37vLTw" id="2BHiRxeuPsp" role="3uHU7B">
                      <ref role="3cqZAo" node="PhFjFi6YEh" resolve="myBegin" />
                    </node>
                  </node>
                  <node concept="2OqwBi" id="PhFjFi7uLO" role="3K4GZi">
                    <node concept="liA8E" id="24cAaiUz$hd" role="2OqNvi">
                      <ref role="37wK5l" to="mhbf:~SNode.getNodeId():org.jetbrains.mps.openapi.model.SNodeId" resolve="getNodeId" />
                    </node>
                    <node concept="2OqwBi" id="PhFjFi7uLP" role="2Oq$k0">
                      <node concept="37vLTw" id="3GM_nagTxSK" role="2Oq$k0">
                        <ref role="3cqZAo" node="PhFjFi7uLc" resolve="children" />
                      </node>
                      <node concept="liA8E" id="PhFjFi7uLR" role="2OqNvi">
                        <ref role="37wK5l" to="33ny:~List.get(int):java.lang.Object" resolve="get" />
                        <node concept="3cpWsd" id="PhFjFi7uLS" role="37wK5m">
                          <node concept="3cmrfG" id="PhFjFi7uLT" role="3uHU7w">
                            <property role="3cmrfH" value="1" />
                          </node>
                          <node concept="37vLTw" id="2BHiRxeuDZO" role="3uHU7B">
                            <ref role="3cqZAo" node="PhFjFi6YEh" resolve="myBegin" />
                          </node>
                        </node>
                      </node>
                    </node>
                  </node>
                </node>
                <node concept="37vLTw" id="2BHiRxeukou" role="37vLTJ">
                  <ref role="3cqZAo" node="PhFjFi7uJW" resolve="myPreparedAnchorId" />
                </node>
              </node>
            </node>
          </node>
        </node>
      </node>
      <node concept="3Tm1VV" id="PhFjFi7uzP" role="1B3o_S" />
    </node>
    <node concept="3clFb_" id="2W$ok$XXIew" role="jymVt">
      <property role="TrG5h" value="apply" />
      <node concept="3cqZAl" id="2W$ok$XXIex" role="3clF45" />
      <node concept="3Tm1VV" id="2W$ok$XXIey" role="1B3o_S" />
      <node concept="37vLTG" id="2W$ok$XXIez" role="3clF46">
        <property role="TrG5h" value="model" />
        <node concept="H_c77" id="2W$ok$XXIe$" role="1tU5fm" />
        <node concept="2AHcQZ" id="2W$ok$XXIe_" role="2AJF6D">
          <ref role="2AI5Lk" to="mhfm:~NotNull" resolve="NotNull" />
        </node>
      </node>
      <node concept="37vLTG" id="4YYMSngGbkf" role="3clF46">
        <property role="TrG5h" value="nodeCopier" />
        <node concept="3uibUv" id="4YPlf0PK8wV" role="1tU5fm">
          <ref role="3uigEE" node="69abr3GmYnQ" resolve="NodeCopier" />
        </node>
        <node concept="2AHcQZ" id="4YYMSngGbkh" role="2AJF6D">
          <ref role="2AI5Lk" to="mhfm:~NotNull" resolve="NotNull" />
        </node>
      </node>
      <node concept="3clFbS" id="2W$ok$XXIeA" role="3clF47">
        <node concept="3SKdUt" id="PhFjFi7uNe" role="3cqZAp">
          <node concept="3SKdUq" id="PhFjFi7uNf" role="3SKWNk">
            <property role="3SKdUp" value="delete old nodes" />
          </node>
        </node>
        <node concept="3clFbF" id="PhFjFi7uMP" role="3cqZAp">
          <node concept="1rXfSq" id="4hiugqyyWyY" role="3clFbG">
            <ref role="37wK5l" node="PhFjFi7uzM" resolve="prepare" />
          </node>
        </node>
        <node concept="3clFbF" id="PhFjFi7uMR" role="3cqZAp">
          <node concept="2OqwBi" id="PhFjFi7uMS" role="3clFbG">
            <node concept="37vLTw" id="2BHiRxeufsx" role="2Oq$k0">
              <ref role="3cqZAo" node="PhFjFi7uzF" resolve="myPreparedIdsToDelete" />
            </node>
            <node concept="2es0OD" id="PhFjFi7uMU" role="2OqNvi">
              <node concept="1bVj0M" id="PhFjFi7uMV" role="23t8la">
                <node concept="3clFbS" id="PhFjFi7uMW" role="1bW5cS">
                  <node concept="3clFbF" id="PhFjFi7uMX" role="3cqZAp">
                    <node concept="2OqwBi" id="PhFjFi7uMY" role="3clFbG">
                      <node concept="2OqwBi" id="2n9zn0CqME6" role="2Oq$k0">
                        <node concept="liA8E" id="2n9zn0CqME7" role="2OqNvi">
                          <ref role="37wK5l" to="mhbf:~SModel.getNode(org.jetbrains.mps.openapi.model.SNodeId):org.jetbrains.mps.openapi.model.SNode" resolve="getNode" />
                          <node concept="37vLTw" id="2BHiRxghiN3" role="37wK5m">
                            <ref role="3cqZAo" node="PhFjFi7uMO" resolve="id" />
                          </node>
                        </node>
                        <node concept="2JrnkZ" id="2n9zn0CqME9" role="2Oq$k0">
                          <node concept="37vLTw" id="2BHiRxghfCQ" role="2JrQYb">
                            <ref role="3cqZAo" node="2W$ok$XXIez" resolve="model" />
                          </node>
                        </node>
                      </node>
                      <node concept="liA8E" id="PhFjFi7uN4" role="2OqNvi">
                        <ref role="37wK5l" to="mhbf:~SNode.delete():void" resolve="delete" />
                      </node>
                    </node>
                  </node>
                </node>
                <node concept="Rh6nW" id="PhFjFi7uMO" role="1bW2Oz">
                  <property role="TrG5h" value="id" />
                  <node concept="2jxLKc" id="PhFjFi7uN5" role="1tU5fm" />
                </node>
              </node>
            </node>
          </node>
        </node>
        <node concept="3clFbF" id="PhFjFi7uN6" role="3cqZAp">
          <node concept="37vLTI" id="PhFjFi7uN7" role="3clFbG">
            <node concept="10Nm6u" id="PhFjFi7uN8" role="37vLTx" />
            <node concept="37vLTw" id="2BHiRxeudAY" role="37vLTJ">
              <ref role="3cqZAo" node="PhFjFi7uzF" resolve="myPreparedIdsToDelete" />
            </node>
          </node>
        </node>
        <node concept="3clFbH" id="PhFjFi7uNb" role="3cqZAp" />
        <node concept="3SKdUt" id="PhFjFi7uNh" role="3cqZAp">
          <node concept="3SKdUq" id="PhFjFi7uNi" role="3SKWNk">
            <property role="3SKdUp" value="copy nodes to insert" />
          </node>
        </node>
        <node concept="3cpWs8" id="2W$ok$XXIgq" role="3cqZAp">
          <node concept="3cpWsn" id="2W$ok$XXIgr" role="3cpWs9">
            <property role="TrG5h" value="nodesToAdd" />
            <node concept="_YKpA" id="2W$ok$XXIgu" role="1tU5fm">
              <node concept="3Tqbb2" id="2W$ok$XXIgw" role="_ZDj9" />
            </node>
            <node concept="2ShNRf" id="2W$ok$XXIgy" role="33vP2m">
              <node concept="Tc6Ow" id="2W$ok$XXIgz" role="2ShVmc">
                <node concept="3Tqbb2" id="2W$ok$XXIg$" role="HW$YZ" />
              </node>
            </node>
          </node>
        </node>
        <node concept="3cpWs8" id="2W$ok$XXIhe" role="3cqZAp">
          <node concept="3cpWsn" id="2W$ok$XXIhf" role="3cpWs9">
            <property role="TrG5h" value="newChildren" />
            <node concept="2YIFZM" id="5RC8IUNni8q" role="33vP2m">
              <ref role="37wK5l" to="18ew:~IterableUtil.asList(java.lang.Iterable):java.util.List" resolve="asList" />
              <ref role="1Pybhc" to="18ew:~IterableUtil" resolve="IterableUtil" />
              <node concept="2OqwBi" id="2W$ok$XXIhg" role="37wK5m">
                <node concept="2JrnkZ" id="3ZTTsGEsgPF" role="2Oq$k0">
                  <node concept="1rXfSq" id="42UviMIkALl" role="2JrQYb">
                    <ref role="37wK5l" node="3ZTTsGEscp3" resolve="getParent" />
                    <node concept="3clFbT" id="3ZTTsGEsgik" role="37wK5m">
                      <property role="3clFbU" value="true" />
                    </node>
                  </node>
                </node>
                <node concept="liA8E" id="2W$ok$XXIho" role="2OqNvi">
                  <ref role="37wK5l" to="mhbf:~SNode.getChildren(org.jetbrains.mps.openapi.language.SContainmentLink):java.lang.Iterable" resolve="getChildren" />
                  <node concept="37vLTw" id="2BHiRxeuog9" role="37wK5m">
                    <ref role="3cqZAo" node="4k3fuHGsETj" resolve="myRole" />
                  </node>
                </node>
              </node>
            </node>
            <node concept="3uibUv" id="2W$ok$XXIhc" role="1tU5fm">
              <ref role="3uigEE" to="33ny:~List" resolve="List" />
              <node concept="3qUE_q" id="5RC8IUNniz4" role="11_B2D">
                <node concept="3uibUv" id="3h0hLt2JZSM" role="3qUE_r">
                  <ref role="3uigEE" to="mhbf:~SNode" resolve="SNode" />
                </node>
              </node>
            </node>
          </node>
        </node>
        <node concept="1Dw8fO" id="2W$ok$XXIfN" role="3cqZAp">
          <node concept="3clFbS" id="2W$ok$XXIfO" role="2LFqv$">
            <node concept="3clFbF" id="2W$ok$XXIg_" role="3cqZAp">
              <node concept="2OqwBi" id="2W$ok$XXIgB" role="3clFbG">
                <node concept="37vLTw" id="3GM_nagTv$2" role="2Oq$k0">
                  <ref role="3cqZAo" node="2W$ok$XXIgr" resolve="nodesToAdd" />
                </node>
                <node concept="TSZUe" id="2W$ok$XXIgF" role="2OqNvi">
                  <node concept="2OqwBi" id="4YYMSngGbkk" role="25WWJ7">
                    <node concept="37vLTw" id="2BHiRxgm6bT" role="2Oq$k0">
                      <ref role="3cqZAo" node="4YYMSngGbkf" resolve="nodeCopier" />
                    </node>
                    <node concept="liA8E" id="4YYMSngGbko" role="2OqNvi">
                      <ref role="37wK5l" node="69abr3GmYoe" resolve="copyNode" />
                      <node concept="2OqwBi" id="4YYMSngGbkp" role="37wK5m">
                        <node concept="37vLTw" id="3GM_nagTxY0" role="2Oq$k0">
                          <ref role="3cqZAo" node="2W$ok$XXIhf" resolve="newChildren" />
                        </node>
                        <node concept="liA8E" id="4YYMSngGbkr" role="2OqNvi">
                          <ref role="37wK5l" to="33ny:~List.get(int):java.lang.Object" resolve="get" />
                          <node concept="37vLTw" id="3GM_nagTssV" role="37wK5m">
                            <ref role="3cqZAo" node="2W$ok$XXIfQ" resolve="i" />
                          </node>
                        </node>
                      </node>
                    </node>
                  </node>
                </node>
              </node>
            </node>
          </node>
          <node concept="3cpWsn" id="2W$ok$XXIfQ" role="1Duv9x">
            <property role="TrG5h" value="i" />
            <node concept="10Oyi0" id="2W$ok$XXIfR" role="1tU5fm" />
            <node concept="37vLTw" id="2BHiRxeuFHL" role="33vP2m">
              <ref role="3cqZAo" node="PhFjFi6YEn" resolve="myResultBegin" />
            </node>
          </node>
          <node concept="3eOVzh" id="2W$ok$XXIfV" role="1Dwp0S">
            <node concept="37vLTw" id="2BHiRxeulwS" role="3uHU7w">
              <ref role="3cqZAo" node="PhFjFi6YEq" resolve="myResultEnd" />
            </node>
            <node concept="37vLTw" id="3GM_nagTwM8" role="3uHU7B">
              <ref role="3cqZAo" node="2W$ok$XXIfQ" resolve="i" />
            </node>
          </node>
          <node concept="3uNrnE" id="2W$ok$XXIgb" role="1Dwrff">
            <node concept="37vLTw" id="3GM_nagT_eX" role="2$L3a6">
              <ref role="3cqZAo" node="2W$ok$XXIfQ" resolve="i" />
            </node>
          </node>
        </node>
        <node concept="3clFbH" id="PhFjFi7uNc" role="3cqZAp" />
        <node concept="3SKdUt" id="PhFjFi7uNk" role="3cqZAp">
          <node concept="3SKdUq" id="PhFjFi7uNl" role="3SKWNk">
            <property role="3SKdUp" value="insert new nodes" />
          </node>
        </node>
        <node concept="3cpWs8" id="2W$ok$XXIeE" role="3cqZAp">
          <node concept="3cpWsn" id="2W$ok$XXIeF" role="3cpWs9">
            <property role="TrG5h" value="anchor" />
            <node concept="3Tqbb2" id="2W$ok$XXIeG" role="1tU5fm" />
            <node concept="3K4zz7" id="PhFjFi7uMA" role="33vP2m">
              <node concept="2OqwBi" id="2n9zn0CqMBz" role="3K4GZi">
                <node concept="liA8E" id="2n9zn0CqMB$" role="2OqNvi">
                  <ref role="37wK5l" to="mhbf:~SModel.getNode(org.jetbrains.mps.openapi.model.SNodeId):org.jetbrains.mps.openapi.model.SNode" resolve="getNode" />
                  <node concept="37vLTw" id="2BHiRxeuyXh" role="37wK5m">
                    <ref role="3cqZAo" node="PhFjFi7uJW" resolve="myPreparedAnchorId" />
                  </node>
                </node>
                <node concept="2JrnkZ" id="2n9zn0CqMBA" role="2Oq$k0">
                  <node concept="37vLTw" id="2BHiRxghgko" role="2JrQYb">
                    <ref role="3cqZAo" node="2W$ok$XXIez" resolve="model" />
                  </node>
                </node>
              </node>
              <node concept="10Nm6u" id="PhFjFi7uMB" role="3K4E3e" />
              <node concept="3clFbC" id="PhFjFi7uMH" role="3K4Cdx">
                <node concept="10Nm6u" id="PhFjFi7uMI" role="3uHU7w" />
                <node concept="37vLTw" id="2BHiRxeuPaq" role="3uHU7B">
                  <ref role="3cqZAo" node="PhFjFi7uJW" resolve="myPreparedAnchorId" />
                </node>
              </node>
            </node>
          </node>
        </node>
        <node concept="3cpWs8" id="2W$ok$XXIeK" role="3cqZAp">
          <node concept="3cpWsn" id="2W$ok$XXIeL" role="3cpWs9">
            <property role="TrG5h" value="parent" />
            <node concept="2OqwBi" id="2n9zn0CqMEb" role="33vP2m">
              <node concept="liA8E" id="2n9zn0CqMEc" role="2OqNvi">
                <ref role="37wK5l" to="mhbf:~SModel.getNode(org.jetbrains.mps.openapi.model.SNodeId):org.jetbrains.mps.openapi.model.SNode" resolve="getNode" />
                <node concept="37vLTw" id="2BHiRxeuoVp" role="37wK5m">
                  <ref role="3cqZAo" node="4k3fuHGsETf" resolve="myParentNodeId" />
                </node>
              </node>
              <node concept="2JrnkZ" id="2n9zn0CqMEe" role="2Oq$k0">
                <node concept="37vLTw" id="2BHiRxglK_3" role="2JrQYb">
                  <ref role="3cqZAo" node="2W$ok$XXIez" resolve="model" />
                </node>
              </node>
            </node>
            <node concept="3Tqbb2" id="2W$ok$XXIeM" role="1tU5fm" />
          </node>
        </node>
        <node concept="3clFbJ" id="3qaUGgZZV3c" role="3cqZAp">
          <node concept="3clFbS" id="3qaUGgZZV3e" role="3clFbx">
            <node concept="3SKdUt" id="3LC5F5NmkCF" role="3cqZAp">
              <node concept="3SKdUq" id="3LC5F5NmkCO" role="3SKWNk">
                <property role="3SKdUp" value="can't use anchor.next-sibling here as it looks for sibling with respect to node's containment role" />
              </node>
            </node>
            <node concept="3SKdUt" id="3LC5F5NmkDy" role="3cqZAp">
              <node concept="3SKdUq" id="3LC5F5NmkDH" role="3SKWNk">
                <property role="3SKdUp" value="while there are tests (MergeCoreTest) that expect ordering according overall children list" />
              </node>
            </node>
            <node concept="3clFbF" id="3qaUGgZZVVz" role="3cqZAp">
              <node concept="37vLTI" id="3qaUGgZZW42" role="3clFbG">
                <node concept="2OqwBi" id="3qaUGgZZW6H" role="37vLTx">
                  <node concept="2JrnkZ" id="3LC5F5Nml23" role="2Oq$k0">
                    <node concept="37vLTw" id="3qaUGgZZW5d" role="2JrQYb">
                      <ref role="3cqZAo" node="2W$ok$XXIeF" resolve="anchor" />
                    </node>
                  </node>
                  <node concept="liA8E" id="3LC5F5NmlA6" role="2OqNvi">
                    <ref role="37wK5l" to="mhbf:~SNode.getNextSibling():org.jetbrains.mps.openapi.model.SNode" resolve="getNextSibling" />
                  </node>
                </node>
                <node concept="37vLTw" id="3qaUGgZZVVx" role="37vLTJ">
                  <ref role="3cqZAo" node="2W$ok$XXIeF" resolve="anchor" />
                </node>
              </node>
            </node>
          </node>
          <node concept="3y3z36" id="3qaUGgZZVJv" role="3clFbw">
            <node concept="10Nm6u" id="3qaUGgZZVUJ" role="3uHU7w" />
            <node concept="37vLTw" id="3qaUGgZZVxt" role="3uHU7B">
              <ref role="3cqZAo" node="2W$ok$XXIeF" resolve="anchor" />
            </node>
          </node>
          <node concept="9aQIb" id="1oJRhVR8$ZN" role="9aQIa">
            <node concept="3clFbS" id="1oJRhVR8$ZO" role="9aQI4">
              <node concept="3SKdUt" id="1oJRhVR8QGI" role="3cqZAp">
                <node concept="3SKdUq" id="1oJRhVR8QQQ" role="3SKWNk">
                  <property role="3SKdUp" value="MergeCoreTest expects nodes without anchor to go first" />
                </node>
              </node>
              <node concept="3clFbF" id="1oJRhVR8AFm" role="3cqZAp">
                <node concept="37vLTI" id="1oJRhVR8B33" role="3clFbG">
                  <node concept="2OqwBi" id="1oJRhVR8CFS" role="37vLTx">
                    <node concept="2JrnkZ" id="1oJRhVR8Puo" role="2Oq$k0">
                      <node concept="37vLTw" id="1oJRhVR8CEn" role="2JrQYb">
                        <ref role="3cqZAo" node="2W$ok$XXIeL" resolve="parent" />
                      </node>
                    </node>
                    <node concept="liA8E" id="1oJRhVR8Q2I" role="2OqNvi">
                      <ref role="37wK5l" to="mhbf:~SNode.getFirstChild():org.jetbrains.mps.openapi.model.SNode" resolve="getFirstChild" />
                    </node>
                  </node>
                  <node concept="37vLTw" id="1oJRhVR8AFl" role="37vLTJ">
                    <ref role="3cqZAo" node="2W$ok$XXIeF" resolve="anchor" />
                  </node>
                </node>
              </node>
            </node>
          </node>
        </node>
        <node concept="2Gpval" id="2W$ok$XXIic" role="3cqZAp">
          <node concept="2GrKxI" id="2W$ok$XXIid" role="2Gsz3X">
            <property role="TrG5h" value="newNode" />
          </node>
          <node concept="37vLTw" id="3GM_nagTzAP" role="2GsD0m">
            <ref role="3cqZAo" node="2W$ok$XXIgr" resolve="nodesToAdd" />
          </node>
          <node concept="3clFbS" id="2W$ok$XXIif" role="2LFqv$">
            <node concept="3clFbF" id="3qaUGgZZSZW" role="3cqZAp">
              <node concept="2OqwBi" id="3qaUGgZZT9d" role="3clFbG">
                <node concept="2JrnkZ" id="3qaUGgZZTxi" role="2Oq$k0">
                  <node concept="37vLTw" id="3qaUGgZZSZU" role="2JrQYb">
                    <ref role="3cqZAo" node="2W$ok$XXIeL" resolve="parent" />
                  </node>
                </node>
                <node concept="liA8E" id="3qaUGgZZTBF" role="2OqNvi">
                  <ref role="37wK5l" to="mhbf:~SNode.insertChildBefore(org.jetbrains.mps.openapi.language.SContainmentLink,org.jetbrains.mps.openapi.model.SNode,org.jetbrains.mps.openapi.model.SNode):void" resolve="insertChildBefore" />
                  <node concept="37vLTw" id="3qaUGgZZTCS" role="37wK5m">
                    <ref role="3cqZAo" node="4k3fuHGsETj" resolve="myRole" />
                  </node>
                  <node concept="2GrUjf" id="3qaUGgZZTHo" role="37wK5m">
                    <ref role="2Gs0qQ" node="2W$ok$XXIid" resolve="newNode" />
                  </node>
                  <node concept="37vLTw" id="3qaUGgZZWwJ" role="37wK5m">
                    <ref role="3cqZAo" node="2W$ok$XXIeF" resolve="anchor" />
                  </node>
                </node>
              </node>
            </node>
          </node>
        </node>
      </node>
      <node concept="2AHcQZ" id="3tYsUK_SicM" role="2AJF6D">
        <ref role="2AI5Lk" to="wyt6:~Override" resolve="Override" />
      </node>
    </node>
    <node concept="3clFb_" id="3RcDWS$m2E8" role="jymVt">
      <property role="TrG5h" value="getRootId" />
      <node concept="3uibUv" id="3RcDWS$m2E9" role="3clF45">
        <ref role="3uigEE" to="mhbf:~SNodeId" resolve="SNodeId" />
      </node>
      <node concept="3Tm1VV" id="3RcDWS$m2Ea" role="1B3o_S" />
      <node concept="2AHcQZ" id="3RcDWS$m2Eb" role="2AJF6D">
        <ref role="2AI5Lk" to="mhfm:~Nullable" resolve="Nullable" />
      </node>
      <node concept="3clFbS" id="3RcDWS$m2Ec" role="3clF47">
        <node concept="3clFbF" id="3RcDWS$m2Ek" role="3cqZAp">
          <node concept="2OqwBi" id="3ZTTsGEsfZB" role="3clFbG">
            <node concept="2JrnkZ" id="3ZTTsGEsfT3" role="2Oq$k0">
              <node concept="2OqwBi" id="3ZTTsGEsfJ2" role="2JrQYb">
                <node concept="1rXfSq" id="42UviMIkEJI" role="2Oq$k0">
                  <ref role="37wK5l" node="3ZTTsGEscp3" resolve="getParent" />
                  <node concept="3clFbT" id="3ZTTsGEsfDv" role="37wK5m">
                    <property role="3clFbU" value="false" />
                  </node>
                </node>
                <node concept="2Rxl7S" id="3ZTTsGEsfPm" role="2OqNvi" />
              </node>
            </node>
            <node concept="liA8E" id="3ZTTsGEsg6r" role="2OqNvi">
              <ref role="37wK5l" to="mhbf:~SNode.getNodeId():org.jetbrains.mps.openapi.model.SNodeId" resolve="getNodeId" />
            </node>
          </node>
        </node>
      </node>
      <node concept="2AHcQZ" id="3RcDWS$m2Ed" role="2AJF6D">
        <ref role="2AI5Lk" to="wyt6:~Override" resolve="Override" />
      </node>
    </node>
    <node concept="3clFb_" id="PhFjFi6VsK" role="jymVt">
      <property role="1EzhhJ" value="false" />
      <property role="TrG5h" value="getType" />
      <node concept="3uibUv" id="PhFjFi6VsL" role="3clF45">
        <ref role="3uigEE" node="7inhnIFBpHM" resolve="ChangeType" />
      </node>
      <node concept="3Tm1VV" id="PhFjFi6VsM" role="1B3o_S" />
      <node concept="3clFbS" id="PhFjFi6VsN" role="3clF47">
        <node concept="3clFbJ" id="PhFjFi6VsV" role="3cqZAp">
          <node concept="3clFbS" id="PhFjFi6VsW" role="3clFbx">
            <node concept="3cpWs6" id="PhFjFi6Vt5" role="3cqZAp">
              <node concept="Rm8GO" id="PhFjFi6Vt8" role="3cqZAk">
                <ref role="Rm8GQ" node="7inhnIFBpHO" resolve="ADD" />
                <ref role="1Px2BO" node="7inhnIFBpHM" resolve="ChangeType" />
              </node>
            </node>
          </node>
          <node concept="3clFbC" id="PhFjFi6Vt1" role="3clFbw">
            <node concept="37vLTw" id="2BHiRxeuTxS" role="3uHU7w">
              <ref role="3cqZAo" node="PhFjFi6YEk" resolve="myEnd" />
            </node>
            <node concept="37vLTw" id="2BHiRxeuvKR" role="3uHU7B">
              <ref role="3cqZAo" node="PhFjFi6YEh" resolve="myBegin" />
            </node>
          </node>
        </node>
        <node concept="3clFbJ" id="PhFjFi6Vta" role="3cqZAp">
          <node concept="3clFbS" id="PhFjFi6Vtb" role="3clFbx">
            <node concept="3cpWs6" id="PhFjFi6Vtj" role="3cqZAp">
              <node concept="Rm8GO" id="PhFjFi6Vtm" role="3cqZAk">
                <ref role="Rm8GQ" node="7inhnIFBpHU" resolve="DELETE" />
                <ref role="1Px2BO" node="7inhnIFBpHM" resolve="ChangeType" />
              </node>
            </node>
          </node>
          <node concept="3clFbC" id="PhFjFi6Vtf" role="3clFbw">
            <node concept="37vLTw" id="2BHiRxeuvK9" role="3uHU7w">
              <ref role="3cqZAo" node="PhFjFi6YEq" resolve="myResultEnd" />
            </node>
            <node concept="37vLTw" id="2BHiRxeuq9w" role="3uHU7B">
              <ref role="3cqZAo" node="PhFjFi6YEn" resolve="myResultBegin" />
            </node>
          </node>
        </node>
        <node concept="3cpWs6" id="PhFjFi6YCR" role="3cqZAp">
          <node concept="Rm8GO" id="PhFjFi6YCU" role="3cqZAk">
            <ref role="Rm8GQ" node="7inhnIFBpI0" resolve="CHANGE" />
            <ref role="1Px2BO" node="7inhnIFBpHM" resolve="ChangeType" />
          </node>
        </node>
      </node>
      <node concept="2AHcQZ" id="5Gi8bfMdBnD" role="2AJF6D">
        <ref role="2AI5Lk" to="mhfm:~NotNull" resolve="NotNull" />
      </node>
      <node concept="2AHcQZ" id="3tYsUK_SicI" role="2AJF6D">
        <ref role="2AI5Lk" to="wyt6:~Override" resolve="Override" />
      </node>
    </node>
    <node concept="3clFb_" id="PhFjFi6YDb" role="jymVt">
      <property role="1EzhhJ" value="false" />
      <property role="TrG5h" value="toString" />
      <node concept="3Tm1VV" id="PhFjFi6YDc" role="1B3o_S" />
      <node concept="17QB3L" id="PhFjFi6YDi" role="3clF45" />
      <node concept="3clFbS" id="PhFjFi6YDe" role="3clF47">
        <node concept="3clFbJ" id="PhFjFi6YDn" role="3cqZAp">
          <node concept="3clFbS" id="PhFjFi6YDo" role="3clFbx">
            <node concept="3cpWs6" id="PhFjFi6YDp" role="3cqZAp">
              <node concept="2YIFZM" id="PhFjFi6YDE" role="3cqZAk">
                <ref role="37wK5l" to="wyt6:~String.format(java.lang.String,java.lang.Object...):java.lang.String" resolve="format" />
                <ref role="1Pybhc" to="wyt6:~String" resolve="String" />
                <node concept="Xl_RD" id="PhFjFi6YDF" role="37wK5m">
                  <property role="Xl_RC" value="Insert %s into position #%d in role %s of node %s" />
                </node>
                <node concept="1rXfSq" id="4hiugqysiCq" role="37wK5m">
                  <ref role="37wK5l" node="7bcsw60G6XG" resolve="nodeRange" />
                  <node concept="37vLTw" id="2BHiRxeunde" role="37wK5m">
                    <ref role="3cqZAo" node="PhFjFi6YEn" resolve="myResultBegin" />
                  </node>
                  <node concept="37vLTw" id="2BHiRxeuWTH" role="37wK5m">
                    <ref role="3cqZAo" node="PhFjFi6YEq" resolve="myResultEnd" />
                  </node>
                </node>
                <node concept="37vLTw" id="2BHiRxeus$$" role="37wK5m">
                  <ref role="3cqZAo" node="PhFjFi6YEh" resolve="myBegin" />
                </node>
                <node concept="37vLTw" id="2BHiRxeuIyX" role="37wK5m">
                  <ref role="3cqZAo" node="4k3fuHGsETj" resolve="myRole" />
                </node>
                <node concept="37vLTw" id="2BHiRxeul72" role="37wK5m">
                  <ref role="3cqZAo" node="4k3fuHGsETf" resolve="myParentNodeId" />
                </node>
              </node>
            </node>
          </node>
          <node concept="3clFbC" id="PhFjFi6YDr" role="3clFbw">
            <node concept="37vLTw" id="2BHiRxeuM_6" role="3uHU7w">
              <ref role="3cqZAo" node="PhFjFi6YEh" resolve="myBegin" />
            </node>
            <node concept="37vLTw" id="2BHiRxeuFHv" role="3uHU7B">
              <ref role="3cqZAo" node="PhFjFi6YEk" resolve="myEnd" />
            </node>
          </node>
        </node>
        <node concept="3clFbJ" id="PhFjFi6YDu" role="3cqZAp">
          <node concept="3clFbS" id="PhFjFi6YDv" role="3clFbx">
            <node concept="3cpWs6" id="PhFjFi6YDw" role="3cqZAp">
              <node concept="2YIFZM" id="PhFjFi6YDP" role="3cqZAk">
                <ref role="1Pybhc" to="wyt6:~String" resolve="String" />
                <ref role="37wK5l" to="wyt6:~String.format(java.lang.String,java.lang.Object...):java.lang.String" resolve="format" />
                <node concept="Xl_RD" id="PhFjFi6YDQ" role="37wK5m">
                  <property role="Xl_RC" value="Delete %s in role %s of node %s" />
                </node>
                <node concept="1rXfSq" id="4hiugqysrp6" role="37wK5m">
                  <ref role="37wK5l" node="7bcsw60G6XG" resolve="nodeRange" />
                  <node concept="37vLTw" id="2BHiRxeuoMw" role="37wK5m">
                    <ref role="3cqZAo" node="PhFjFi6YEh" resolve="myBegin" />
                  </node>
                  <node concept="37vLTw" id="2BHiRxeujUc" role="37wK5m">
                    <ref role="3cqZAo" node="PhFjFi6YEk" resolve="myEnd" />
                  </node>
                </node>
                <node concept="37vLTw" id="2BHiRxeudes" role="37wK5m">
                  <ref role="3cqZAo" node="4k3fuHGsETj" resolve="myRole" />
                </node>
                <node concept="37vLTw" id="2BHiRxeuoZR" role="37wK5m">
                  <ref role="3cqZAo" node="4k3fuHGsETf" resolve="myParentNodeId" />
                </node>
              </node>
            </node>
          </node>
          <node concept="3clFbC" id="PhFjFi6YDy" role="3clFbw">
            <node concept="37vLTw" id="2BHiRxeuL5J" role="3uHU7w">
              <ref role="3cqZAo" node="PhFjFi6YEn" resolve="myResultBegin" />
            </node>
            <node concept="37vLTw" id="2BHiRxeu_m5" role="3uHU7B">
              <ref role="3cqZAo" node="PhFjFi6YEq" resolve="myResultEnd" />
            </node>
          </node>
        </node>
        <node concept="3cpWs6" id="PhFjFi6YD_" role="3cqZAp">
          <node concept="2YIFZM" id="PhFjFi6YDY" role="3cqZAk">
            <ref role="37wK5l" to="wyt6:~String.format(java.lang.String,java.lang.Object...):java.lang.String" resolve="format" />
            <ref role="1Pybhc" to="wyt6:~String" resolve="String" />
            <node concept="Xl_RD" id="PhFjFi6YDZ" role="37wK5m">
              <property role="Xl_RC" value="Replace %s with nodes %s in role %s of node %s" />
            </node>
            <node concept="1rXfSq" id="4hiugqysuvO" role="37wK5m">
              <ref role="37wK5l" node="7bcsw60G6XG" resolve="nodeRange" />
              <node concept="37vLTw" id="2BHiRxeuq40" role="37wK5m">
                <ref role="3cqZAo" node="PhFjFi6YEh" resolve="myBegin" />
              </node>
              <node concept="37vLTw" id="2BHiRxeuoZ2" role="37wK5m">
                <ref role="3cqZAo" node="PhFjFi6YEk" resolve="myEnd" />
              </node>
            </node>
            <node concept="1rXfSq" id="4hiugqysr1k" role="37wK5m">
              <ref role="37wK5l" node="7bcsw60G6XG" resolve="nodeRange" />
              <node concept="37vLTw" id="2BHiRxeuE2v" role="37wK5m">
                <ref role="3cqZAo" node="PhFjFi6YEn" resolve="myResultBegin" />
              </node>
              <node concept="37vLTw" id="2BHiRxeuyLz" role="37wK5m">
                <ref role="3cqZAo" node="PhFjFi6YEq" resolve="myResultEnd" />
              </node>
            </node>
            <node concept="37vLTw" id="2BHiRxeu_C_" role="37wK5m">
              <ref role="3cqZAo" node="4k3fuHGsETj" resolve="myRole" />
            </node>
            <node concept="37vLTw" id="2BHiRxeuta1" role="37wK5m">
              <ref role="3cqZAo" node="4k3fuHGsETf" resolve="myParentNodeId" />
            </node>
          </node>
        </node>
      </node>
      <node concept="2AHcQZ" id="PhFjFi6YDf" role="2AJF6D">
        <ref role="2AI5Lk" to="wyt6:~Override" resolve="Override" />
      </node>
    </node>
    <node concept="3clFb_" id="51cMXQKRj5u" role="jymVt">
      <property role="1EzhhJ" value="false" />
      <property role="TrG5h" value="getDescription" />
      <node concept="17QB3L" id="51cMXQKRj5v" role="3clF45" />
      <node concept="3Tm1VV" id="51cMXQKRj5w" role="1B3o_S" />
      <node concept="3clFbS" id="51cMXQKRj5x" role="3clF47">
        <node concept="3clFbF" id="52JQx_XoJgf" role="3cqZAp">
          <node concept="1rXfSq" id="4hiugqyyIjc" role="3clFbG">
            <ref role="37wK5l" node="52JQx_XoJdM" resolve="getDescription" />
            <node concept="3clFbT" id="52JQx_XoJgh" role="37wK5m">
              <property role="3clFbU" value="true" />
            </node>
          </node>
        </node>
      </node>
      <node concept="2AHcQZ" id="3tYsUK_SicC" role="2AJF6D">
        <ref role="2AI5Lk" to="wyt6:~Override" resolve="Override" />
      </node>
    </node>
    <node concept="3clFb_" id="52JQx_XoJdM" role="jymVt">
      <property role="1EzhhJ" value="false" />
      <property role="TrG5h" value="getDescription" />
      <node concept="17QB3L" id="52JQx_XoJdN" role="3clF45" />
      <node concept="3Tm1VV" id="52JQx_XoJdO" role="1B3o_S" />
      <node concept="3clFbS" id="52JQx_XoJdP" role="3clF47">
        <node concept="3cpWs8" id="52JQx_XoJdQ" role="3cqZAp">
          <node concept="3cpWsn" id="52JQx_XoJdR" role="3cpWs9">
            <property role="TrG5h" value="newChildren" />
            <node concept="_YKpA" id="52JQx_XoJdS" role="1tU5fm">
              <node concept="3Tqbb2" id="3ZTTsGEsjao" role="_ZDj9" />
            </node>
            <node concept="10Nm6u" id="52JQx_XoJg8" role="33vP2m" />
          </node>
        </node>
        <node concept="3cpWs8" id="52JQx_XoJe4" role="3cqZAp">
          <node concept="3cpWsn" id="52JQx_XoJe5" role="3cpWs9">
            <property role="TrG5h" value="newIds" />
            <node concept="17QB3L" id="52JQx_XoJe6" role="1tU5fm" />
            <node concept="10Nm6u" id="52JQx_XoJg6" role="33vP2m" />
          </node>
        </node>
        <node concept="3clFbJ" id="52JQx_XoJfU" role="3cqZAp">
          <node concept="3clFbS" id="52JQx_XoJfV" role="3clFbx">
            <node concept="3clFbF" id="52JQx_XoJfZ" role="3cqZAp">
              <node concept="37vLTI" id="52JQx_XoJg0" role="3clFbG">
                <node concept="2YIFZM" id="5RC8IUNmsCy" role="37vLTx">
                  <ref role="37wK5l" to="18ew:~IterableUtil.asList(java.lang.Iterable):java.util.List" resolve="asList" />
                  <ref role="1Pybhc" to="18ew:~IterableUtil" resolve="IterableUtil" />
                  <node concept="2OqwBi" id="52JQx_XoJdU" role="37wK5m">
                    <node concept="2JrnkZ" id="3ZTTsGEshkF" role="2Oq$k0">
                      <node concept="1rXfSq" id="42UviMIkAZ2" role="2JrQYb">
                        <ref role="37wK5l" node="3ZTTsGEscp3" resolve="getParent" />
                        <node concept="3clFbT" id="3ZTTsGEshck" role="37wK5m">
                          <property role="3clFbU" value="true" />
                        </node>
                      </node>
                    </node>
                    <node concept="liA8E" id="52JQx_XoJe2" role="2OqNvi">
                      <ref role="37wK5l" to="mhbf:~SNode.getChildren(org.jetbrains.mps.openapi.language.SContainmentLink):java.lang.Iterable" resolve="getChildren" />
                      <node concept="37vLTw" id="2BHiRxeujTe" role="37wK5m">
                        <ref role="3cqZAo" node="4k3fuHGsETj" resolve="myRole" />
                      </node>
                    </node>
                  </node>
                </node>
                <node concept="37vLTw" id="3GM_nagT_b3" role="37vLTJ">
                  <ref role="3cqZAo" node="52JQx_XoJdR" resolve="newChildren" />
                </node>
              </node>
            </node>
            <node concept="3clFbF" id="52JQx_XoJg2" role="3cqZAp">
              <node concept="37vLTI" id="52JQx_XoJg3" role="3clFbG">
                <node concept="2OqwBi" id="52JQx_XoJe7" role="37vLTx">
                  <node concept="2OqwBi" id="52JQx_XoJe8" role="2Oq$k0">
                    <node concept="2OqwBi" id="52JQx_XoJe9" role="2Oq$k0">
                      <node concept="37vLTw" id="3GM_nagTskH" role="2Oq$k0">
                        <ref role="3cqZAo" node="52JQx_XoJdR" resolve="newChildren" />
                      </node>
                      <node concept="8snch" id="52JQx_XoJeb" role="2OqNvi">
                        <node concept="37vLTw" id="2BHiRxeuW3u" role="8sqot">
                          <ref role="3cqZAo" node="PhFjFi6YEn" resolve="myResultBegin" />
                        </node>
                        <node concept="37vLTw" id="2BHiRxeuuZb" role="8st4g">
                          <ref role="3cqZAo" node="PhFjFi6YEq" resolve="myResultEnd" />
                        </node>
                      </node>
                    </node>
                    <node concept="3$u5V9" id="52JQx_XoJee" role="2OqNvi">
                      <node concept="1bVj0M" id="52JQx_XoJef" role="23t8la">
                        <node concept="3clFbS" id="52JQx_XoJeg" role="1bW5cS">
                          <node concept="3clFbF" id="52JQx_XoJeh" role="3cqZAp">
                            <node concept="3cpWs3" id="52JQx_XoJei" role="3clFbG">
                              <node concept="Xl_RD" id="52JQx_XoJej" role="3uHU7B">
                                <property role="Xl_RC" value="#" />
                              </node>
                              <node concept="2OqwBi" id="52JQx_XoJek" role="3uHU7w">
                                <node concept="liA8E" id="24cAaiUz$mh" role="2OqNvi">
                                  <ref role="37wK5l" to="mhbf:~SNode.getNodeId():org.jetbrains.mps.openapi.model.SNodeId" resolve="getNodeId" />
                                </node>
                                <node concept="2JrnkZ" id="3ZTTsGEsk8G" role="2Oq$k0">
                                  <node concept="37vLTw" id="2BHiRxghfZj" role="2JrQYb">
                                    <ref role="3cqZAo" node="52JQx_XoJen" resolve="n" />
                                  </node>
                                </node>
                              </node>
                            </node>
                          </node>
                        </node>
                        <node concept="Rh6nW" id="52JQx_XoJen" role="1bW2Oz">
                          <property role="TrG5h" value="n" />
                          <node concept="2jxLKc" id="52JQx_XoJeo" role="1tU5fm" />
                        </node>
                      </node>
                    </node>
                  </node>
                  <node concept="3uJxvA" id="52JQx_XoJep" role="2OqNvi">
                    <node concept="Xl_RD" id="52JQx_XoJeq" role="3uJOhx">
                      <property role="Xl_RC" value=", " />
                    </node>
                  </node>
                </node>
                <node concept="37vLTw" id="3GM_nagTtfy" role="37vLTJ">
                  <ref role="3cqZAo" node="52JQx_XoJe5" resolve="newIds" />
                </node>
              </node>
            </node>
          </node>
          <node concept="37vLTw" id="2BHiRxgmkE3" role="3clFbw">
            <ref role="3cqZAo" node="52JQx_XoJfR" resolve="verbose" />
          </node>
        </node>
        <node concept="3clFbH" id="52JQx_XoJer" role="3cqZAp" />
        <node concept="3cpWs8" id="52JQx_XoJes" role="3cqZAp">
          <node concept="3cpWsn" id="52JQx_XoJet" role="3cpWs9">
            <property role="TrG5h" value="oldStuff" />
            <node concept="17QB3L" id="52JQx_XoJeu" role="1tU5fm" />
            <node concept="3K4zz7" id="52JQx_XoJev" role="33vP2m">
              <node concept="1rXfSq" id="58$PzbkaPE7" role="3K4E3e">
                <ref role="37wK5l" node="4k3fuHGtdrF" resolve="getRole" />
              </node>
              <node concept="3clFbC" id="52JQx_XoJex" role="3K4Cdx">
                <node concept="3cmrfG" id="52JQx_XoJey" role="3uHU7w">
                  <property role="3cmrfH" value="1" />
                </node>
                <node concept="3cpWsd" id="52JQx_XoJez" role="3uHU7B">
                  <node concept="37vLTw" id="2BHiRxeuFIh" role="3uHU7B">
                    <ref role="3cqZAo" node="PhFjFi6YEk" resolve="myEnd" />
                  </node>
                  <node concept="37vLTw" id="2BHiRxeuJvk" role="3uHU7w">
                    <ref role="3cqZAo" node="PhFjFi6YEh" resolve="myBegin" />
                  </node>
                </node>
              </node>
              <node concept="2YIFZM" id="52JQx_XoJeA" role="3K4GZi">
                <ref role="37wK5l" to="18ew:~NameUtil.formatNumericalString(int,java.lang.String):java.lang.String" resolve="formatNumericalString" />
                <ref role="1Pybhc" to="18ew:~NameUtil" resolve="NameUtil" />
                <node concept="3cpWsd" id="52JQx_XoJeB" role="37wK5m">
                  <node concept="37vLTw" id="2BHiRxeutDH" role="3uHU7w">
                    <ref role="3cqZAo" node="PhFjFi6YEh" resolve="myBegin" />
                  </node>
                  <node concept="37vLTw" id="2BHiRxeuu5u" role="3uHU7B">
                    <ref role="3cqZAo" node="PhFjFi6YEk" resolve="myEnd" />
                  </node>
                </node>
                <node concept="1rXfSq" id="58$PzbkaOlT" role="37wK5m">
                  <ref role="37wK5l" node="4k3fuHGtdrF" resolve="getRole" />
                </node>
              </node>
            </node>
          </node>
        </node>
        <node concept="3cpWs8" id="52JQx_XoJeF" role="3cqZAp">
          <node concept="3cpWsn" id="52JQx_XoJeG" role="3cpWs9">
            <property role="TrG5h" value="newStuff" />
            <node concept="17QB3L" id="52JQx_XoJeH" role="1tU5fm" />
            <node concept="3K4zz7" id="52JQx_XoJeI" role="33vP2m">
              <node concept="1rXfSq" id="58$PzbkaUds" role="3K4E3e">
                <ref role="37wK5l" node="4k3fuHGtdrF" resolve="getRole" />
              </node>
              <node concept="3clFbC" id="52JQx_XoJeK" role="3K4Cdx">
                <node concept="3cmrfG" id="52JQx_XoJeL" role="3uHU7w">
                  <property role="3cmrfH" value="1" />
                </node>
                <node concept="3cpWsd" id="52JQx_XoJeM" role="3uHU7B">
                  <node concept="37vLTw" id="2BHiRxeujRL" role="3uHU7B">
                    <ref role="3cqZAo" node="PhFjFi6YEq" resolve="myResultEnd" />
                  </node>
                  <node concept="37vLTw" id="2BHiRxeuWTg" role="3uHU7w">
                    <ref role="3cqZAo" node="PhFjFi6YEn" resolve="myResultBegin" />
                  </node>
                </node>
              </node>
              <node concept="2YIFZM" id="52JQx_XoJeP" role="3K4GZi">
                <ref role="37wK5l" to="18ew:~NameUtil.formatNumericalString(int,java.lang.String):java.lang.String" resolve="formatNumericalString" />
                <ref role="1Pybhc" to="18ew:~NameUtil" resolve="NameUtil" />
                <node concept="3cpWsd" id="52JQx_XoJeQ" role="37wK5m">
                  <node concept="37vLTw" id="2BHiRxeurs1" role="3uHU7w">
                    <ref role="3cqZAo" node="PhFjFi6YEn" resolve="myResultBegin" />
                  </node>
                  <node concept="37vLTw" id="2BHiRxeuVYm" role="3uHU7B">
                    <ref role="3cqZAo" node="PhFjFi6YEq" resolve="myResultEnd" />
                  </node>
                </node>
                <node concept="1rXfSq" id="58$PzbkaOXw" role="37wK5m">
                  <ref role="37wK5l" node="4k3fuHGtdrF" resolve="getRole" />
                </node>
              </node>
            </node>
          </node>
        </node>
        <node concept="3SKdUt" id="58$Pzbkb2Km" role="3cqZAp">
          <node concept="3SKdUq" id="58$Pzbkb4F9" role="3SKWNk">
            <property role="3SKdUp" value="FIXME get rid of this dirty magic with role names &quot;pluralization&quot;. PLEASE!!!" />
          </node>
        </node>
        <node concept="3clFbJ" id="52JQx_XoJeU" role="3cqZAp">
          <node concept="3clFbS" id="52JQx_XoJeV" role="3clFbx">
            <node concept="3clFbF" id="52JQx_XoJeW" role="3cqZAp">
              <node concept="37vLTI" id="52JQx_XoJeX" role="3clFbG">
                <node concept="Xl_RD" id="52JQx_XoJeY" role="37vLTx">
                  <property role="Xl_RC" value="another" />
                </node>
                <node concept="37vLTw" id="3GM_nagTAZO" role="37vLTJ">
                  <ref role="3cqZAo" node="52JQx_XoJeG" resolve="newStuff" />
                </node>
              </node>
            </node>
          </node>
          <node concept="1Wc70l" id="52JQx_XoJf0" role="3clFbw">
            <node concept="17R0WA" id="52JQx_XoJf1" role="3uHU7B">
              <node concept="37vLTw" id="3GM_nagTylH" role="3uHU7B">
                <ref role="3cqZAo" node="52JQx_XoJeG" resolve="newStuff" />
              </node>
              <node concept="1rXfSq" id="58$PzbkaYR1" role="3uHU7w">
                <ref role="37wK5l" node="4k3fuHGtdrF" resolve="getRole" />
              </node>
            </node>
            <node concept="17R0WA" id="52JQx_XoJf4" role="3uHU7w">
              <node concept="1rXfSq" id="58$PzbkaYuE" role="3uHU7w">
                <ref role="37wK5l" node="4k3fuHGtdrF" resolve="getRole" />
              </node>
              <node concept="37vLTw" id="3GM_nagTsRN" role="3uHU7B">
                <ref role="3cqZAo" node="52JQx_XoJet" resolve="oldStuff" />
              </node>
            </node>
          </node>
          <node concept="3eNFk2" id="52JQx_XoJf7" role="3eNLev">
            <node concept="3clFbS" id="52JQx_XoJf8" role="3eOfB_">
              <node concept="3clFbF" id="52JQx_XoJf9" role="3cqZAp">
                <node concept="37vLTI" id="52JQx_XoJfa" role="3clFbG">
                  <node concept="3cpWs3" id="52JQx_XoJfb" role="37vLTx">
                    <node concept="37vLTw" id="3GM_nagT$2f" role="3uHU7w">
                      <ref role="3cqZAo" node="52JQx_XoJeG" resolve="newStuff" />
                    </node>
                    <node concept="Xl_RD" id="52JQx_XoJfd" role="3uHU7B">
                      <property role="Xl_RC" value="another " />
                    </node>
                  </node>
                  <node concept="37vLTw" id="3GM_nagTu9G" role="37vLTJ">
                    <ref role="3cqZAo" node="52JQx_XoJeG" resolve="newStuff" />
                  </node>
                </node>
              </node>
            </node>
            <node concept="3y3z36" id="52JQx_XoJff" role="3eO9$A">
              <node concept="37vLTw" id="2BHiRxeuHt1" role="3uHU7w">
                <ref role="3cqZAo" node="PhFjFi6YEh" resolve="myBegin" />
              </node>
              <node concept="37vLTw" id="2BHiRxeulxV" role="3uHU7B">
                <ref role="3cqZAo" node="PhFjFi6YEk" resolve="myEnd" />
              </node>
            </node>
          </node>
        </node>
        <node concept="3clFbJ" id="52JQx_XoJfi" role="3cqZAp">
          <node concept="3clFbC" id="52JQx_XoJfj" role="3clFbw">
            <node concept="37vLTw" id="2BHiRxeudFD" role="3uHU7w">
              <ref role="3cqZAo" node="PhFjFi6YEh" resolve="myBegin" />
            </node>
            <node concept="37vLTw" id="2BHiRxeuO06" role="3uHU7B">
              <ref role="3cqZAo" node="PhFjFi6YEk" resolve="myEnd" />
            </node>
          </node>
          <node concept="3clFbS" id="52JQx_XoJfm" role="3clFbx">
            <node concept="3clFbJ" id="52JQx_XoJgj" role="3cqZAp">
              <node concept="3clFbS" id="52JQx_XoJgk" role="3clFbx">
                <node concept="3cpWs8" id="52JQx_XoJfn" role="3cqZAp">
                  <node concept="3cpWsn" id="52JQx_XoJfo" role="3cpWs9">
                    <property role="TrG5h" value="addedOrInserted" />
                    <node concept="17QB3L" id="52JQx_XoJfp" role="1tU5fm" />
                    <node concept="3K4zz7" id="52JQx_XoJfq" role="33vP2m">
                      <node concept="Xl_RD" id="52JQx_XoJfr" role="3K4E3e">
                        <property role="Xl_RC" value="Added" />
                      </node>
                      <node concept="Xl_RD" id="52JQx_XoJfs" role="3K4GZi">
                        <property role="Xl_RC" value="Inserted" />
                      </node>
                      <node concept="3clFbC" id="52JQx_XoJft" role="3K4Cdx">
                        <node concept="2OqwBi" id="52JQx_XoJfu" role="3uHU7w">
                          <node concept="37vLTw" id="3GM_nagTtpj" role="2Oq$k0">
                            <ref role="3cqZAo" node="52JQx_XoJdR" resolve="newChildren" />
                          </node>
                          <node concept="34oBXx" id="52JQx_XoJfw" role="2OqNvi" />
                        </node>
                        <node concept="37vLTw" id="2BHiRxeuHrj" role="3uHU7B">
                          <ref role="3cqZAo" node="PhFjFi6YEq" resolve="myResultEnd" />
                        </node>
                      </node>
                    </node>
                  </node>
                </node>
                <node concept="3cpWs6" id="52JQx_XoJfy" role="3cqZAp">
                  <node concept="2YIFZM" id="52JQx_XoJfz" role="3cqZAk">
                    <ref role="37wK5l" to="wyt6:~String.format(java.lang.String,java.lang.Object...):java.lang.String" resolve="format" />
                    <ref role="1Pybhc" to="wyt6:~String" resolve="String" />
                    <node concept="Xl_RD" id="52JQx_XoJf$" role="37wK5m">
                      <property role="Xl_RC" value="%s %s: %s" />
                    </node>
                    <node concept="37vLTw" id="3GM_nagT_pn" role="37wK5m">
                      <ref role="3cqZAo" node="52JQx_XoJfo" resolve="addedOrInserted" />
                    </node>
                    <node concept="37vLTw" id="3GM_nagTrdh" role="37wK5m">
                      <ref role="3cqZAo" node="52JQx_XoJeG" resolve="newStuff" />
                    </node>
                    <node concept="37vLTw" id="3GM_nagTt$G" role="37wK5m">
                      <ref role="3cqZAo" node="52JQx_XoJe5" resolve="newIds" />
                    </node>
                  </node>
                </node>
              </node>
              <node concept="37vLTw" id="2BHiRxgmajj" role="3clFbw">
                <ref role="3cqZAo" node="52JQx_XoJfR" resolve="verbose" />
              </node>
              <node concept="9aQIb" id="52JQx_XoJgo" role="9aQIa">
                <node concept="3clFbS" id="52JQx_XoJgp" role="9aQI4">
                  <node concept="3cpWs6" id="52JQx_XoJg_" role="3cqZAp">
                    <node concept="2YIFZM" id="52JQx_XoJgA" role="3cqZAk">
                      <ref role="37wK5l" to="wyt6:~String.format(java.lang.String,java.lang.Object...):java.lang.String" resolve="format" />
                      <ref role="1Pybhc" to="wyt6:~String" resolve="String" />
                      <node concept="Xl_RD" id="52JQx_XoJgB" role="37wK5m">
                        <property role="Xl_RC" value="Added %s" />
                      </node>
                      <node concept="37vLTw" id="3GM_nagTvuw" role="37wK5m">
                        <ref role="3cqZAo" node="52JQx_XoJeG" resolve="newStuff" />
                      </node>
                    </node>
                  </node>
                </node>
              </node>
            </node>
          </node>
        </node>
        <node concept="3clFbJ" id="52JQx_XoJfC" role="3cqZAp">
          <node concept="3clFbC" id="52JQx_XoJfD" role="3clFbw">
            <node concept="37vLTw" id="2BHiRxeuxMu" role="3uHU7w">
              <ref role="3cqZAo" node="PhFjFi6YEn" resolve="myResultBegin" />
            </node>
            <node concept="37vLTw" id="2BHiRxeuxSO" role="3uHU7B">
              <ref role="3cqZAo" node="PhFjFi6YEq" resolve="myResultEnd" />
            </node>
          </node>
          <node concept="3clFbS" id="52JQx_XoJfG" role="3clFbx">
            <node concept="3cpWs6" id="52JQx_XoJfH" role="3cqZAp">
              <node concept="2YIFZM" id="52JQx_XoJfI" role="3cqZAk">
                <ref role="1Pybhc" to="wyt6:~String" resolve="String" />
                <ref role="37wK5l" to="wyt6:~String.format(java.lang.String,java.lang.Object...):java.lang.String" resolve="format" />
                <node concept="Xl_RD" id="52JQx_XoJfJ" role="37wK5m">
                  <property role="Xl_RC" value="Removed %s" />
                </node>
                <node concept="37vLTw" id="3GM_nagTt$B" role="37wK5m">
                  <ref role="3cqZAo" node="52JQx_XoJet" resolve="oldStuff" />
                </node>
              </node>
            </node>
          </node>
        </node>
        <node concept="3clFbJ" id="52JQx_XoJgG" role="3cqZAp">
          <node concept="3clFbS" id="52JQx_XoJgH" role="3clFbx">
            <node concept="3cpWs6" id="52JQx_XoJfL" role="3cqZAp">
              <node concept="2YIFZM" id="52JQx_XoJfM" role="3cqZAk">
                <ref role="1Pybhc" to="wyt6:~String" resolve="String" />
                <ref role="37wK5l" to="wyt6:~String.format(java.lang.String,java.lang.Object...):java.lang.String" resolve="format" />
                <node concept="Xl_RD" id="52JQx_XoJfN" role="37wK5m">
                  <property role="Xl_RC" value="Replaced %s with %s: %s" />
                </node>
                <node concept="37vLTw" id="3GM_nagTz_9" role="37wK5m">
                  <ref role="3cqZAo" node="52JQx_XoJet" resolve="oldStuff" />
                </node>
                <node concept="37vLTw" id="3GM_nagTtb4" role="37wK5m">
                  <ref role="3cqZAo" node="52JQx_XoJeG" resolve="newStuff" />
                </node>
                <node concept="37vLTw" id="3GM_nagTudQ" role="37wK5m">
                  <ref role="3cqZAo" node="52JQx_XoJe5" resolve="newIds" />
                </node>
              </node>
            </node>
          </node>
          <node concept="37vLTw" id="2BHiRxglQ$S" role="3clFbw">
            <ref role="3cqZAo" node="52JQx_XoJfR" resolve="verbose" />
          </node>
          <node concept="9aQIb" id="52JQx_XoJgL" role="9aQIa">
            <node concept="3clFbS" id="52JQx_XoJgM" role="9aQI4">
              <node concept="3cpWs6" id="52JQx_XoJgN" role="3cqZAp">
                <node concept="2YIFZM" id="52JQx_XoJgO" role="3cqZAk">
                  <ref role="37wK5l" to="wyt6:~String.format(java.lang.String,java.lang.Object...):java.lang.String" resolve="format" />
                  <ref role="1Pybhc" to="wyt6:~String" resolve="String" />
                  <node concept="Xl_RD" id="52JQx_XoJgP" role="37wK5m">
                    <property role="Xl_RC" value="Replaced %s with %s" />
                  </node>
                  <node concept="37vLTw" id="3GM_nagTwLl" role="37wK5m">
                    <ref role="3cqZAo" node="52JQx_XoJet" resolve="oldStuff" />
                  </node>
                  <node concept="37vLTw" id="3GM_nagTvou" role="37wK5m">
                    <ref role="3cqZAo" node="52JQx_XoJeG" resolve="newStuff" />
                  </node>
                </node>
              </node>
            </node>
          </node>
        </node>
      </node>
      <node concept="37vLTG" id="52JQx_XoJfR" role="3clF46">
        <property role="TrG5h" value="verbose" />
        <node concept="10P_77" id="52JQx_XoJfS" role="1tU5fm" />
      </node>
    </node>
    <node concept="3clFb_" id="PhFjFi6YFC" role="jymVt">
      <property role="1EzhhJ" value="false" />
      <property role="TrG5h" value="createOppositeChange" />
      <node concept="3uibUv" id="PhFjFi6YFD" role="3clF45">
        <ref role="3uigEE" node="7Dh0CRFZxgO" resolve="ModelChange" />
      </node>
      <node concept="3Tmbuc" id="PhFjFi6YFE" role="1B3o_S" />
      <node concept="3clFbS" id="PhFjFi6YFF" role="3clF47">
        <node concept="3clFbF" id="PhFjFi6YFI" role="3cqZAp">
          <node concept="2ShNRf" id="PhFjFi6YFJ" role="3clFbG">
            <node concept="1pGfFk" id="PhFjFi6YFK" role="2ShVmc">
              <ref role="37wK5l" node="4k3fuHGtdr9" resolve="NodeGroupChange" />
              <node concept="2OqwBi" id="PhFjFi6YFL" role="37wK5m">
                <node concept="1rXfSq" id="4hiugqyyZbp" role="2Oq$k0">
                  <ref role="37wK5l" node="5x0q8wkvS4u" resolve="getChangeSet" />
                </node>
                <node concept="liA8E" id="PhFjFi6YFN" role="2OqNvi">
                  <ref role="37wK5l" to="bfxj:3kRMfhMv9uc" resolve="getOppositeChangeSet" />
                </node>
              </node>
              <node concept="37vLTw" id="2BHiRxeuoMa" role="37wK5m">
                <ref role="3cqZAo" node="4k3fuHGsETf" resolve="myParentNodeId" />
              </node>
              <node concept="37vLTw" id="2BHiRxeuoLH" role="37wK5m">
                <ref role="3cqZAo" node="4k3fuHGsETj" resolve="myRole" />
              </node>
              <node concept="37vLTw" id="2BHiRxeuXiz" role="37wK5m">
                <ref role="3cqZAo" node="PhFjFi6YEn" resolve="myResultBegin" />
              </node>
              <node concept="37vLTw" id="2BHiRxeuSuG" role="37wK5m">
                <ref role="3cqZAo" node="PhFjFi6YEq" resolve="myResultEnd" />
              </node>
              <node concept="37vLTw" id="2BHiRxeuSvu" role="37wK5m">
                <ref role="3cqZAo" node="PhFjFi6YEh" resolve="myBegin" />
              </node>
              <node concept="37vLTw" id="2BHiRxeujTo" role="37wK5m">
                <ref role="3cqZAo" node="PhFjFi6YEk" resolve="myEnd" />
              </node>
            </node>
          </node>
        </node>
      </node>
      <node concept="2AHcQZ" id="5Gi8bfMdALF" role="2AJF6D">
        <ref role="2AI5Lk" to="mhfm:~NotNull" resolve="NotNull" />
      </node>
      <node concept="2AHcQZ" id="3tYsUK_SicQ" role="2AJF6D">
        <ref role="2AI5Lk" to="wyt6:~Override" resolve="Override" />
      </node>
    </node>
    <node concept="2YIFZL" id="7bcsw60G6XG" role="jymVt">
      <property role="TrG5h" value="nodeRange" />
      <node concept="17QB3L" id="7bcsw60G6XL" role="3clF45" />
      <node concept="3clFbS" id="7bcsw60G6XJ" role="3clF47">
        <node concept="3clFbF" id="7bcsw60G6Y9" role="3cqZAp">
          <node concept="3K4zz7" id="7bcsw60G6Ya" role="3clFbG">
            <node concept="2YIFZM" id="7bcsw60G6Yb" role="3K4E3e">
              <ref role="1Pybhc" to="wyt6:~String" resolve="String" />
              <ref role="37wK5l" to="wyt6:~String.format(java.lang.String,java.lang.Object...):java.lang.String" resolve="format" />
              <node concept="Xl_RD" id="7bcsw60G6Yc" role="37wK5m">
                <property role="Xl_RC" value="node #%d" />
              </node>
              <node concept="37vLTw" id="2BHiRxgmv4w" role="37wK5m">
                <ref role="3cqZAo" node="7bcsw60G6XM" resolve="begin" />
              </node>
            </node>
            <node concept="2YIFZM" id="7bcsw60G6Ye" role="3K4GZi">
              <ref role="37wK5l" to="wyt6:~String.format(java.lang.String,java.lang.Object...):java.lang.String" resolve="format" />
              <ref role="1Pybhc" to="wyt6:~String" resolve="String" />
              <node concept="Xl_RD" id="7bcsw60G6Yf" role="37wK5m">
                <property role="Xl_RC" value="nodes #%d-%d" />
              </node>
              <node concept="37vLTw" id="2BHiRxgm8LX" role="37wK5m">
                <ref role="3cqZAo" node="7bcsw60G6XM" resolve="begin" />
              </node>
              <node concept="3cpWsd" id="7bcsw60G6Yh" role="37wK5m">
                <node concept="3cmrfG" id="7bcsw60G6Yi" role="3uHU7w">
                  <property role="3cmrfH" value="1" />
                </node>
                <node concept="37vLTw" id="2BHiRxgljrf" role="3uHU7B">
                  <ref role="3cqZAo" node="7bcsw60G6XO" resolve="end" />
                </node>
              </node>
            </node>
            <node concept="3clFbC" id="7bcsw60G6Yk" role="3K4Cdx">
              <node concept="37vLTw" id="2BHiRxghfko" role="3uHU7w">
                <ref role="3cqZAo" node="7bcsw60G6XO" resolve="end" />
              </node>
              <node concept="3cpWs3" id="7bcsw60G6Ym" role="3uHU7B">
                <node concept="3cmrfG" id="7bcsw60G6Yn" role="3uHU7w">
                  <property role="3cmrfH" value="1" />
                </node>
                <node concept="37vLTw" id="2BHiRxgm$Fw" role="3uHU7B">
                  <ref role="3cqZAo" node="7bcsw60G6XM" resolve="begin" />
                </node>
              </node>
            </node>
          </node>
        </node>
      </node>
      <node concept="3Tm6S6" id="PhFjFi7rxj" role="1B3o_S" />
      <node concept="37vLTG" id="7bcsw60G6XM" role="3clF46">
        <property role="TrG5h" value="begin" />
        <node concept="10Oyi0" id="7bcsw60G6XN" role="1tU5fm" />
      </node>
      <node concept="37vLTG" id="7bcsw60G6XO" role="3clF46">
        <property role="TrG5h" value="end" />
        <node concept="10Oyi0" id="7bcsw60G6XQ" role="1tU5fm" />
      </node>
    </node>
  </node>
  <node concept="312cEu" id="2nwhOFr8I08">
    <property role="TrG5h" value="SetPropertyChange" />
    <property role="3GE5qa" value="structure" />
    <node concept="3uibUv" id="4W7A6jbeADd" role="1zkMxy">
      <ref role="3uigEE" node="4W7A6jbeACg" resolve="NodeChange" />
    </node>
    <node concept="3Tm1VV" id="2nwhOFr8I09" role="1B3o_S" />
    <node concept="312cEg" id="2nH2HpRmY1h" role="jymVt">
      <property role="TrG5h" value="myProperty" />
      <node concept="3Tm6S6" id="2nH2HpRmY1i" role="1B3o_S" />
      <node concept="3uibUv" id="5IRXTJLMOby" role="1tU5fm">
        <ref role="3uigEE" to="c17a:~SProperty" resolve="SProperty" />
      </node>
    </node>
    <node concept="312cEg" id="2nH2HpRnspf" role="jymVt">
      <property role="TrG5h" value="myNewValue" />
      <node concept="3Tm6S6" id="2nH2HpRnspg" role="1B3o_S" />
      <node concept="17QB3L" id="2nH2HpRnsph" role="1tU5fm" />
    </node>
    <node concept="312cEg" id="7n1vgxs$Pfo" role="jymVt">
      <property role="34CwA1" value="false" />
      <property role="eg7rD" value="false" />
      <property role="TrG5h" value="myMergeHint" />
      <property role="3TUv4t" value="false" />
      <node concept="3Tm6S6" id="7n1vgxs$Nu7" role="1B3o_S" />
      <node concept="3uibUv" id="7n1vgxs$P8s" role="1tU5fm">
        <ref role="3uigEE" to="mhbf:~SNodeReference" resolve="SNodeReference" />
      </node>
      <node concept="10Nm6u" id="7n1vgxs$PT$" role="33vP2m" />
    </node>
    <node concept="312cEg" id="3BZin2chXup" role="jymVt">
      <property role="34CwA1" value="false" />
      <property role="eg7rD" value="false" />
      <property role="TrG5h" value="myMergeHintLoaded" />
      <property role="3TUv4t" value="false" />
      <node concept="3Tm6S6" id="3BZin2chW_l" role="1B3o_S" />
      <node concept="10P_77" id="7n1vgxs_CgP" role="1tU5fm" />
      <node concept="3clFbT" id="7n1vgxs_Crb" role="33vP2m">
        <property role="3clFbU" value="false" />
      </node>
    </node>
    <node concept="2tJIrI" id="5IRXTJLNPPQ" role="jymVt" />
    <node concept="3clFbW" id="2nH2HpRmY1o" role="jymVt">
      <node concept="3cqZAl" id="2nH2HpRmY1p" role="3clF45" />
      <node concept="3Tm1VV" id="2nH2HpRmY1q" role="1B3o_S" />
      <node concept="3clFbS" id="2nH2HpRmY1s" role="3clF47">
        <node concept="XkiVB" id="4W7A6jbeADf" role="3cqZAp">
          <ref role="37wK5l" node="4W7A6jbeACr" resolve="NodeChange" />
          <node concept="37vLTw" id="2BHiRxghf94" role="37wK5m">
            <ref role="3cqZAo" node="2nH2HpRmY1u" resolve="changeSet" />
          </node>
          <node concept="37vLTw" id="2BHiRxgmv4m" role="37wK5m">
            <ref role="3cqZAo" node="2nH2HpRmY1y" resolve="nodeId" />
          </node>
        </node>
        <node concept="3clFbF" id="2nH2HpRmY1H" role="3cqZAp">
          <node concept="37vLTI" id="2nH2HpRmY1J" role="3clFbG">
            <node concept="37vLTw" id="2BHiRxeuxRK" role="37vLTJ">
              <ref role="3cqZAo" node="2nH2HpRmY1h" resolve="myProperty" />
            </node>
            <node concept="37vLTw" id="2BHiRxglqRu" role="37vLTx">
              <ref role="3cqZAo" node="2nH2HpRmY1F" resolve="property" />
            </node>
          </node>
        </node>
        <node concept="3clFbF" id="2nH2HpRmY1Q" role="3cqZAp">
          <node concept="37vLTI" id="2nH2HpRmY1S" role="3clFbG">
            <node concept="37vLTw" id="2BHiRxeumux" role="37vLTJ">
              <ref role="3cqZAo" node="2nH2HpRnspf" resolve="myNewValue" />
            </node>
            <node concept="37vLTw" id="2BHiRxgm2uL" role="37vLTx">
              <ref role="3cqZAo" node="2nH2HpRmY1O" resolve="newValue" />
            </node>
          </node>
        </node>
      </node>
      <node concept="37vLTG" id="2nH2HpRmY1u" role="3clF46">
        <property role="TrG5h" value="changeSet" />
        <node concept="3uibUv" id="3kRMfhMvhrI" role="1tU5fm">
          <ref role="3uigEE" to="bfxj:3kRMfhMv03j" resolve="ChangeSet" />
        </node>
        <node concept="2AHcQZ" id="2W$ok$XXFAI" role="2AJF6D">
          <ref role="2AI5Lk" to="mhfm:~NotNull" resolve="NotNull" />
        </node>
      </node>
      <node concept="37vLTG" id="2nH2HpRmY1y" role="3clF46">
        <property role="TrG5h" value="nodeId" />
        <node concept="2AHcQZ" id="2W$ok$XXFAJ" role="2AJF6D">
          <ref role="2AI5Lk" to="mhfm:~NotNull" resolve="NotNull" />
        </node>
        <node concept="3uibUv" id="2nH2HpRmY1z" role="1tU5fm">
          <ref role="3uigEE" to="mhbf:~SNodeId" resolve="SNodeId" />
        </node>
      </node>
      <node concept="37vLTG" id="2nH2HpRmY1F" role="3clF46">
        <property role="TrG5h" value="property" />
        <node concept="3uibUv" id="5IRXTJLMMrJ" role="1tU5fm">
          <ref role="3uigEE" to="c17a:~SProperty" resolve="SProperty" />
        </node>
      </node>
      <node concept="37vLTG" id="2nH2HpRmY1O" role="3clF46">
        <property role="TrG5h" value="newValue" />
        <node concept="17QB3L" id="2nH2HpRmY1P" role="1tU5fm" />
      </node>
    </node>
    <node concept="3clFb_" id="2nH2HpRnsoR" role="jymVt">
      <property role="TrG5h" value="getPropertyName" />
      <node concept="2AHcQZ" id="2W$ok$XXFAL" role="2AJF6D">
        <ref role="2AI5Lk" to="mhfm:~NotNull" resolve="NotNull" />
      </node>
      <node concept="17QB3L" id="2nH2HpRnsoS" role="3clF45" />
      <node concept="3Tm1VV" id="2nH2HpRnsoT" role="1B3o_S" />
      <node concept="3clFbS" id="2nH2HpRnsoU" role="3clF47">
        <node concept="3clFbF" id="2nH2HpRnsoV" role="3cqZAp">
          <node concept="2OqwBi" id="5IRXTJLMTq5" role="3clFbG">
            <node concept="37vLTw" id="2BHiRxeukw$" role="2Oq$k0">
              <ref role="3cqZAo" node="2nH2HpRmY1h" resolve="myProperty" />
            </node>
            <node concept="liA8E" id="5IRXTJLMTvR" role="2OqNvi">
              <ref role="37wK5l" to="c17a:~SProperty.getName():java.lang.String" resolve="getName" />
            </node>
          </node>
        </node>
      </node>
    </node>
    <node concept="3clFb_" id="42UviMIicV_" role="jymVt">
      <property role="1EzhhJ" value="false" />
      <property role="TrG5h" value="getProperty" />
      <property role="od$2w" value="false" />
      <property role="DiZV1" value="false" />
      <property role="2aFKle" value="false" />
      <node concept="3clFbS" id="42UviMIicVC" role="3clF47">
        <node concept="3clFbF" id="42UviMIidiZ" role="3cqZAp">
          <node concept="37vLTw" id="42UviMIidiY" role="3clFbG">
            <ref role="3cqZAo" node="2nH2HpRmY1h" resolve="myProperty" />
          </node>
        </node>
      </node>
      <node concept="3Tm1VV" id="42UviMIic_J" role="1B3o_S" />
      <node concept="3uibUv" id="42UviMIicT9" role="3clF45">
        <ref role="3uigEE" to="c17a:~SProperty" resolve="SProperty" />
      </node>
    </node>
    <node concept="3clFb_" id="5IRXTJLNS6t" role="jymVt">
      <property role="1EzhhJ" value="false" />
      <property role="TrG5h" value="isAbout" />
      <property role="od$2w" value="false" />
      <property role="DiZV1" value="false" />
      <property role="2aFKle" value="false" />
      <node concept="3clFbS" id="5IRXTJLNS6w" role="3clF47">
        <node concept="3cpWs6" id="5IRXTJLNTv5" role="3cqZAp">
          <node concept="2OqwBi" id="5IRXTJLNUe0" role="3cqZAk">
            <node concept="37vLTw" id="5IRXTJLNTvN" role="2Oq$k0">
              <ref role="3cqZAo" node="2nH2HpRmY1h" resolve="myProperty" />
            </node>
            <node concept="liA8E" id="5IRXTJLNUQu" role="2OqNvi">
              <ref role="37wK5l" to="wyt6:~Object.equals(java.lang.Object):boolean" resolve="equals" />
              <node concept="37vLTw" id="5IRXTJLNVtx" role="37wK5m">
                <ref role="3cqZAo" node="5IRXTJLNSPJ" resolve="property" />
              </node>
            </node>
          </node>
        </node>
      </node>
      <node concept="3Tm1VV" id="5IRXTJLNRiN" role="1B3o_S" />
      <node concept="10P_77" id="5IRXTJLNS1r" role="3clF45" />
      <node concept="37vLTG" id="5IRXTJLNSPJ" role="3clF46">
        <property role="TrG5h" value="property" />
        <node concept="3uibUv" id="5IRXTJLNSPI" role="1tU5fm">
          <ref role="3uigEE" to="c17a:~SProperty" resolve="SProperty" />
        </node>
      </node>
    </node>
    <node concept="3clFb_" id="7n1vgxs$Lim" role="jymVt">
      <property role="1EzhhJ" value="false" />
      <property role="TrG5h" value="getMergeHint" />
      <property role="od$2w" value="false" />
      <property role="DiZV1" value="false" />
      <property role="2aFKle" value="false" />
      <node concept="3Tm1VV" id="7n1vgxs$Liq" role="1B3o_S" />
      <node concept="3uibUv" id="7n1vgxs$Lir" role="3clF45">
        <ref role="3uigEE" to="mhbf:~SNodeReference" resolve="SNodeReference" />
      </node>
      <node concept="2AHcQZ" id="7n1vgxs$Lis" role="2AJF6D">
        <ref role="2AI5Lk" to="mhfm:~Nullable" resolve="Nullable" />
      </node>
      <node concept="3clFbS" id="7n1vgxs$Liu" role="3clF47">
        <node concept="3SKdUt" id="7n1vgxs$Qr5" role="3cqZAp">
          <node concept="3SKdUq" id="7n1vgxs$Qr4" role="3SKWNk">
            <property role="3SKdUp" value="get &quot;nonconflicting&quot; attribute in metamodel " />
          </node>
        </node>
        <node concept="3clFbJ" id="7n1vgxs$Qq7" role="3cqZAp">
          <node concept="3fqX7Q" id="7n1vgxs$Qq8" role="3clFbw">
            <node concept="37vLTw" id="7n1vgxs$Qq9" role="3fr31v">
              <ref role="3cqZAo" node="3BZin2chXup" resolve="myMergeHintLoaded" />
            </node>
          </node>
          <node concept="3clFbS" id="7n1vgxs$Qqb" role="3clFbx">
            <node concept="3clFbF" id="7n1vgxs$Qqc" role="3cqZAp">
              <node concept="37vLTI" id="7n1vgxs$Qqd" role="3clFbG">
                <node concept="37vLTw" id="7n1vgxs$Qqe" role="37vLTJ">
                  <ref role="3cqZAo" node="3BZin2chXup" resolve="myMergeHintLoaded" />
                </node>
                <node concept="3clFbT" id="7n1vgxs$Qqf" role="37vLTx">
                  <property role="3clFbU" value="true" />
                </node>
              </node>
            </node>
            <node concept="3cpWs8" id="6$Ws1PhU1FE" role="3cqZAp">
              <node concept="3cpWsn" id="6$Ws1PhU1FH" role="3cpWs9">
                <property role="TrG5h" value="n" />
                <node concept="3Tqbb2" id="6$Ws1PhU1FC" role="1tU5fm" />
                <node concept="2OqwBi" id="6$Ws1PhU1LI" role="33vP2m">
                  <node concept="liA8E" id="6$Ws1PhU1LJ" role="2OqNvi">
                    <ref role="37wK5l" to="mhbf:~SModel.getNode(org.jetbrains.mps.openapi.model.SNodeId):org.jetbrains.mps.openapi.model.SNode" resolve="getNode" />
                    <node concept="1rXfSq" id="6$Ws1PhU1LK" role="37wK5m">
                      <ref role="37wK5l" node="3ZTTsGErwoe" resolve="getAffectedNodeId" />
                      <node concept="3clFbT" id="3ZTTsGErBiC" role="37wK5m">
                        <property role="3clFbU" value="false" />
                      </node>
                    </node>
                  </node>
                  <node concept="2JrnkZ" id="6$Ws1PhU1LL" role="2Oq$k0">
                    <node concept="2OqwBi" id="6$Ws1PhU1LM" role="2JrQYb">
                      <node concept="1rXfSq" id="6$Ws1PhU1LN" role="2Oq$k0">
                        <ref role="37wK5l" node="5x0q8wkvS4u" resolve="getChangeSet" />
                      </node>
                      <node concept="liA8E" id="6$Ws1PhU1LO" role="2OqNvi">
                        <ref role="37wK5l" to="bfxj:3kRMfhMv9u3" resolve="getOldModel" />
                      </node>
                    </node>
                  </node>
                </node>
              </node>
            </node>
            <node concept="3cpWs8" id="3BZin2cgmVH" role="3cqZAp">
              <node concept="3cpWsn" id="3BZin2cgmVK" role="3cpWs9">
                <property role="TrG5h" value="c" />
                <node concept="3THzug" id="3BZin2cgmVF" role="1tU5fm" />
                <node concept="2OqwBi" id="3BZin2cgne2" role="33vP2m">
                  <node concept="37vLTw" id="3BZin2cgnd4" role="2Oq$k0">
                    <ref role="3cqZAo" node="6$Ws1PhU1FH" resolve="n" />
                  </node>
                  <node concept="3NT_Vc" id="3BZin2cgnpw" role="2OqNvi" />
                </node>
              </node>
            </node>
            <node concept="3cpWs8" id="6$Ws1PhUcI3" role="3cqZAp">
              <node concept="3cpWsn" id="6$Ws1PhUcI6" role="3cpWs9">
                <property role="TrG5h" value="propDecl" />
                <node concept="3Tqbb2" id="6$Ws1PhUcI1" role="1tU5fm">
                  <ref role="ehGHo" to="tpce:f_TJgxF" resolve="PropertyDeclaration" />
                </node>
                <node concept="1PxgMI" id="6$Ws1PhUdaj" role="33vP2m">
                  <property role="1BlNFB" value="true" />
                  <node concept="2OqwBi" id="5IRXTJLMVfy" role="1m5AlR">
                    <node concept="37vLTw" id="5IRXTJLMV7l" role="2Oq$k0">
                      <ref role="3cqZAo" node="2nH2HpRmY1h" resolve="myProperty" />
                    </node>
                    <node concept="liA8E" id="5IRXTJLMVxM" role="2OqNvi">
                      <ref role="37wK5l" to="c17a:~SProperty.getDeclarationNode():org.jetbrains.mps.openapi.model.SNode" resolve="getDeclarationNode" />
                    </node>
                  </node>
                  <node concept="chp4Y" id="714IaVdGZau" role="3oSUPX">
                    <ref role="cht4Q" to="tpce:f_TJgxF" resolve="PropertyDeclaration" />
                  </node>
                </node>
              </node>
            </node>
            <node concept="3cpWs8" id="7n1vgxs_rL1" role="3cqZAp">
              <node concept="3cpWsn" id="7n1vgxs_rL4" role="3cpWs9">
                <property role="TrG5h" value="hint" />
                <node concept="3Tqbb2" id="7n1vgxs_rKZ" role="1tU5fm">
                  <ref role="ehGHo" to="6p:6lZ2aXXUNcq" resolve="MergeHint" />
                </node>
                <node concept="2OqwBi" id="7n1vgxs_t9b" role="33vP2m">
                  <node concept="37vLTw" id="7n1vgxs_t9c" role="2Oq$k0">
                    <ref role="3cqZAo" node="6$Ws1PhUcI6" resolve="propDecl" />
                  </node>
                  <node concept="3CFZ6_" id="7n1vgxs_t9d" role="2OqNvi">
                    <node concept="3CFYIy" id="7n1vgxs_t9e" role="3CFYIz">
                      <ref role="3CFYIx" to="6p:6lZ2aXXUNcq" resolve="MergeHint" />
                    </node>
                  </node>
                </node>
              </node>
            </node>
            <node concept="3clFbJ" id="7n1vgxs$QqK" role="3cqZAp">
              <property role="TyiWK" value="false" />
              <property role="TyiWL" value="true" />
              <node concept="2OqwBi" id="7n1vgxs_tzP" role="3clFbw">
                <node concept="37vLTw" id="7n1vgxs_tww" role="2Oq$k0">
                  <ref role="3cqZAo" node="7n1vgxs_rL4" resolve="hint" />
                </node>
                <node concept="3w_OXm" id="7n1vgxs_tTE" role="2OqNvi" />
              </node>
              <node concept="3clFbS" id="7n1vgxs$QqN" role="3clFbx">
                <node concept="3clFbF" id="7n1vgxs_u5e" role="3cqZAp">
                  <node concept="37vLTI" id="7n1vgxs_u8l" role="3clFbG">
                    <node concept="2OqwBi" id="7n1vgxs_ue$" role="37vLTx">
                      <node concept="37vLTw" id="7n1vgxs_u8L" role="2Oq$k0">
                        <ref role="3cqZAo" node="3BZin2cgmVK" resolve="c" />
                      </node>
                      <node concept="3CFZ6_" id="7n1vgxs_ukx" role="2OqNvi">
                        <node concept="3CFYIy" id="7n1vgxs_une" role="3CFYIz">
                          <ref role="3CFYIx" to="6p:6lZ2aXXUNcq" resolve="MergeHint" />
                        </node>
                      </node>
                    </node>
                    <node concept="37vLTw" id="7n1vgxs_u5c" role="37vLTJ">
                      <ref role="3cqZAo" node="7n1vgxs_rL4" resolve="hint" />
                    </node>
                  </node>
                </node>
              </node>
            </node>
            <node concept="3clFbJ" id="7n1vgxs$QqS" role="3cqZAp">
              <node concept="2OqwBi" id="7n1vgxs_uEP" role="3clFbw">
                <node concept="37vLTw" id="7n1vgxs_uC3" role="2Oq$k0">
                  <ref role="3cqZAo" node="7n1vgxs_rL4" resolve="hint" />
                </node>
                <node concept="3x8VRR" id="7n1vgxs_v0t" role="2OqNvi" />
              </node>
              <node concept="3clFbS" id="7n1vgxs$QqV" role="3clFbx">
                <node concept="3clFbF" id="7n1vgxs$QqW" role="3cqZAp">
                  <node concept="37vLTI" id="7n1vgxs_vwe" role="3clFbG">
                    <node concept="2ShNRf" id="7n1vgxs_vDI" role="37vLTx">
                      <node concept="1pGfFk" id="7n1vgxs_AfI" role="2ShVmc">
                        <ref role="37wK5l" to="w1kc:~SNodePointer.&lt;init&gt;(org.jetbrains.mps.openapi.model.SNode)" resolve="SNodePointer" />
                        <node concept="37vLTw" id="7n1vgxs_Ahk" role="37wK5m">
                          <ref role="3cqZAo" node="7n1vgxs_rL4" resolve="hint" />
                        </node>
                      </node>
                    </node>
                    <node concept="37vLTw" id="7n1vgxs_vnT" role="37vLTJ">
                      <ref role="3cqZAo" node="7n1vgxs$Pfo" resolve="myMergeHint" />
                    </node>
                  </node>
                </node>
              </node>
            </node>
          </node>
        </node>
        <node concept="3clFbF" id="7n1vgxs_B0v" role="3cqZAp">
          <node concept="37vLTw" id="7n1vgxs_B0t" role="3clFbG">
            <ref role="3cqZAo" node="7n1vgxs$Pfo" resolve="myMergeHint" />
          </node>
        </node>
      </node>
      <node concept="2AHcQZ" id="7n1vgxs$Liv" role="2AJF6D">
        <ref role="2AI5Lk" to="wyt6:~Override" resolve="Override" />
      </node>
    </node>
    <node concept="3clFb_" id="2nH2HpRnsoX" role="jymVt">
      <property role="TrG5h" value="getNewValue" />
      <node concept="17QB3L" id="2nH2HpRnsoY" role="3clF45" />
      <node concept="3Tm1VV" id="2nH2HpRnsoZ" role="1B3o_S" />
      <node concept="3clFbS" id="2nH2HpRnsp0" role="3clF47">
        <node concept="3clFbF" id="2nH2HpRnsp1" role="3cqZAp">
          <node concept="37vLTw" id="2BHiRxeuu31" role="3clFbG">
            <ref role="3cqZAo" node="2nH2HpRnspf" resolve="myNewValue" />
          </node>
        </node>
      </node>
    </node>
    <node concept="3clFb_" id="2W$ok$XXF__" role="jymVt">
      <property role="TrG5h" value="apply" />
      <node concept="3cqZAl" id="2W$ok$XXF_A" role="3clF45" />
      <node concept="3Tm1VV" id="2W$ok$XXF_B" role="1B3o_S" />
      <node concept="37vLTG" id="2W$ok$XXF_C" role="3clF46">
        <property role="TrG5h" value="model" />
        <node concept="H_c77" id="2W$ok$XXF_D" role="1tU5fm" />
        <node concept="2AHcQZ" id="2W$ok$XXF_E" role="2AJF6D">
          <ref role="2AI5Lk" to="mhfm:~NotNull" resolve="NotNull" />
        </node>
      </node>
      <node concept="37vLTG" id="4YYMSngGbky" role="3clF46">
        <property role="TrG5h" value="nodeCopier" />
        <node concept="3uibUv" id="4YPlf0PK8wX" role="1tU5fm">
          <ref role="3uigEE" node="69abr3GmYnQ" resolve="NodeCopier" />
        </node>
        <node concept="2AHcQZ" id="4YYMSngGbk$" role="2AJF6D">
          <ref role="2AI5Lk" to="mhfm:~NotNull" resolve="NotNull" />
        </node>
      </node>
      <node concept="3clFbS" id="2W$ok$XXF_F" role="3clF47">
        <node concept="3cpWs8" id="2W$ok$XXFAp" role="3cqZAp">
          <node concept="3cpWsn" id="2W$ok$XXFAq" role="3cpWs9">
            <property role="TrG5h" value="node" />
            <node concept="2OqwBi" id="2n9zn0CqMBJ" role="33vP2m">
              <node concept="liA8E" id="2n9zn0CqMBK" role="2OqNvi">
                <ref role="37wK5l" to="mhbf:~SModel.getNode(org.jetbrains.mps.openapi.model.SNodeId):org.jetbrains.mps.openapi.model.SNode" resolve="getNode" />
                <node concept="1rXfSq" id="4hiugqyz9Pw" role="37wK5m">
                  <ref role="37wK5l" node="4W7A6jbeACU" resolve="getAffectedNodeId" />
                </node>
              </node>
              <node concept="2JrnkZ" id="2n9zn0CqMBM" role="2Oq$k0">
                <node concept="37vLTw" id="2BHiRxgmyvw" role="2JrQYb">
                  <ref role="3cqZAo" node="2W$ok$XXF_C" resolve="model" />
                </node>
              </node>
            </node>
            <node concept="3uibUv" id="2W$ok$XXFAr" role="1tU5fm">
              <ref role="3uigEE" to="mhbf:~SNode" resolve="SNode" />
            </node>
          </node>
        </node>
        <node concept="1gVbGN" id="2W$ok$XXFA0" role="3cqZAp">
          <node concept="3y3z36" id="2W$ok$XXFAy" role="1gVkn0">
            <node concept="10Nm6u" id="2W$ok$XXFA_" role="3uHU7w" />
            <node concept="37vLTw" id="3GM_nagTzDS" role="3uHU7B">
              <ref role="3cqZAo" node="2W$ok$XXFAq" resolve="node" />
            </node>
          </node>
        </node>
        <node concept="3clFbF" id="2W$ok$XXFAB" role="3cqZAp">
          <node concept="2OqwBi" id="2W$ok$XXFAD" role="3clFbG">
            <node concept="37vLTw" id="3GM_nagTBPr" role="2Oq$k0">
              <ref role="3cqZAo" node="2W$ok$XXFAq" resolve="node" />
            </node>
            <node concept="liA8E" id="2W$ok$XXFAH" role="2OqNvi">
              <ref role="37wK5l" to="mhbf:~SNode.setProperty(org.jetbrains.mps.openapi.language.SProperty,java.lang.String):void" resolve="setProperty" />
              <node concept="37vLTw" id="2BHiRxeuneV" role="37wK5m">
                <ref role="3cqZAo" node="2nH2HpRmY1h" resolve="myProperty" />
              </node>
              <node concept="37vLTw" id="2BHiRxeusJO" role="37wK5m">
                <ref role="3cqZAo" node="2nH2HpRnspf" resolve="myNewValue" />
              </node>
            </node>
          </node>
        </node>
      </node>
      <node concept="2AHcQZ" id="3tYsUK_UnR5" role="2AJF6D">
        <ref role="2AI5Lk" to="wyt6:~Override" resolve="Override" />
      </node>
    </node>
    <node concept="3clFb_" id="2WueYNNTBir" role="jymVt">
      <property role="1EzhhJ" value="false" />
      <property role="TrG5h" value="createOppositeChange" />
      <node concept="3uibUv" id="2WueYNNTBis" role="3clF45">
        <ref role="3uigEE" node="7Dh0CRFZxgO" resolve="ModelChange" />
      </node>
      <node concept="3Tmbuc" id="2WueYNNTBit" role="1B3o_S" />
      <node concept="3clFbS" id="2WueYNNTBiu" role="3clF47">
        <node concept="3cpWs8" id="2WueYNNTBkQ" role="3cqZAp">
          <node concept="3cpWsn" id="2WueYNNTBkR" role="3cpWs9">
            <property role="TrG5h" value="node" />
            <node concept="2OqwBi" id="2n9zn0CqMAa" role="33vP2m">
              <node concept="liA8E" id="2n9zn0CqMAb" role="2OqNvi">
                <ref role="37wK5l" to="mhbf:~SModel.getNode(org.jetbrains.mps.openapi.model.SNodeId):org.jetbrains.mps.openapi.model.SNode" resolve="getNode" />
                <node concept="1rXfSq" id="4hiugqyzhP5" role="37wK5m">
                  <ref role="37wK5l" node="3ZTTsGErwoe" resolve="getAffectedNodeId" />
                  <node concept="3clFbT" id="3ZTTsGErAOx" role="37wK5m">
                    <property role="3clFbU" value="false" />
                  </node>
                </node>
              </node>
              <node concept="2JrnkZ" id="2n9zn0CqMAd" role="2Oq$k0">
                <node concept="2OqwBi" id="2n9zn0CqMAe" role="2JrQYb">
                  <node concept="1rXfSq" id="4hiugqyyZYj" role="2Oq$k0">
                    <ref role="37wK5l" node="5x0q8wkvS4u" resolve="getChangeSet" />
                  </node>
                  <node concept="liA8E" id="2n9zn0CqMAg" role="2OqNvi">
                    <ref role="37wK5l" to="bfxj:3kRMfhMv9u3" resolve="getOldModel" />
                  </node>
                </node>
              </node>
            </node>
            <node concept="3uibUv" id="2WueYNNTBkS" role="1tU5fm">
              <ref role="3uigEE" to="mhbf:~SNode" resolve="SNode" />
            </node>
          </node>
        </node>
        <node concept="1gVbGN" id="2WueYNNTBkY" role="3cqZAp">
          <node concept="3y3z36" id="2WueYNNTBkZ" role="1gVkn0">
            <node concept="10Nm6u" id="2WueYNNTBl0" role="3uHU7w" />
            <node concept="37vLTw" id="3GM_nagTyoj" role="3uHU7B">
              <ref role="3cqZAo" node="2WueYNNTBkR" resolve="node" />
            </node>
          </node>
        </node>
        <node concept="3cpWs6" id="2WueYNNTBWb" role="3cqZAp">
          <node concept="2ShNRf" id="2WueYNNTBiQ" role="3cqZAk">
            <node concept="1pGfFk" id="2WueYNNTBiS" role="2ShVmc">
              <ref role="37wK5l" node="2nH2HpRmY1o" resolve="SetPropertyChange" />
              <node concept="2OqwBi" id="2WueYNNTBj1" role="37wK5m">
                <node concept="1rXfSq" id="4hiugqyz9tn" role="2Oq$k0">
                  <ref role="37wK5l" node="5x0q8wkvS4u" resolve="getChangeSet" />
                </node>
                <node concept="liA8E" id="2WueYNNTBj5" role="2OqNvi">
                  <ref role="37wK5l" to="bfxj:3kRMfhMv9uc" resolve="getOppositeChangeSet" />
                </node>
              </node>
              <node concept="1rXfSq" id="4hiugqyzfch" role="37wK5m">
                <ref role="37wK5l" node="3ZTTsGErwoe" resolve="getAffectedNodeId" />
                <node concept="3clFbT" id="3ZTTsGErAnq" role="37wK5m">
                  <property role="3clFbU" value="true" />
                </node>
              </node>
              <node concept="37vLTw" id="2BHiRxeuTtT" role="37wK5m">
                <ref role="3cqZAo" node="2nH2HpRmY1h" resolve="myProperty" />
              </node>
              <node concept="2OqwBi" id="2WueYNNTBlk" role="37wK5m">
                <node concept="liA8E" id="2WueYNNTBlo" role="2OqNvi">
                  <ref role="37wK5l" to="mhbf:~SNode.getProperty(org.jetbrains.mps.openapi.language.SProperty):java.lang.String" resolve="getProperty" />
                  <node concept="37vLTw" id="2BHiRxeuniy" role="37wK5m">
                    <ref role="3cqZAo" node="2nH2HpRmY1h" resolve="myProperty" />
                  </node>
                </node>
                <node concept="37vLTw" id="3GM_nagTxR1" role="2Oq$k0">
                  <ref role="3cqZAo" node="2WueYNNTBkR" resolve="node" />
                </node>
              </node>
            </node>
          </node>
        </node>
      </node>
      <node concept="2AHcQZ" id="5Gi8bfMdBnE" role="2AJF6D">
        <ref role="2AI5Lk" to="mhfm:~NotNull" resolve="NotNull" />
      </node>
      <node concept="2AHcQZ" id="3tYsUK_UnR6" role="2AJF6D">
        <ref role="2AI5Lk" to="wyt6:~Override" resolve="Override" />
      </node>
    </node>
    <node concept="3clFb_" id="4TJPS00dNDy" role="jymVt">
      <property role="TrG5h" value="toString" />
      <node concept="3Tm1VV" id="4TJPS00dNDz" role="1B3o_S" />
      <node concept="17QB3L" id="4TJPS00dNDD" role="3clF45" />
      <node concept="3clFbS" id="4TJPS00dND_" role="3clF47">
        <node concept="3clFbF" id="4TJPS00dNDE" role="3cqZAp">
          <node concept="2YIFZM" id="4TJPS00dNDG" role="3clFbG">
            <ref role="1Pybhc" to="wyt6:~String" resolve="String" />
            <ref role="37wK5l" to="wyt6:~String.format(java.lang.String,java.lang.Object...):java.lang.String" resolve="format" />
            <node concept="Xl_RD" id="4TJPS00dNDH" role="37wK5m">
              <property role="Xl_RC" value="Set property %s to %s in node %s" />
            </node>
            <node concept="37vLTw" id="2BHiRxeuwBP" role="37wK5m">
              <ref role="3cqZAo" node="2nH2HpRmY1h" resolve="myProperty" />
            </node>
            <node concept="37vLTw" id="2BHiRxeuImc" role="37wK5m">
              <ref role="3cqZAo" node="2nH2HpRnspf" resolve="myNewValue" />
            </node>
            <node concept="1rXfSq" id="4hiugqyziWZ" role="37wK5m">
              <ref role="37wK5l" node="3ZTTsGErwoe" resolve="getAffectedNodeId" />
              <node concept="3clFbT" id="3ZTTsGEr_Zt" role="37wK5m">
                <property role="3clFbU" value="false" />
              </node>
            </node>
          </node>
        </node>
      </node>
      <node concept="2AHcQZ" id="4TJPS00dNDA" role="2AJF6D">
        <ref role="2AI5Lk" to="wyt6:~Override" resolve="Override" />
      </node>
    </node>
    <node concept="3clFb_" id="51cMXQKRj4x" role="jymVt">
      <property role="1EzhhJ" value="false" />
      <property role="TrG5h" value="getDescription" />
      <node concept="17QB3L" id="51cMXQKRj4y" role="3clF45" />
      <node concept="3Tm1VV" id="51cMXQKRj4z" role="1B3o_S" />
      <node concept="3clFbS" id="51cMXQKRj4$" role="3clF47">
        <node concept="3clFbF" id="51cMXQKRj4_" role="3cqZAp">
          <node concept="2YIFZM" id="51cMXQKRj4C" role="3clFbG">
            <ref role="1Pybhc" to="wyt6:~String" resolve="String" />
            <ref role="37wK5l" to="wyt6:~String.format(java.lang.String,java.lang.Object...):java.lang.String" resolve="format" />
            <node concept="Xl_RD" id="51cMXQKRj4A" role="37wK5m">
              <property role="Xl_RC" value="Changed %s of #%s from '%s' to '%s'" />
            </node>
            <node concept="37vLTw" id="2BHiRxeuh_z" role="37wK5m">
              <ref role="3cqZAo" node="2nH2HpRmY1h" resolve="myProperty" />
            </node>
            <node concept="1rXfSq" id="4hiugqyyHSp" role="37wK5m">
              <ref role="37wK5l" node="3ZTTsGErwoe" resolve="getAffectedNodeId" />
              <node concept="3clFbT" id="3ZTTsGErB78" role="37wK5m">
                <property role="3clFbU" value="false" />
              </node>
            </node>
            <node concept="2OqwBi" id="51cMXQKRj52" role="37wK5m">
              <node concept="2OqwBi" id="2n9zn0CqMCf" role="2Oq$k0">
                <node concept="liA8E" id="2n9zn0CqMCg" role="2OqNvi">
                  <ref role="37wK5l" to="mhbf:~SModel.getNode(org.jetbrains.mps.openapi.model.SNodeId):org.jetbrains.mps.openapi.model.SNode" resolve="getNode" />
                  <node concept="1rXfSq" id="4hiugqyza3h" role="37wK5m">
                    <ref role="37wK5l" node="3ZTTsGErwoe" resolve="getAffectedNodeId" />
                    <node concept="3clFbT" id="3ZTTsGErA7f" role="37wK5m">
                      <property role="3clFbU" value="false" />
                    </node>
                  </node>
                </node>
                <node concept="2JrnkZ" id="2n9zn0CqMCi" role="2Oq$k0">
                  <node concept="2OqwBi" id="2n9zn0CqMCj" role="2JrQYb">
                    <node concept="liA8E" id="2n9zn0CqMCk" role="2OqNvi">
                      <ref role="37wK5l" to="bfxj:3kRMfhMv9u3" resolve="getOldModel" />
                    </node>
                    <node concept="1rXfSq" id="4hiugqyzerN" role="2Oq$k0">
                      <ref role="37wK5l" node="5x0q8wkvS4u" resolve="getChangeSet" />
                    </node>
                  </node>
                </node>
              </node>
              <node concept="liA8E" id="51cMXQKRj56" role="2OqNvi">
                <ref role="37wK5l" to="mhbf:~SNode.getProperty(org.jetbrains.mps.openapi.language.SProperty):java.lang.String" resolve="getProperty" />
                <node concept="37vLTw" id="2BHiRxeular" role="37wK5m">
                  <ref role="3cqZAo" node="2nH2HpRmY1h" resolve="myProperty" />
                </node>
              </node>
            </node>
            <node concept="2OqwBi" id="6XzQhazzpQn" role="37wK5m">
              <node concept="2OqwBi" id="2n9zn0CqMEt" role="2Oq$k0">
                <node concept="liA8E" id="2n9zn0CqMEu" role="2OqNvi">
                  <ref role="37wK5l" to="mhbf:~SModel.getNode(org.jetbrains.mps.openapi.model.SNodeId):org.jetbrains.mps.openapi.model.SNode" resolve="getNode" />
                  <node concept="1rXfSq" id="4hiugqyza4H" role="37wK5m">
                    <ref role="37wK5l" node="3ZTTsGErwoe" resolve="getAffectedNodeId" />
                    <node concept="3clFbT" id="3ZTTsGErAeP" role="37wK5m">
                      <property role="3clFbU" value="true" />
                    </node>
                  </node>
                </node>
                <node concept="2JrnkZ" id="2n9zn0CqMEw" role="2Oq$k0">
                  <node concept="2OqwBi" id="2n9zn0CqMEx" role="2JrQYb">
                    <node concept="1rXfSq" id="4hiugqyzkpk" role="2Oq$k0">
                      <ref role="37wK5l" node="5x0q8wkvS4u" resolve="getChangeSet" />
                    </node>
                    <node concept="liA8E" id="2n9zn0CqMEz" role="2OqNvi">
                      <ref role="37wK5l" to="bfxj:3kRMfhMv9u8" resolve="getNewModel" />
                    </node>
                  </node>
                </node>
              </node>
              <node concept="liA8E" id="6XzQhazzpQv" role="2OqNvi">
                <ref role="37wK5l" to="mhbf:~SNode.getProperty(org.jetbrains.mps.openapi.language.SProperty):java.lang.String" resolve="getProperty" />
                <node concept="37vLTw" id="2BHiRxeuvyu" role="37wK5m">
                  <ref role="3cqZAo" node="2nH2HpRmY1h" resolve="myProperty" />
                </node>
              </node>
            </node>
          </node>
        </node>
      </node>
      <node concept="2AHcQZ" id="3tYsUK_UnR4" role="2AJF6D">
        <ref role="2AI5Lk" to="wyt6:~Override" resolve="Override" />
      </node>
    </node>
  </node>
  <node concept="312cEu" id="2nH2HpRnsob">
    <property role="TrG5h" value="SetReferenceChange" />
    <property role="3GE5qa" value="structure" />
    <node concept="3uibUv" id="4W7A6jbeAMP" role="1zkMxy">
      <ref role="3uigEE" node="4W7A6jbeACg" resolve="NodeChange" />
    </node>
    <node concept="3Tm1VV" id="2nH2HpRnsoc" role="1B3o_S" />
    <node concept="312cEg" id="2nH2HpRnsMo" role="jymVt">
      <property role="TrG5h" value="myRole" />
      <property role="3TUv4t" value="true" />
      <node concept="3Tm6S6" id="2nH2HpRnsMp" role="1B3o_S" />
      <node concept="3uibUv" id="5IRXTJLPuQU" role="1tU5fm">
        <ref role="3uigEE" to="c17a:~SReferenceLink" resolve="SReferenceLink" />
      </node>
    </node>
    <node concept="312cEg" id="2nH2HpRnsMs" role="jymVt">
      <property role="TrG5h" value="myTargetModelReference" />
      <property role="3TUv4t" value="true" />
      <node concept="3Tm6S6" id="2nH2HpRnsMt" role="1B3o_S" />
      <node concept="3uibUv" id="2nH2HpRnsMv" role="1tU5fm">
        <ref role="3uigEE" to="mhbf:~SModelReference" resolve="SModelReference" />
      </node>
    </node>
    <node concept="312cEg" id="2nH2HpRnsMw" role="jymVt">
      <property role="TrG5h" value="myTargetNodeId" />
      <property role="3TUv4t" value="true" />
      <node concept="3Tm6S6" id="2nH2HpRnsMx" role="1B3o_S" />
      <node concept="3uibUv" id="2nH2HpRnsMz" role="1tU5fm">
        <ref role="3uigEE" to="mhbf:~SNodeId" resolve="SNodeId" />
      </node>
    </node>
    <node concept="312cEg" id="2nH2HpRnsM$" role="jymVt">
      <property role="TrG5h" value="myResolveInfo" />
      <property role="3TUv4t" value="true" />
      <node concept="3Tm6S6" id="2nH2HpRnsM_" role="1B3o_S" />
      <node concept="17QB3L" id="2nH2HpRnsMB" role="1tU5fm" />
    </node>
    <node concept="312cEg" id="5xVZxjNpBB_" role="jymVt">
      <property role="TrG5h" value="myResolveInfoOnly" />
      <property role="3TUv4t" value="true" />
      <node concept="10P_77" id="5xVZxjNqb40" role="1tU5fm" />
      <node concept="3Tm6S6" id="5xVZxjNpBBA" role="1B3o_S" />
    </node>
    <node concept="3clFbW" id="2nH2HpRnsMF" role="jymVt">
      <node concept="3cqZAl" id="2nH2HpRnsMG" role="3clF45" />
      <node concept="3Tm1VV" id="2nH2HpRnsMH" role="1B3o_S" />
      <node concept="3clFbS" id="2nH2HpRnsMJ" role="3clF47">
        <node concept="XkiVB" id="4W7A6jbeAMR" role="3cqZAp">
          <ref role="37wK5l" node="4W7A6jbeACr" resolve="NodeChange" />
          <node concept="37vLTw" id="2BHiRxghf_v" role="37wK5m">
            <ref role="3cqZAo" node="2nH2HpRnsML" resolve="changeSet" />
          </node>
          <node concept="37vLTw" id="2BHiRxgluLV" role="37wK5m">
            <ref role="3cqZAo" node="2nH2HpRnsMP" resolve="sourceNodeId" />
          </node>
        </node>
        <node concept="3clFbF" id="2nH2HpRnsN0" role="3cqZAp">
          <node concept="37vLTI" id="2nH2HpRnsN2" role="3clFbG">
            <node concept="37vLTw" id="2BHiRxeusIc" role="37vLTJ">
              <ref role="3cqZAo" node="2nH2HpRnsMo" resolve="myRole" />
            </node>
            <node concept="37vLTw" id="2BHiRxgkWrS" role="37vLTx">
              <ref role="3cqZAo" node="2nH2HpRnsMY" resolve="role" />
            </node>
          </node>
        </node>
        <node concept="3clFbF" id="2nH2HpRnsN9" role="3cqZAp">
          <node concept="37vLTI" id="2nH2HpRnsNb" role="3clFbG">
            <node concept="37vLTw" id="2BHiRxeuFKN" role="37vLTJ">
              <ref role="3cqZAo" node="2nH2HpRnsMs" resolve="myTargetModelReference" />
            </node>
            <node concept="37vLTw" id="2BHiRxgm9xx" role="37vLTx">
              <ref role="3cqZAo" node="2nH2HpRnsN7" resolve="targetModelReference" />
            </node>
          </node>
        </node>
        <node concept="3SKdUt" id="2p9HAeNSoqm" role="3cqZAp">
          <node concept="3SKdUq" id="2p9HAeNSoqn" role="3SKWNk">
            <property role="3SKdUp" value="if target node id is null and resolve info is not-null it's dynamic reference" />
          </node>
        </node>
        <node concept="3clFbF" id="2nH2HpRnsNi" role="3cqZAp">
          <node concept="37vLTI" id="2nH2HpRnsNk" role="3clFbG">
            <node concept="37vLTw" id="2BHiRxeuw$g" role="37vLTJ">
              <ref role="3cqZAo" node="2nH2HpRnsMw" resolve="myTargetNodeId" />
            </node>
            <node concept="37vLTw" id="2BHiRxgmeYG" role="37vLTx">
              <ref role="3cqZAo" node="2nH2HpRnsNg" resolve="targetNodeId" />
            </node>
          </node>
        </node>
        <node concept="3clFbF" id="2nH2HpRnsNr" role="3cqZAp">
          <node concept="37vLTI" id="2nH2HpRnsNt" role="3clFbG">
            <node concept="37vLTw" id="2BHiRxeuSWw" role="37vLTJ">
              <ref role="3cqZAo" node="2nH2HpRnsM$" resolve="myResolveInfo" />
            </node>
            <node concept="37vLTw" id="2BHiRxgm7JG" role="37vLTx">
              <ref role="3cqZAo" node="2nH2HpRnsNp" resolve="resolveInfo" />
            </node>
          </node>
        </node>
        <node concept="3clFbH" id="5xVZxjNqwel" role="3cqZAp" />
        <node concept="3SKdUt" id="5xVZxjNruMd" role="3cqZAp">
          <node concept="3SKdUq" id="5xVZxjNruMe" role="3SKWNk">
            <property role="3SKdUp" value="check if only resolve info for static reference changed - then it cannot conflict with other changes" />
          </node>
        </node>
        <node concept="3cpWs8" id="5xVZxjNqzZN" role="3cqZAp">
          <node concept="3cpWsn" id="5xVZxjNqzZO" role="3cpWs9">
            <property role="TrG5h" value="oldRef" />
            <node concept="2EnYce" id="5xVZxjNs6Ae" role="33vP2m">
              <node concept="2OqwBi" id="2n9zn0CqMAv" role="2Oq$k0">
                <node concept="liA8E" id="2n9zn0CqMAw" role="2OqNvi">
                  <ref role="37wK5l" to="mhbf:~SModel.getNode(org.jetbrains.mps.openapi.model.SNodeId):org.jetbrains.mps.openapi.model.SNode" resolve="getNode" />
                  <node concept="1rXfSq" id="4hiugqyyYmC" role="37wK5m">
                    <ref role="37wK5l" node="3ZTTsGErwoe" resolve="getAffectedNodeId" />
                    <node concept="3clFbT" id="3ZTTsGErCu1" role="37wK5m">
                      <property role="3clFbU" value="false" />
                    </node>
                  </node>
                </node>
                <node concept="2JrnkZ" id="2n9zn0CqMAy" role="2Oq$k0">
                  <node concept="2OqwBi" id="2n9zn0CqMAz" role="2JrQYb">
                    <node concept="37vLTw" id="2BHiRxglI4X" role="2Oq$k0">
                      <ref role="3cqZAo" node="2nH2HpRnsML" resolve="changeSet" />
                    </node>
                    <node concept="liA8E" id="2n9zn0CqMA_" role="2OqNvi">
                      <ref role="37wK5l" to="bfxj:3kRMfhMv9u3" resolve="getOldModel" />
                    </node>
                  </node>
                </node>
              </node>
              <node concept="liA8E" id="5xVZxjNqzZY" role="2OqNvi">
                <ref role="37wK5l" to="mhbf:~SNode.getReference(org.jetbrains.mps.openapi.language.SReferenceLink):org.jetbrains.mps.openapi.model.SReference" resolve="getReference" />
                <node concept="37vLTw" id="2BHiRxeusbj" role="37wK5m">
                  <ref role="3cqZAo" node="2nH2HpRnsMo" resolve="myRole" />
                </node>
              </node>
            </node>
            <node concept="3uibUv" id="5xVZxjNqzZP" role="1tU5fm">
              <ref role="3uigEE" to="mhbf:~SReference" resolve="SReference" />
            </node>
          </node>
        </node>
        <node concept="3clFbF" id="5xVZxjNqsF$" role="3cqZAp">
          <node concept="37vLTI" id="5xVZxjNroas" role="3clFbG">
            <node concept="37vLTw" id="2BHiRxeuTvS" role="37vLTJ">
              <ref role="3cqZAo" node="5xVZxjNpBB_" resolve="myResolveInfoOnly" />
            </node>
            <node concept="1Wc70l" id="5xVZxjNrpe9" role="37vLTx">
              <node concept="3y3z36" id="5xVZxjNrpea" role="3uHU7w">
                <node concept="37vLTw" id="2BHiRxghg8_" role="3uHU7B">
                  <ref role="3cqZAo" node="2nH2HpRnsNg" resolve="targetNodeId" />
                </node>
                <node concept="10Nm6u" id="5xVZxjNrpeb" role="3uHU7w" />
              </node>
              <node concept="1Wc70l" id="5xVZxjNrped" role="3uHU7B">
                <node concept="17R0WA" id="5xVZxjNrpee" role="3uHU7B">
                  <node concept="37vLTw" id="2BHiRxghgc6" role="3uHU7w">
                    <ref role="3cqZAo" node="2nH2HpRnsN7" resolve="targetModelReference" />
                  </node>
                  <node concept="2EnYce" id="5xVZxjNrVhN" role="3uHU7B">
                    <node concept="liA8E" id="5xVZxjNrVhO" role="2OqNvi">
                      <ref role="37wK5l" to="mhbf:~SReference.getTargetSModelReference():org.jetbrains.mps.openapi.model.SModelReference" resolve="getTargetSModelReference" />
                    </node>
                    <node concept="37vLTw" id="3GM_nagT_G_" role="2Oq$k0">
                      <ref role="3cqZAo" node="5xVZxjNqzZO" resolve="oldRef" />
                    </node>
                  </node>
                </node>
                <node concept="17R0WA" id="5xVZxjNrpeh" role="3uHU7w">
                  <node concept="37vLTw" id="2BHiRxgmanB" role="3uHU7w">
                    <ref role="3cqZAo" node="2nH2HpRnsNg" resolve="targetNodeId" />
                  </node>
                  <node concept="2EnYce" id="5xVZxjNrXHb" role="3uHU7B">
                    <node concept="liA8E" id="5xVZxjNrXHc" role="2OqNvi">
                      <ref role="37wK5l" to="mhbf:~SReference.getTargetNodeId():org.jetbrains.mps.openapi.model.SNodeId" resolve="getTargetNodeId" />
                    </node>
                    <node concept="37vLTw" id="3GM_nagTute" role="2Oq$k0">
                      <ref role="3cqZAo" node="5xVZxjNqzZO" resolve="oldRef" />
                    </node>
                  </node>
                </node>
              </node>
            </node>
          </node>
        </node>
      </node>
      <node concept="37vLTG" id="2nH2HpRnsML" role="3clF46">
        <property role="TrG5h" value="changeSet" />
        <node concept="3uibUv" id="3kRMfhMvhrK" role="1tU5fm">
          <ref role="3uigEE" to="bfxj:3kRMfhMv03j" resolve="ChangeSet" />
        </node>
        <node concept="2AHcQZ" id="2W$ok$XXFAW" role="2AJF6D">
          <ref role="2AI5Lk" to="mhfm:~NotNull" resolve="NotNull" />
        </node>
      </node>
      <node concept="37vLTG" id="2nH2HpRnsMP" role="3clF46">
        <property role="TrG5h" value="sourceNodeId" />
        <node concept="2AHcQZ" id="2W$ok$XXFAX" role="2AJF6D">
          <ref role="2AI5Lk" to="mhfm:~NotNull" resolve="NotNull" />
        </node>
        <node concept="3uibUv" id="2nH2HpRnsMQ" role="1tU5fm">
          <ref role="3uigEE" to="mhbf:~SNodeId" resolve="SNodeId" />
        </node>
      </node>
      <node concept="37vLTG" id="2nH2HpRnsMY" role="3clF46">
        <property role="TrG5h" value="role" />
        <node concept="2AHcQZ" id="2W$ok$XXFB1" role="2AJF6D">
          <ref role="2AI5Lk" to="mhfm:~NotNull" resolve="NotNull" />
        </node>
        <node concept="3uibUv" id="5IRXTJLPtc_" role="1tU5fm">
          <ref role="3uigEE" to="c17a:~SReferenceLink" resolve="SReferenceLink" />
        </node>
      </node>
      <node concept="37vLTG" id="2nH2HpRnsN7" role="3clF46">
        <property role="TrG5h" value="targetModelReference" />
        <node concept="2AHcQZ" id="2W$ok$XXFAY" role="2AJF6D">
          <ref role="2AI5Lk" to="mhfm:~Nullable" resolve="Nullable" />
        </node>
        <node concept="3uibUv" id="2nH2HpRnsN8" role="1tU5fm">
          <ref role="3uigEE" to="mhbf:~SModelReference" resolve="SModelReference" />
        </node>
      </node>
      <node concept="37vLTG" id="2nH2HpRnsNg" role="3clF46">
        <property role="TrG5h" value="targetNodeId" />
        <node concept="2AHcQZ" id="2W$ok$XXFAZ" role="2AJF6D">
          <ref role="2AI5Lk" to="mhfm:~Nullable" resolve="Nullable" />
        </node>
        <node concept="3uibUv" id="2nH2HpRnsNh" role="1tU5fm">
          <ref role="3uigEE" to="mhbf:~SNodeId" resolve="SNodeId" />
        </node>
      </node>
      <node concept="37vLTG" id="2nH2HpRnsNp" role="3clF46">
        <property role="TrG5h" value="resolveInfo" />
        <node concept="2AHcQZ" id="2W$ok$XXFB0" role="2AJF6D">
          <ref role="2AI5Lk" to="mhfm:~Nullable" resolve="Nullable" />
        </node>
        <node concept="17QB3L" id="2nH2HpRnsNq" role="1tU5fm" />
      </node>
    </node>
    <node concept="3clFb_" id="4TJPS00dNDU" role="jymVt">
      <property role="TrG5h" value="getRole" />
      <node concept="2AHcQZ" id="2W$ok$XXFB2" role="2AJF6D">
        <ref role="2AI5Lk" to="mhfm:~NotNull" resolve="NotNull" />
      </node>
      <node concept="17QB3L" id="4TJPS00dNDV" role="3clF45" />
      <node concept="3Tm1VV" id="4TJPS00dNDW" role="1B3o_S" />
      <node concept="3clFbS" id="4TJPS00dNDX" role="3clF47">
        <node concept="3clFbF" id="4TJPS00dNDY" role="3cqZAp">
          <node concept="2OqwBi" id="5IRXTJLPzqZ" role="3clFbG">
            <node concept="37vLTw" id="2BHiRxeuMvt" role="2Oq$k0">
              <ref role="3cqZAo" node="2nH2HpRnsMo" resolve="myRole" />
            </node>
            <node concept="liA8E" id="5IRXTJLPzO1" role="2OqNvi">
              <ref role="37wK5l" to="c17a:~SReferenceLink.getRoleName():java.lang.String" resolve="getRoleName" />
            </node>
          </node>
        </node>
      </node>
    </node>
    <node concept="3clFb_" id="42UviMIiTxr" role="jymVt">
      <property role="1EzhhJ" value="false" />
      <property role="TrG5h" value="getRoleLink" />
      <property role="od$2w" value="false" />
      <property role="DiZV1" value="false" />
      <property role="2aFKle" value="false" />
      <node concept="3clFbS" id="42UviMIiTxu" role="3clF47">
        <node concept="3clFbF" id="42UviMIiUkl" role="3cqZAp">
          <node concept="37vLTw" id="42UviMIiUkk" role="3clFbG">
            <ref role="3cqZAo" node="2nH2HpRnsMo" resolve="myRole" />
          </node>
        </node>
      </node>
      <node concept="3Tm1VV" id="42UviMIiSNr" role="1B3o_S" />
      <node concept="3uibUv" id="42UviMIiTuo" role="3clF45">
        <ref role="3uigEE" to="c17a:~SReferenceLink" resolve="SReferenceLink" />
      </node>
      <node concept="2AHcQZ" id="42UviMIiUnY" role="2AJF6D">
        <ref role="2AI5Lk" to="mhfm:~NotNull" resolve="NotNull" />
      </node>
    </node>
    <node concept="3clFb_" id="5IRXTJLQ5Bw" role="jymVt">
      <property role="1EzhhJ" value="false" />
      <property role="TrG5h" value="isAbout" />
      <property role="od$2w" value="false" />
      <property role="DiZV1" value="false" />
      <property role="2aFKle" value="false" />
      <node concept="3clFbS" id="5IRXTJLQ5Bz" role="3clF47">
        <node concept="3cpWs6" id="5IRXTJLQ8Cd" role="3cqZAp">
          <node concept="2OqwBi" id="5IRXTJLQaUV" role="3cqZAk">
            <node concept="37vLTw" id="5IRXTJLQ9NO" role="2Oq$k0">
              <ref role="3cqZAo" node="2nH2HpRnsMo" resolve="myRole" />
            </node>
            <node concept="liA8E" id="5IRXTJLQcp3" role="2OqNvi">
              <ref role="37wK5l" to="wyt6:~Object.equals(java.lang.Object):boolean" resolve="equals" />
              <node concept="37vLTw" id="5IRXTJLQdN6" role="37wK5m">
                <ref role="3cqZAo" node="5IRXTJLQ7dI" resolve="link" />
              </node>
            </node>
          </node>
        </node>
      </node>
      <node concept="3Tm1VV" id="5IRXTJLQ3XI" role="1B3o_S" />
      <node concept="10P_77" id="5IRXTJLQ5wg" role="3clF45" />
      <node concept="37vLTG" id="5IRXTJLQ7dI" role="3clF46">
        <property role="TrG5h" value="link" />
        <node concept="3uibUv" id="5IRXTJLQ7dH" role="1tU5fm">
          <ref role="3uigEE" to="c17a:~SReferenceLink" resolve="SReferenceLink" />
        </node>
      </node>
    </node>
    <node concept="3clFb_" id="4TJPS00dNE0" role="jymVt">
      <property role="TrG5h" value="getTargetModelReference" />
      <node concept="2AHcQZ" id="2W$ok$XXFB3" role="2AJF6D">
        <ref role="2AI5Lk" to="mhfm:~Nullable" resolve="Nullable" />
      </node>
      <node concept="3uibUv" id="4TJPS00dNE1" role="3clF45">
        <ref role="3uigEE" to="mhbf:~SModelReference" resolve="SModelReference" />
      </node>
      <node concept="3Tm1VV" id="4TJPS00dNE2" role="1B3o_S" />
      <node concept="3clFbS" id="4TJPS00dNE3" role="3clF47">
        <node concept="3clFbF" id="4TJPS00dNE4" role="3cqZAp">
          <node concept="37vLTw" id="2BHiRxeuWUi" role="3clFbG">
            <ref role="3cqZAo" node="2nH2HpRnsMs" resolve="myTargetModelReference" />
          </node>
        </node>
      </node>
    </node>
    <node concept="3clFb_" id="4TJPS00dNE6" role="jymVt">
      <property role="TrG5h" value="getTargetNodeId" />
      <node concept="2AHcQZ" id="2W$ok$XXFB4" role="2AJF6D">
        <ref role="2AI5Lk" to="mhfm:~Nullable" resolve="Nullable" />
      </node>
      <node concept="3uibUv" id="4TJPS00dNE7" role="3clF45">
        <ref role="3uigEE" to="mhbf:~SNodeId" resolve="SNodeId" />
      </node>
      <node concept="3Tm1VV" id="4TJPS00dNE8" role="1B3o_S" />
      <node concept="3clFbS" id="4TJPS00dNE9" role="3clF47">
        <node concept="3clFbF" id="4TJPS00dNEa" role="3cqZAp">
          <node concept="37vLTw" id="2BHiRxeuSuf" role="3clFbG">
            <ref role="3cqZAo" node="2nH2HpRnsMw" resolve="myTargetNodeId" />
          </node>
        </node>
      </node>
    </node>
    <node concept="3clFb_" id="4TJPS00dNEc" role="jymVt">
      <property role="TrG5h" value="getResolveInfo" />
      <node concept="2AHcQZ" id="2W$ok$XXFB5" role="2AJF6D">
        <ref role="2AI5Lk" to="mhfm:~Nullable" resolve="Nullable" />
      </node>
      <node concept="17QB3L" id="4TJPS00dNEd" role="3clF45" />
      <node concept="3Tm1VV" id="4TJPS00dNEe" role="1B3o_S" />
      <node concept="3clFbS" id="4TJPS00dNEf" role="3clF47">
        <node concept="3clFbF" id="4TJPS00dNEg" role="3cqZAp">
          <node concept="37vLTw" id="2BHiRxeuyJQ" role="3clFbG">
            <ref role="3cqZAo" node="2nH2HpRnsM$" resolve="myResolveInfo" />
          </node>
        </node>
      </node>
    </node>
    <node concept="3clFb_" id="2W$ok$XXFAP" role="jymVt">
      <property role="TrG5h" value="apply" />
      <node concept="3cqZAl" id="2W$ok$XXFAQ" role="3clF45" />
      <node concept="3Tm1VV" id="2W$ok$XXFAR" role="1B3o_S" />
      <node concept="37vLTG" id="2W$ok$XXFAS" role="3clF46">
        <property role="TrG5h" value="model" />
        <node concept="H_c77" id="2W$ok$XXFAT" role="1tU5fm" />
        <node concept="2AHcQZ" id="2W$ok$XXFAU" role="2AJF6D">
          <ref role="2AI5Lk" to="mhfm:~NotNull" resolve="NotNull" />
        </node>
      </node>
      <node concept="37vLTG" id="4YYMSngGbk_" role="3clF46">
        <property role="TrG5h" value="nodeCopier" />
        <node concept="3uibUv" id="4YPlf0PK8wZ" role="1tU5fm">
          <ref role="3uigEE" node="69abr3GmYnQ" resolve="NodeCopier" />
        </node>
        <node concept="2AHcQZ" id="4YYMSngGbkB" role="2AJF6D">
          <ref role="2AI5Lk" to="mhfm:~NotNull" resolve="NotNull" />
        </node>
      </node>
      <node concept="3clFbS" id="2W$ok$XXFAV" role="3clF47">
        <node concept="3cpWs8" id="2W$ok$XXFBk" role="3cqZAp">
          <node concept="3cpWsn" id="2W$ok$XXFBl" role="3cpWs9">
            <property role="TrG5h" value="node" />
            <node concept="2OqwBi" id="2n9zn0CqMD6" role="33vP2m">
              <node concept="liA8E" id="2n9zn0CqMD7" role="2OqNvi">
                <ref role="37wK5l" to="mhbf:~SModel.getNode(org.jetbrains.mps.openapi.model.SNodeId):org.jetbrains.mps.openapi.model.SNode" resolve="getNode" />
                <node concept="1rXfSq" id="4hiugqyzb7M" role="37wK5m">
                  <ref role="37wK5l" node="4W7A6jbeACU" resolve="getAffectedNodeId" />
                </node>
              </node>
              <node concept="2JrnkZ" id="2n9zn0CqMD9" role="2Oq$k0">
                <node concept="37vLTw" id="2BHiRxgmkHp" role="2JrQYb">
                  <ref role="3cqZAo" node="2W$ok$XXFAS" resolve="model" />
                </node>
              </node>
            </node>
            <node concept="3uibUv" id="2W$ok$XXFBm" role="1tU5fm">
              <ref role="3uigEE" to="mhbf:~SNode" resolve="SNode" />
            </node>
          </node>
        </node>
        <node concept="1gVbGN" id="2W$ok$XXFBt" role="3cqZAp">
          <node concept="3y3z36" id="2W$ok$XXFBw" role="1gVkn0">
            <node concept="10Nm6u" id="2W$ok$XXFBz" role="3uHU7w" />
            <node concept="37vLTw" id="3GM_nagTwXs" role="3uHU7B">
              <ref role="3cqZAo" node="2W$ok$XXFBl" resolve="node" />
            </node>
          </node>
        </node>
        <node concept="3clFbJ" id="2W$ok$XXFBJ" role="3cqZAp">
          <node concept="3clFbS" id="2W$ok$XXFBK" role="3clFbx">
            <node concept="3clFbF" id="2W$ok$XXFCf" role="3cqZAp">
              <node concept="2OqwBi" id="2W$ok$XXFCh" role="3clFbG">
                <node concept="37vLTw" id="3GM_nagTs8s" role="2Oq$k0">
                  <ref role="3cqZAo" node="2W$ok$XXFBl" resolve="node" />
                </node>
                <node concept="liA8E" id="2iSpZqBbCjo" role="2OqNvi">
                  <ref role="37wK5l" to="mhbf:~SNode.setReferenceTarget(org.jetbrains.mps.openapi.language.SReferenceLink,org.jetbrains.mps.openapi.model.SNode):void" resolve="setReferenceTarget" />
                  <node concept="37vLTw" id="2BHiRxeuPHu" role="37wK5m">
                    <ref role="3cqZAo" node="2nH2HpRnsMo" resolve="myRole" />
                  </node>
                  <node concept="10Nm6u" id="2iSpZqBbCjq" role="37wK5m" />
                </node>
              </node>
            </node>
          </node>
          <node concept="1Wc70l" id="2W$ok$XXFC7" role="3clFbw">
            <node concept="3clFbC" id="2W$ok$XXFCb" role="3uHU7w">
              <node concept="10Nm6u" id="2W$ok$XXFCe" role="3uHU7w" />
              <node concept="37vLTw" id="2BHiRxeujQ6" role="3uHU7B">
                <ref role="3cqZAo" node="2nH2HpRnsM$" resolve="myResolveInfo" />
              </node>
            </node>
            <node concept="3clFbC" id="2W$ok$XXFC3" role="3uHU7B">
              <node concept="37vLTw" id="2BHiRxeuNY2" role="3uHU7B">
                <ref role="3cqZAo" node="2nH2HpRnsMw" resolve="myTargetNodeId" />
              </node>
              <node concept="10Nm6u" id="2W$ok$XXFC6" role="3uHU7w" />
            </node>
          </node>
          <node concept="9aQIb" id="2W$ok$XXFCu" role="9aQIa">
            <node concept="3clFbS" id="2W$ok$XXFCv" role="9aQI4">
              <node concept="3cpWs8" id="2W$ok$XXFCX" role="3cqZAp">
                <node concept="3cpWsn" id="2W$ok$XXFCY" role="3cpWs9">
                  <property role="TrG5h" value="targetModelReference" />
                  <node concept="3uibUv" id="2W$ok$XXFCZ" role="1tU5fm">
                    <ref role="3uigEE" to="mhbf:~SModelReference" resolve="SModelReference" />
                  </node>
                  <node concept="3K4zz7" id="2W$ok$XXFD0" role="33vP2m">
                    <node concept="2OqwBi" id="2n9zn0CqN2H" role="3K4E3e">
                      <node concept="liA8E" id="2n9zn0CqN2I" role="2OqNvi">
                        <ref role="37wK5l" to="mhbf:~SModel.getReference():org.jetbrains.mps.openapi.model.SModelReference" resolve="getReference" />
                      </node>
                      <node concept="2JrnkZ" id="2n9zn0CqN2J" role="2Oq$k0">
                        <node concept="37vLTw" id="2BHiRxgm6GN" role="2JrQYb">
                          <ref role="3cqZAo" node="2W$ok$XXFAS" resolve="model" />
                        </node>
                      </node>
                    </node>
                    <node concept="37vLTw" id="2BHiRxeuW3w" role="3K4GZi">
                      <ref role="3cqZAo" node="2nH2HpRnsMs" resolve="myTargetModelReference" />
                    </node>
                    <node concept="3clFbC" id="2W$ok$XXFD6" role="3K4Cdx">
                      <node concept="10Nm6u" id="2W$ok$XXFD7" role="3uHU7w" />
                      <node concept="37vLTw" id="2BHiRxeuoOX" role="3uHU7B">
                        <ref role="3cqZAo" node="2nH2HpRnsMs" resolve="myTargetModelReference" />
                      </node>
                    </node>
                  </node>
                </node>
              </node>
              <node concept="3cpWs8" id="2W$ok$XXFDc" role="3cqZAp">
                <node concept="3cpWsn" id="2W$ok$XXFDd" role="3cpWs9">
                  <property role="TrG5h" value="reference" />
                  <node concept="3uibUv" id="2W$ok$XXFDe" role="1tU5fm">
                    <ref role="3uigEE" to="mhbf:~SReference" resolve="SReference" />
                  </node>
                </node>
              </node>
              <node concept="3clFbJ" id="2p9HAeNSoqp" role="3cqZAp">
                <node concept="3clFbC" id="2p9HAeNSoqx" role="3clFbw">
                  <node concept="10Nm6u" id="2p9HAeNSoq$" role="3uHU7w" />
                  <node concept="37vLTw" id="2BHiRxeug4Z" role="3uHU7B">
                    <ref role="3cqZAo" node="2nH2HpRnsMw" resolve="myTargetNodeId" />
                  </node>
                </node>
                <node concept="3clFbS" id="2p9HAeNSoqq" role="3clFbx">
                  <node concept="3clFbF" id="2p9HAeNSoq_" role="3cqZAp">
                    <node concept="37vLTI" id="2p9HAeNSoqB" role="3clFbG">
                      <node concept="37vLTw" id="3GM_nagTBr5" role="37vLTJ">
                        <ref role="3cqZAo" node="2W$ok$XXFDd" resolve="reference" />
                      </node>
                      <node concept="2ShNRf" id="2p9HAeNSoqE" role="37vLTx">
                        <node concept="1pGfFk" id="2p9HAeNSoqF" role="2ShVmc">
                          <ref role="37wK5l" to="w1kc:~DynamicReference.&lt;init&gt;(org.jetbrains.mps.openapi.language.SReferenceLink,org.jetbrains.mps.openapi.model.SNode,org.jetbrains.mps.openapi.model.SModelReference,java.lang.String)" resolve="DynamicReference" />
                          <node concept="37vLTw" id="2BHiRxeuv12" role="37wK5m">
                            <ref role="3cqZAo" node="2nH2HpRnsMo" resolve="myRole" />
                          </node>
                          <node concept="37vLTw" id="3GM_nagTv2P" role="37wK5m">
                            <ref role="3cqZAo" node="2W$ok$XXFBl" resolve="node" />
                          </node>
                          <node concept="37vLTw" id="3GM_nagTwms" role="37wK5m">
                            <ref role="3cqZAo" node="2W$ok$XXFCY" resolve="targetModelReference" />
                          </node>
                          <node concept="37vLTw" id="2BHiRxeuDZf" role="37wK5m">
                            <ref role="3cqZAo" node="2nH2HpRnsM$" resolve="myResolveInfo" />
                          </node>
                        </node>
                      </node>
                    </node>
                  </node>
                </node>
                <node concept="9aQIb" id="2p9HAeNSoqL" role="9aQIa">
                  <node concept="3clFbS" id="2p9HAeNSoqM" role="9aQI4">
                    <node concept="3clFbF" id="2p9HAeNSoqu" role="3cqZAp">
                      <node concept="37vLTI" id="2p9HAeNSoqv" role="3clFbG">
                        <node concept="2ShNRf" id="2W$ok$XXFDg" role="37vLTx">
                          <node concept="1pGfFk" id="2W$ok$XXFDi" role="2ShVmc">
                            <ref role="37wK5l" to="w1kc:~StaticReference.&lt;init&gt;(org.jetbrains.mps.openapi.language.SReferenceLink,org.jetbrains.mps.openapi.model.SNode,org.jetbrains.mps.openapi.model.SModelReference,org.jetbrains.mps.openapi.model.SNodeId,java.lang.String)" resolve="StaticReference" />
                            <node concept="37vLTw" id="2BHiRxeuW2P" role="37wK5m">
                              <ref role="3cqZAo" node="2nH2HpRnsMo" resolve="myRole" />
                            </node>
                            <node concept="37vLTw" id="3GM_nagTtXY" role="37wK5m">
                              <ref role="3cqZAo" node="2W$ok$XXFBl" resolve="node" />
                            </node>
                            <node concept="37vLTw" id="3GM_nagTyeH" role="37wK5m">
                              <ref role="3cqZAo" node="2W$ok$XXFCY" resolve="targetModelReference" />
                            </node>
                            <node concept="37vLTw" id="2BHiRxeuoNk" role="37wK5m">
                              <ref role="3cqZAo" node="2nH2HpRnsMw" resolve="myTargetNodeId" />
                            </node>
                            <node concept="37vLTw" id="2BHiRxeuyU7" role="37wK5m">
                              <ref role="3cqZAo" node="2nH2HpRnsM$" resolve="myResolveInfo" />
                            </node>
                          </node>
                        </node>
                        <node concept="37vLTw" id="3GM_nagT$Io" role="37vLTJ">
                          <ref role="3cqZAo" node="2W$ok$XXFDd" resolve="reference" />
                        </node>
                      </node>
                    </node>
                  </node>
                </node>
              </node>
              <node concept="3clFbF" id="2W$ok$XXFDt" role="3cqZAp">
                <node concept="2OqwBi" id="2iSpZqBbCjQ" role="3clFbG">
                  <node concept="liA8E" id="2iSpZqBbCjS" role="2OqNvi">
                    <ref role="37wK5l" to="mhbf:~SNode.setReferenceTarget(org.jetbrains.mps.openapi.language.SReferenceLink,org.jetbrains.mps.openapi.model.SNode):void" resolve="setReferenceTarget" />
                    <node concept="37vLTw" id="2BHiRxeurrb" role="37wK5m">
                      <ref role="3cqZAo" node="2nH2HpRnsMo" resolve="myRole" />
                    </node>
                    <node concept="10Nm6u" id="2iSpZqBbCjU" role="37wK5m" />
                  </node>
                  <node concept="37vLTw" id="3GM_nagTtwM" role="2Oq$k0">
                    <ref role="3cqZAo" node="2W$ok$XXFBl" resolve="node" />
                  </node>
                </node>
              </node>
              <node concept="3clFbF" id="2W$ok$XXFDA" role="3cqZAp">
                <node concept="2OqwBi" id="2Z5EMGU0xHr" role="3clFbG">
                  <node concept="37vLTw" id="3GM_nagTrrA" role="2Oq$k0">
                    <ref role="3cqZAo" node="2W$ok$XXFBl" resolve="node" />
                  </node>
                  <node concept="liA8E" id="2Z5EMGU0xHt" role="2OqNvi">
                    <ref role="37wK5l" to="mhbf:~SNode.setReference(org.jetbrains.mps.openapi.language.SReferenceLink,org.jetbrains.mps.openapi.model.SReference):void" resolve="setReference" />
                    <node concept="37vLTw" id="5IRXTJLPA6J" role="37wK5m">
